-- MySQL dump 10.13  Distrib 8.0.25, for Win64 (x86_64)
--
-- Host: 127.0.0.1    Database: iboot
-- ------------------------------------------------------
-- Server version	8.0.34-0ubuntu0.20.04.1

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!50503 SET NAMES utf8mb4 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `iot_collect_data`
--

DROP TABLE IF EXISTS `iot_collect_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `iot_collect_data` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `cid` bigint NOT NULL COMMENT '任务执行标识',
  `uid` bigint DEFAULT NULL COMMENT '设备uid',
  `signal_id` bigint NOT NULL COMMENT '信号id',
  `field_type` tinyint DEFAULT NULL COMMENT '数据类型',
  `collect_task_id` bigint NOT NULL COMMENT '任务id',
  `address` varchar(128) DEFAULT NULL COMMENT '信号地址',
  `value` varchar(256) DEFAULT NULL COMMENT '值',
  `status` tinyint(1) NOT NULL DEFAULT '0' COMMENT '采集状态',
  `reason` varchar(64) NOT NULL DEFAULT '' COMMENT '错误说明',
  `collect_time` datetime NOT NULL COMMENT '采集时间',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  PRIMARY KEY (`id`),
  KEY `iot_collect_data_cid_index` (`cid` DESC),
  KEY `iot_collect_data_collect_time_index` (`collect_time` DESC),
  KEY `iot_collect_data_signal_id_index` (`signal_id`),
  KEY `iot_collect_data_uid_index` (`uid` DESC)
) ENGINE=InnoDB AUTO_INCREMENT=565 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='采集到的数据';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `iot_collect_data`
--

LOCK TABLES `iot_collect_data` WRITE;
/*!40000 ALTER TABLE `iot_collect_data` DISABLE KEYS */;
/*!40000 ALTER TABLE `iot_collect_data` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `iot_collect_detail`
--

DROP TABLE IF EXISTS `iot_collect_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `iot_collect_detail` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `uid` bigint NOT NULL COMMENT '设备uid',
  `child_sn` varchar(64) DEFAULT NULL COMMENT '子设备编号',
  `extend` varchar(512) DEFAULT NULL COMMENT '扩展字段',
  `store_uid` bigint DEFAULT NULL COMMENT '存储设备uid',
  `store_action` varchar(36) DEFAULT NULL COMMENT '存储动作',
  `collect_action` varchar(36) DEFAULT NULL COMMENT '采集动作',
  `point_group_id` bigint NOT NULL COMMENT '点位组',
  `collect_task_id` bigint NOT NULL COMMENT '采集任务id',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  PRIMARY KEY (`id`),
  KEY `iot_collect_detail_collect_task_id_index` (`collect_task_id`),
  KEY `iot_collect_detail_point_group_id_index` (`point_group_id`),
  KEY `iot_collect_detail_uid_index` (`uid`),
  KEY `iot_collect_detail_child_sn_index` (`child_sn`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='采集明细';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `iot_collect_detail`
--

LOCK TABLES `iot_collect_detail` WRITE;
/*!40000 ALTER TABLE `iot_collect_detail` DISABLE KEYS */;
INSERT INTO `iot_collect_detail` VALUES (1,1582605843000504300,'01',NULL,NULL,'STORE:RDBMS','MODBUS:DTU:TCP',6,1,'2022-10-30 09:47:24'),(2,1646147083234230300,'1','{}',NULL,'STORE:RDBMS','CLIENT:MODBUS:RTU',7,3,'2023-04-14 22:45:39');
/*!40000 ALTER TABLE `iot_collect_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `iot_collect_task`
--

DROP TABLE IF EXISTS `iot_collect_task`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `iot_collect_task` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `name` varchar(64) NOT NULL COMMENT '任务名称',
  `cron` varchar(32) NOT NULL COMMENT '任务调度',
  `status` char(12) NOT NULL DEFAULT 'stop' COMMENT '任务状态(start, stop, fail)',
  `remark` varchar(128) NOT NULL DEFAULT '' COMMENT '采集任务说明',
  `reason` varchar(128) NOT NULL DEFAULT '' COMMENT '任务失败的原因',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` timestamp NULL DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`),
  UNIQUE KEY `iot_collect_task_name_uindex` (`name`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='数据采集任务';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `iot_collect_task`
--

LOCK TABLES `iot_collect_task` WRITE;
/*!40000 ALTER TABLE `iot_collect_task` DISABLE KEYS */;
INSERT INTO `iot_collect_task` VALUES (1,'plc采集','0/30 * * * * ?','stop','S71200设备采集任务','','2022-08-28 15:29:51','2023-08-17 09:44:54'),(3,'modbus测试','0/30 * * * * ?','stop','用于测试modbus设备协议的数据采集','','2023-04-14 22:41:34','2023-04-15 00:19:57');
/*!40000 ALTER TABLE `iot_collect_task` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `iot_device`
--

DROP TABLE IF EXISTS `iot_device`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `iot_device` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `uid` bigint NOT NULL COMMENT '设备唯一的uid',
  `name` varchar(64) NOT NULL COMMENT '设备名称',
  `lon` varchar(24) DEFAULT NULL COMMENT '经度',
  `lat` varchar(24) DEFAULT NULL COMMENT '纬度',
  `ip` varchar(32) DEFAULT NULL COMMENT '设备ip',
  `port` int DEFAULT NULL COMMENT '设备端口',
  `model` int DEFAULT NULL COMMENT '设备型号',
  `status` enum('online','offline') NOT NULL DEFAULT 'offline' COMMENT '设备状态',
  `user_id` bigint DEFAULT NULL COMMENT '所属会员',
  `address` varchar(64) DEFAULT NULL COMMENT '地址',
  `extend` varchar(36) NOT NULL DEFAULT '' COMMENT '拓展字段',
  `account` varchar(64) DEFAULT NULL COMMENT '账号',
  `password` varchar(64) DEFAULT NULL COMMENT '密码',
  `device_sn` varchar(64) NOT NULL COMMENT '设备编号',
  `switch_time` timestamp NULL DEFAULT NULL COMMENT '设备状态切换时间',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` timestamp NULL DEFAULT NULL COMMENT '更新时间',
  `device_type_id` bigint NOT NULL COMMENT '设备所属类型',
  PRIMARY KEY (`id`),
  UNIQUE KEY `iot_device_uid_uindex` (`uid`),
  KEY `iot_device_create_time_index` (`create_time` DESC)
) ENGINE=InnoDB AUTO_INCREMENT=21 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='设备表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `iot_device`
--

LOCK TABLES `iot_device` WRITE;
/*!40000 ALTER TABLE `iot_device` DISABLE KEYS */;
INSERT INTO `iot_device` VALUES (5,1550801539290628000,'欧姆龙PLC',NULL,NULL,'172.16.30.1',9600,7,'offline',NULL,NULL,'',NULL,NULL,'omron001','2023-09-07 01:42:08','2022-07-23 19:14:34',NULL,3),(6,1555798233911939000,'RTU协议测试',NULL,NULL,NULL,NULL,10,'offline',NULL,NULL,'',NULL,NULL,'RTU_IOT_MODBUS_01','2023-09-07 01:42:08','2022-08-06 14:09:38',NULL,8),(8,1559835702382841900,'DTU模拟设测试',NULL,NULL,NULL,NULL,19,'offline',NULL,NULL,'',NULL,NULL,'100000000003','2023-09-07 01:42:08','2022-08-17 17:33:06',NULL,10),(16,1582605843000504300,'温湿度测试',NULL,NULL,NULL,NULL,9,'offline',NULL,NULL,'',NULL,NULL,'45332450','2023-09-07 01:42:08','2022-10-19 13:33:31',NULL,9),(19,1642094499355742200,'电流采集',NULL,NULL,'127.0.0.1',502,20,'offline',NULL,NULL,'',NULL,NULL,'MODBUS:CLIENT:01','2023-09-07 01:42:08','2023-04-01 17:20:11',NULL,23),(20,1646147083234230300,'test',NULL,NULL,NULL,NULL,21,'offline',NULL,NULL,'',NULL,NULL,'COM2','2023-09-07 01:42:08','2023-04-12 21:43:43',NULL,24);
/*!40000 ALTER TABLE `iot_device` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `iot_device_child`
--

DROP TABLE IF EXISTS `iot_device_child`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `iot_device_child` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `name` varchar(64) NOT NULL COMMENT '子设备名称',
  `uid` bigint NOT NULL COMMENT '设备uid',
  `remark` varchar(256) DEFAULT NULL COMMENT '备注',
  `child_sn` varchar(64) NOT NULL COMMENT '子设备编号',
  `protocol_type` smallint DEFAULT NULL COMMENT '协议类型',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  KEY `iot_device_child_child_sn_index` (`child_sn`),
  KEY `iot_device_child_uid_index` (`uid`)
) ENGINE=InnoDB AUTO_INCREMENT=15 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='子设备';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `iot_device_child`
--

LOCK TABLES `iot_device_child` WRITE;
/*!40000 ALTER TABLE `iot_device_child` DISABLE KEYS */;
INSERT INTO `iot_device_child` VALUES (1,'继电器',1537990013924249600,'用于控制设备开关状态','1',1,'2022-06-18 10:48:32'),(2,'温湿度传感器',1555798233911939000,'用于采集环境的温湿度数据','1',1,'2022-08-06 14:10:05'),(4,'电表',1559835702382841900,'电表设备','1',NULL,'2022-08-18 14:12:28'),(5,'电表2',1559835702382841900,NULL,'0003',NULL,'2022-08-24 17:05:47'),(6,'从机1',1565594612523905000,NULL,'1',NULL,'2022-09-02 15:02:34'),(7,'343',1569960474991177700,NULL,'1',NULL,'2022-09-14 16:05:29'),(8,'rtutest001',1567785941169385500,NULL,'rtutest001',NULL,'2022-09-19 10:44:53'),(9,'wendu',1579858029321433000,NULL,'01',NULL,'2022-10-11 23:34:58'),(10,'shidu',1579858029321433000,NULL,'02',NULL,'2022-10-11 23:35:06'),(11,'2',1565594612523905000,NULL,'2',NULL,'2022-10-13 17:15:11'),(12,'温湿度',1582605843000504300,NULL,'01',NULL,'2022-10-19 13:33:56'),(13,'设备1',1642094499355742200,'从设备1','1',NULL,'2023-04-02 15:24:00'),(14,'子设备1',1646147083234230300,NULL,'1',NULL,'2023-04-13 07:43:12');
/*!40000 ALTER TABLE `iot_device_child` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `iot_device_model`
--

DROP TABLE IF EXISTS `iot_device_model`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `iot_device_model` (
  `id` int NOT NULL AUTO_INCREMENT,
  `type_id` int NOT NULL COMMENT '设备类型id',
  `model` varchar(36) DEFAULT NULL COMMENT '型号',
  `remark` varchar(128) DEFAULT NULL COMMENT '型号说明',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=22 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='设备型号';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `iot_device_model`
--

LOCK TABLES `iot_device_model` WRITE;
/*!40000 ALTER TABLE `iot_device_model` DISABLE KEYS */;
INSERT INTO `iot_device_model` VALUES (1,2,'S200',NULL),(2,2,'S300',NULL),(3,2,'S400',NULL),(4,2,'S1200',NULL),(5,2,'S1500',NULL),(6,2,'S200Smart',NULL),(7,3,'omron',NULL),(9,9,'温湿度传感器','温湿度采集'),(10,8,'继电器8bits','8路状态继电器'),(11,13,'modbus_rtu','modbus_rtu_test'),(13,15,'Photo','1'),(17,20,'1234','12354'),(19,10,'通用型号','dtu通用设备'),(20,23,'STD:ModbusClient','基于标准modbus tcp协议的设备'),(21,24,'STD:ModbusRtu','基于标准Modbus Rtu协议的设备');
/*!40000 ALTER TABLE `iot_device_model` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `iot_device_type`
--

DROP TABLE IF EXISTS `iot_device_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `iot_device_type` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `pid` bigint NOT NULL DEFAULT '0' COMMENT '父id',
  `path` varchar(128) DEFAULT NULL COMMENT '路径',
  `name` varchar(64) NOT NULL COMMENT '类型名称',
  `alias` varchar(36) DEFAULT NULL COMMENT '类型别名',
  `image` varchar(128) DEFAULT NULL COMMENT '类型图地址',
  `remark` varchar(256) DEFAULT NULL COMMENT '类型说明',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  KEY `iot_device_type_alias_index` (`alias`)
) ENGINE=InnoDB AUTO_INCREMENT=25 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='设备类型';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `iot_device_type`
--

LOCK TABLES `iot_device_type` WRITE;
/*!40000 ALTER TABLE `iot_device_type` DISABLE KEYS */;
INSERT INTO `iot_device_type` VALUES (1,5,'5,1','plc','PLC',NULL,'plc设备','2022-05-15 22:04:02'),(2,1,'5,1,2','西门子','PLC',NULL,'西门子','2022-05-15 22:08:08'),(3,1,'5,1,3','欧姆龙','PLC',NULL,'欧姆龙','2022-05-15 22:09:24'),(4,5,'5,4','dtu','DTU',NULL,'数据传输单元(用于串口转互联网)','2022-06-04 14:07:42'),(5,0,'5','工业物联网',NULL,NULL,'用于工业物联网平台设备的管理','2022-06-12 13:10:58'),(8,4,'5,4,8','DTU+ModbusRtu','DTU',NULL,'用于支持dtu操作modbus rtu设备','2022-08-18 12:29:37'),(9,4,'5,4,9','DTU+ModbusTcp','DTU',NULL,'用于支持dtu操作modbus tcp设备','2022-08-18 12:30:19'),(10,4,'5,4,10','DTU+通用协议','DTU',NULL,'用于支持dtu操作其他协议的设备','2022-08-18 12:31:18'),(11,0,'11','智能家居',NULL,NULL,'用于智能家居平台设备的管理','2022-08-27 12:33:02'),(13,5,'5,13','modbus','MODBUS',NULL,'基于modbus的客户端实现','2022-09-02 10:13:12'),(23,13,'5,13,23','ModbusTcp','MODBUS',NULL,'基于modbus_tcp协议的主机','2022-11-01 16:14:08'),(24,13,'5,13,24','ModbusRtu','MODBUS',NULL,'基于modbus_rtu协议的主机','2022-11-01 16:15:12');
/*!40000 ALTER TABLE `iot_device_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `iot_group_point`
--

DROP TABLE IF EXISTS `iot_group_point`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `iot_group_point` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `signal_id` bigint NOT NULL COMMENT '所属点位',
  `group_id` bigint NOT NULL COMMENT '所属点位组',
  PRIMARY KEY (`id`),
  UNIQUE KEY `iot_group_point_group_id_signal_id_uindex` (`group_id`,`signal_id`),
  KEY `iot_group_point_group_id_index` (`group_id`),
  KEY `iot_group_point_point_id_index` (`signal_id`)
) ENGINE=InnoDB AUTO_INCREMENT=33 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='组点位';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `iot_group_point`
--

LOCK TABLES `iot_group_point` WRITE;
/*!40000 ALTER TABLE `iot_group_point` DISABLE KEYS */;
INSERT INTO `iot_group_point` VALUES (15,1,1),(16,2,1),(27,2,2),(23,3,3),(12,3,4),(24,1,5),(25,2,5),(26,6,5),(30,9,6),(29,10,6),(31,11,7),(32,12,7);
/*!40000 ALTER TABLE `iot_group_point` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `iot_point_group`
--

DROP TABLE IF EXISTS `iot_point_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `iot_point_group` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `name` varchar(36) NOT NULL COMMENT '组名称',
  `model_id` int NOT NULL COMMENT '所属型号',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  KEY `iot_point_group_create_time_index` (`create_time` DESC)
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='点位组';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `iot_point_group`
--

LOCK TABLES `iot_point_group` WRITE;
/*!40000 ALTER TABLE `iot_point_group` DISABLE KEYS */;
INSERT INTO `iot_point_group` VALUES (2,'13',1,'2022-08-14 21:13:23'),(3,'继电器控制',10,'2022-08-27 14:59:40'),(4,'modbus_tcp',10,'2022-09-02 14:26:59'),(6,'温湿度组',9,'2022-10-30 18:44:35'),(7,'温湿度',21,'2023-04-14 22:44:21');
/*!40000 ALTER TABLE `iot_point_group` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `iot_product`
--

DROP TABLE IF EXISTS `iot_product`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `iot_product` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `pid` bigint NOT NULL DEFAULT '0' COMMENT '父id',
  `path` varchar(128) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '产品id路径',
  `name` varchar(64) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '产品名称',
  `remark` varchar(512) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL COMMENT '产品说明',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci COMMENT='设备产品';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `iot_product`
--

LOCK TABLES `iot_product` WRITE;
/*!40000 ALTER TABLE `iot_product` DISABLE KEYS */;
/*!40000 ALTER TABLE `iot_product` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `iot_serial`
--

DROP TABLE IF EXISTS `iot_serial`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `iot_serial` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `name` varchar(64) NOT NULL COMMENT '设备名称',
  `com` char(8) NOT NULL COMMENT '串口',
  `baud_rate` int NOT NULL DEFAULT '9600' COMMENT '波特率',
  `data_bits` int NOT NULL DEFAULT '8' COMMENT '数据位',
  `parity` int DEFAULT '0' COMMENT '校验位',
  `stop_bits` int DEFAULT '1' COMMENT '停止位',
  `status` char(8) NOT NULL DEFAULT 'close' COMMENT '状态',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='串口设备';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `iot_serial`
--

LOCK TABLES `iot_serial` WRITE;
/*!40000 ALTER TABLE `iot_serial` DISABLE KEYS */;
INSERT INTO `iot_serial` VALUES (1,'测试','COM2',9600,8,0,1,'close','2023-04-12 12:52:27');
/*!40000 ALTER TABLE `iot_serial` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `iot_signal`
--

DROP TABLE IF EXISTS `iot_signal`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `iot_signal` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `name` varchar(64) NOT NULL COMMENT '点位名称',
  `address` varchar(16) NOT NULL DEFAULT '' COMMENT '点位地址',
  `message` varchar(256) DEFAULT NULL COMMENT '自定义报文',
  `type` tinyint DEFAULT NULL COMMENT '1. 点位 2. 自定义',
  `num` tinyint DEFAULT '0' COMMENT '读取的数量',
  `model_id` int NOT NULL COMMENT '型号id',
  `encode` char(8) DEFAULT NULL COMMENT '自定义报文编码(HEX,UTF8,ASCII)',
  `field_name` varchar(32) NOT NULL COMMENT '点位字段名称',
  `field_type` tinyint DEFAULT NULL COMMENT '字段类型(int、float、...)',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=13 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='寄存器点位';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `iot_signal`
--

LOCK TABLES `iot_signal` WRITE;
/*!40000 ALTER TABLE `iot_signal` DISABLE KEYS */;
INSERT INTO `iot_signal` VALUES (1,'电压值','100','',1,0,1,NULL,'voltage',3,'2022-07-28 17:42:35',NULL),(2,'电流值','102','',1,0,1,NULL,'current',3,'2022-08-16 21:48:24',NULL),(3,'继电器状态','1','',1,0,10,NULL,'status',7,'2022-08-27 14:57:25',NULL),(4,'测试1','2','',1,0,10,NULL,'22',1,'2022-09-08 15:10:11',NULL),(6,'开关','Q100','',1,0,4,NULL,'kaiguan',5,'2022-09-12 18:37:59',NULL),(8,'TEST','','345779348948983495',2,0,19,'HEX','TEST',NULL,'2022-10-29 20:09:24',NULL),(9,'温度','100',NULL,1,0,9,'HEX','temp',5,'2022-10-30 18:43:18',NULL),(10,'湿度','101',NULL,1,0,9,'HEX','humidity',5,'2022-10-30 18:45:49',NULL),(11,'温度','0',NULL,1,0,21,'HEX','temp',3,'2023-04-14 22:42:50',NULL),(12,'适度','3',NULL,1,0,21,'HEX','shidu',3,'2023-04-14 22:43:25',NULL);
/*!40000 ALTER TABLE `iot_signal` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oauth2_app`
--

DROP TABLE IF EXISTS `oauth2_app`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `oauth2_app` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `client_id` varchar(64) NOT NULL COMMENT '应用标识',
  `client_secret` varchar(64) DEFAULT NULL COMMENT '应用密钥',
  `contract_scope` varchar(128) DEFAULT NULL COMMENT '应用签约权限(逗号隔开)',
  `allow_url` varchar(512) DEFAULT NULL COMMENT '允许授权的url(多个用逗号隔开)',
  `client_name` varchar(64) DEFAULT NULL COMMENT '应用名称',
  `access_token_timeout` bigint DEFAULT NULL COMMENT 'access_token保存的时间(秒)',
  `refresh_token_timeout` bigint DEFAULT NULL COMMENT 'refresh-token保存的时间(秒)',
  `client_token_timeout` bigint DEFAULT NULL COMMENT 'client-token保存的时间(秒)',
  `past_token_timeout` bigint DEFAULT NULL COMMENT 'past-client-token保存的时间(秒)',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='oauth2应用';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oauth2_app`
--

LOCK TABLES `oauth2_app` WRITE;
/*!40000 ALTER TABLE `oauth2_app` DISABLE KEYS */;
/*!40000 ALTER TABLE `oauth2_app` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oauth2_client_user`
--

DROP TABLE IF EXISTS `oauth2_client_user`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `oauth2_client_user` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `type` varchar(16) NOT NULL COMMENT '第三方类型',
  `user_id` bigint DEFAULT NULL COMMENT '关联的用户/会员',
  `user_type` varchar(16) DEFAULT NULL COMMENT '用户类型(sys、vip)',
  `openid` varchar(64) NOT NULL COMMENT '第三方openid',
  `nickname` varchar(64) DEFAULT NULL COMMENT '昵称',
  `avatar_url` varchar(128) DEFAULT NULL COMMENT '头像地址',
  `create_time` datetime DEFAULT CURRENT_TIMESTAMP COMMENT '绑定时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='第三方用户';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oauth2_client_user`
--

LOCK TABLES `oauth2_client_user` WRITE;
/*!40000 ALTER TABLE `oauth2_client_user` DISABLE KEYS */;
/*!40000 ALTER TABLE `oauth2_client_user` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oauth2_user`
--

DROP TABLE IF EXISTS `oauth2_user`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `oauth2_user` (
  `id` bigint DEFAULT NULL COMMENT '用户id',
  `login_id` varchar(32) NOT NULL COMMENT '用户标识',
  `client_id` varchar(64) DEFAULT NULL COMMENT '所属应用',
  `openid` varchar(64) DEFAULT NULL COMMENT '用户openid',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='用户表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oauth2_user`
--

LOCK TABLES `oauth2_user` WRITE;
/*!40000 ALTER TABLE `oauth2_user` DISABLE KEYS */;
/*!40000 ALTER TABLE `oauth2_user` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `qrtz_job_task`
--

DROP TABLE IF EXISTS `qrtz_job_task`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `qrtz_job_task` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `name` varchar(128) NOT NULL COMMENT '任务名称',
  `cron` varchar(64) DEFAULT NULL COMMENT 'cron表达式',
  `status` char(24) DEFAULT NULL COMMENT '作业状态',
  `remark` varchar(256) NOT NULL DEFAULT '' COMMENT '备注',
  `params` varchar(512) DEFAULT '' COMMENT '执行参数',
  `method` varchar(128) NOT NULL COMMENT '要调用的方法',
  `job_name` varchar(128) NOT NULL COMMENT '作业名称',
  `concurrent` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否并发',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` timestamp NULL DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`),
  UNIQUE KEY `qrtz_job_task_job_name_uindex` (`job_name`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='作业任务';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `qrtz_job_task`
--

LOCK TABLES `qrtz_job_task` WRITE;
/*!40000 ALTER TABLE `qrtz_job_task` DISABLE KEYS */;
/*!40000 ALTER TABLE `qrtz_job_task` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_access_log`
--

DROP TABLE IF EXISTS `sys_access_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_access_log` (
  `id` bigint NOT NULL AUTO_INCREMENT COMMENT '日志主键',
  `url` varchar(255) DEFAULT '' COMMENT '请求URL',
  `ip` varchar(50) DEFAULT '' COMMENT '主机地址',
  `msn` varchar(32) NOT NULL DEFAULT '' COMMENT '所属模块',
  `title` varchar(64) NOT NULL DEFAULT '' COMMENT '日志标题',
  `type` varchar(16) NOT NULL DEFAULT '' COMMENT '功能类型',
  `millis` int DEFAULT NULL COMMENT '操作毫秒数',
  `user_id` bigint DEFAULT '0' COMMENT '操作人员',
  `params` varchar(256) DEFAULT NULL COMMENT '接口参数',
  `method` varchar(64) DEFAULT NULL COMMENT '接口方法',
  `user_name` varchar(50) DEFAULT '' COMMENT '操作人员',
  `status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '操作状态',
  `err_msg` varchar(512) NOT NULL DEFAULT '' COMMENT '异常消息',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '操作时间',
  `update_time` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=15943 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='操作日志记录';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_access_log`
--

LOCK TABLES `sys_access_log` WRITE;
/*!40000 ALTER TABLE `sys_access_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `sys_access_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_admin`
--

DROP TABLE IF EXISTS `sys_admin`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_admin` (
  `id` bigint NOT NULL AUTO_INCREMENT COMMENT '用户ID',
  `org_id` bigint DEFAULT NULL COMMENT '部门ID',
  `post_id` bigint NOT NULL COMMENT '所属岗位',
  `account` char(24) NOT NULL COMMENT '登录账号',
  `name` varchar(30) NOT NULL COMMENT '用户名称',
  `email` varchar(50) DEFAULT '' COMMENT '用户邮箱',
  `phone` varchar(11) DEFAULT '' COMMENT '手机号码',
  `sex` tinyint NOT NULL DEFAULT '3' COMMENT '用户性别（1男 2女 3保密）',
  `avatar` varchar(100) DEFAULT '' COMMENT '头像路径',
  `password` varchar(50) DEFAULT '' COMMENT '密码',
  `status` enum('enabled','disabled') NOT NULL DEFAULT 'enabled' COMMENT '帐号状态（0正常 1停用）',
  `login_ip` varchar(16) DEFAULT '' COMMENT '最后登陆IP',
  `login_date` datetime DEFAULT NULL COMMENT '最后登陆时间',
  `remark` varchar(500) DEFAULT '' COMMENT '备注',
  `create_by` varchar(64) DEFAULT '' COMMENT '创建者',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  `update_by` varchar(64) DEFAULT '' COMMENT '更新者',
  `update_time` timestamp NULL DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`),
  UNIQUE KEY `t_admin_account_uindex` (`account`)
) ENGINE=InnoDB AUTO_INCREMENT=14 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='管理员信息表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_admin`
--

LOCK TABLES `sys_admin` WRITE;
/*!40000 ALTER TABLE `sys_admin` DISABLE KEYS */;
INSERT INTO `sys_admin` VALUES (1,1,2,'admin','超级管理员','iteaj@outlook.com','13123456028',3,'/img/logo.png','a66abb5684c45962d887564f08346e8d','enabled','127.0.0.1','2018-03-16 11:33:00','做回自己, 活出未来(iteaj)','admin','2018-03-15 00:00:00','admin','2023-09-05 05:53:42'),(7,5,3,'demo','demo','iteaj@outlook.com','13123456029',3,NULL,'e10adc3949ba59abbe56e057f20f883e','enabled',NULL,NULL,'用于演示.','','2023-04-06 00:00:00','','2023-09-05 06:54:57'),(13,3,1,'iteaj','iteaj','shopingidn@gmail.com','13123456028',3,NULL,'a88b27088abf12811cf7df0f1421d7e1','enabled','',NULL,NULL,'','2023-09-05 13:59:21','',NULL);
/*!40000 ALTER TABLE `sys_admin` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_admin_role`
--

DROP TABLE IF EXISTS `sys_admin_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_admin_role` (
  `aid` bigint NOT NULL COMMENT '管理员id',
  `rid` bigint DEFAULT NULL COMMENT '角色id'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='管理员角色表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_admin_role`
--

LOCK TABLES `sys_admin_role` WRITE;
/*!40000 ALTER TABLE `sys_admin_role` DISABLE KEYS */;
INSERT INTO `sys_admin_role` VALUES (1,2),(13,2),(7,4);
/*!40000 ALTER TABLE `sys_admin_role` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_captcha`
--

DROP TABLE IF EXISTS `sys_captcha`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_captcha` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `code` char(36) NOT NULL,
  `captcha` varchar(8) DEFAULT NULL COMMENT '验证码',
  `expire_time` int DEFAULT NULL COMMENT '过期时间(秒)',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  UNIQUE KEY `sys_capt_code_uindex` (`code`)
) ENGINE=InnoDB AUTO_INCREMENT=1699623078721593347 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='验证码';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_captcha`
--

LOCK TABLES `sys_captcha` WRITE;
/*!40000 ALTER TABLE `sys_captcha` DISABLE KEYS */;
INSERT INTO `sys_captcha` VALUES (1699453972982636545,'65457c1d52dd4c21b31cb4b715150368','0',60,'2023-09-07 00:06:16'),(1699470741348655105,'349a1d6fe3b743c590123dac8a4364bb','2',60,'2023-09-07 01:12:54'),(1699477163960541186,'79c2183d94334f73bb50f247d3f75f24','6',60,'2023-09-07 01:38:25'),(1699485682709405698,'874b97f514d24623b1d8095e47f95e1f','0',60,'2023-09-07 02:12:16'),(1699487514399711234,'b8a55ed062384edab33d93fc8a3e32e5','17',60,'2023-09-07 02:19:33'),(1699495480532246529,'8145d4210ec844cdbf3a0c119915bccb','3',60,'2023-09-07 02:51:12'),(1699497322548928513,'68af07e680fd41f69673e2f74e8df830','0',60,'2023-09-07 02:58:31'),(1699510942909440002,'e5a4d8f819b547dc968bdd5630413af6','24',60,'2023-09-07 03:52:39'),(1699523923374350338,'d0a1576af287441984022507c0c165e4','2',60,'2023-09-07 04:44:14'),(1699544868772225025,'db5dc19375c24b00ab757b20ac88ab66','1',60,'2023-09-07 06:07:27'),(1699578825903546369,'ae7986ae968642f68bad924f911be496','11',60,'2023-09-07 08:22:23'),(1699580085096521730,'fc139ae215144f31b3aeffc7680bbed5','15',60,'2023-09-07 08:27:24'),(1699583230023409665,'d942dca2da23454ab045ea3733a80f7b','6',60,'2023-09-07 08:39:53'),(1699588876408037378,'3932c8940898432bbb7cb3601b014549','10',60,'2023-09-07 09:02:20'),(1699590799056019458,'04e693675da84365b7d991ae230c7cb6','8',60,'2023-09-07 09:09:58'),(1699590828290318337,'786c80af39974bf888c2cf1ca5147908','0',60,'2023-09-07 09:10:05'),(1699606795699462146,'d018c0527bca4f548f314444a6018ccc','14',60,'2023-09-07 10:13:32'),(1699619394134581249,'40d3479db86e4b04b0600ccc60d386f9','28',60,'2023-09-07 11:03:36'),(1699619418738368514,'1e9021c6eb55478ca1bb60f15f2ac817','5',60,'2023-09-07 11:03:41'),(1699619419912773633,'295a03d101f442448c2bd0f7656e16e2','14',60,'2023-09-07 11:03:42');
/*!40000 ALTER TABLE `sys_captcha` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_config`
--

DROP TABLE IF EXISTS `sys_config`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_config` (
  `id` int NOT NULL AUTO_INCREMENT COMMENT '参数主键',
  `name` varchar(64) NOT NULL DEFAULT '' COMMENT '参数名称',
  `label` varchar(32) NOT NULL COMMENT '系统配置key',
  `value` varchar(128) DEFAULT '' COMMENT '参数键值',
  `type` enum('def','sys') NOT NULL DEFAULT 'def' COMMENT '配置类型',
  `remark` varchar(500) DEFAULT NULL COMMENT '备注',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` datetime DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`),
  UNIQUE KEY `t_config_label_uindex` (`label`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='参数配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_config`
--

LOCK TABLES `sys_config` WRITE;
/*!40000 ALTER TABLE `sys_config` DISABLE KEYS */;
INSERT INTO `sys_config` VALUES (1,'系统名称','sys_name','城联IOT平台','sys','系统的名称','2019-12-04 07:25:31',NULL),(2,'菜单展开级别','sys_menu_style','one','sys','one：展开一级  more: 展开多级','2022-08-11 11:15:33',NULL),(3,'系统logo','sys_logo','/img/logo.png','sys','系统顶部logo图片地址','2022-08-12 10:04:15',NULL);
/*!40000 ALTER TABLE `sys_config` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_dict_data`
--

DROP TABLE IF EXISTS `sys_dict_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_dict_data` (
  `id` bigint NOT NULL AUTO_INCREMENT COMMENT '字典id',
  `sort` int DEFAULT '0' COMMENT '字典排序',
  `label` varchar(64) DEFAULT '' COMMENT '字典标签',
  `value` varchar(100) DEFAULT '' COMMENT '字典键值',
  `type` char(32) NOT NULL DEFAULT '' COMMENT '字典类型',
  `iz_default` tinyint(1) DEFAULT '0' COMMENT '是否默认（Y是 N否）',
  `status` enum('enabled','disabled') NOT NULL DEFAULT 'enabled' COMMENT '状态（0正常 1停用）',
  `remark` varchar(500) DEFAULT NULL COMMENT '备注',
  `create_by` varchar(64) DEFAULT '' COMMENT '创建者',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  `update_by` varchar(64) DEFAULT '' COMMENT '更新者',
  `update_time` datetime DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=47 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='字典数据表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_dict_data`
--

LOCK TABLES `sys_dict_data` WRITE;
/*!40000 ALTER TABLE `sys_dict_data` DISABLE KEYS */;
INSERT INTO `sys_dict_data` VALUES (1,1,'主栏','T','opera_position',0,'enabled',NULL,'','2019-06-27 11:13:02','','2019-06-27 11:13:07'),(2,2,'主栏(更多)','MT','opera_position',0,'enabled',NULL,'','2019-06-27 11:13:02','','2019-06-27 11:13:07'),(6,0,'主栏(更多)','MM','function-position',0,'enabled','主栏(更多)','',NULL,'',NULL),(11,0,'正常','status','common_status',0,'enabled','正常状态0','',NULL,'',NULL),(12,0,'禁用','disabled','common_status',0,'enabled','禁用状态','',NULL,'',NULL),(13,0,'主栏','M','function-position',0,'enabled','主栏','',NULL,'',NULL),(14,0,'隐藏','hidden','common_status',0,'enabled','隐藏状态','',NULL,'',NULL),(16,10,'男','1','core_sex',0,'enabled',NULL,'',NULL,'',NULL),(17,20,'女','2','core_sex',0,'enabled',NULL,'',NULL,'',NULL),(18,30,'保密','3','core_sex',0,'enabled',NULL,'',NULL,'',NULL),(22,10,'启用','enabled','sys_func_status',0,'enabled',NULL,'',NULL,'',NULL),(23,20,'禁用','disabled','sys_func_status',0,'enabled',NULL,'',NULL,'',NULL),(24,10,'在线','online','iot_device_status',0,'enabled',NULL,'',NULL,'',NULL),(25,20,'离线','offline','iot_device_status',0,'enabled',NULL,'',NULL,'',NULL),(29,10,'modbus_tcp','1','iot_dtu_protocol_type',0,'enabled',NULL,'',NULL,'',NULL),(30,20,'modbus_rtu','2','iot_dtu_protocol_type',0,'enabled',NULL,'',NULL,'',NULL),(31,30,'自定义','3','iot_dtu_protocol_type',0,'enabled',NULL,'',NULL,'',NULL),(32,20,'short','2','iot_field_type',0,'enabled',NULL,'',NULL,'',NULL),(33,10,'byte','1','iot_field_type',0,'enabled',NULL,'',NULL,'',NULL),(34,30,'int','3','iot_field_type',0,'enabled',NULL,'',NULL,'',NULL),(35,40,'long','4','iot_field_type',0,'enabled',NULL,'',NULL,'',NULL),(36,50,'float','5','iot_field_type',0,'enabled',NULL,'',NULL,'',NULL),(37,60,'double','6','iot_field_type',0,'enabled',NULL,'',NULL,'',NULL),(38,70,'boolean','7','iot_field_type',0,'enabled',NULL,'',NULL,'',NULL),(39,80,'date','8','iot_field_type',0,'enabled',NULL,'',NULL,'',NULL),(40,90,'string','9','iot_field_type',0,'enabled','字符串类型','',NULL,'',NULL),(41,100,'TIMESTAMP','10','iot_field_type',0,'enabled','时间戳类型','',NULL,'',NULL),(42,10,'是','true','sys_boolean_status',0,'enabled',NULL,'',NULL,'',NULL),(43,20,'否','false','sys_boolean_status',0,'enabled',NULL,'',NULL,'',NULL),(44,10,'停用','stop','iot_collect_status',0,'enabled',NULL,'',NULL,'',NULL),(45,20,'运行','run','iot_collect_status',0,'enabled',NULL,'',NULL,'',NULL),(46,30,'失败','fail','iot_collect_status',0,'enabled',NULL,'',NULL,'',NULL);
/*!40000 ALTER TABLE `sys_dict_data` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_dict_type`
--

DROP TABLE IF EXISTS `sys_dict_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_dict_type` (
  `id` bigint NOT NULL AUTO_INCREMENT COMMENT '字典主键',
  `type` char(32) NOT NULL DEFAULT '' COMMENT '字典类型',
  `name` varchar(100) DEFAULT '' COMMENT '字典名称',
  `status` enum('enabled','disabled') NOT NULL DEFAULT 'enabled' COMMENT '状态（0正常 1停用）',
  `remark` varchar(500) DEFAULT NULL COMMENT '备注',
  `create_by` varchar(64) DEFAULT '' COMMENT '创建者',
  `create_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_by` varchar(64) DEFAULT '' COMMENT '更新者',
  `update_time` datetime DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`),
  UNIQUE KEY `type t_dict_type_type_uindex` (`type`)
) ENGINE=InnoDB AUTO_INCREMENT=13 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='字典类型表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_dict_type`
--

LOCK TABLES `sys_dict_type` WRITE;
/*!40000 ALTER TABLE `sys_dict_type` DISABLE KEYS */;
INSERT INTO `sys_dict_type` VALUES (5,'sys_func_status','功能状态','enabled','启用(enabled) 禁用(disabled)','','2022-04-17 04:53:36','',NULL),(7,'iot_device_status','设备状态','enabled','包括在线和离线两个状态','','2022-06-05 08:00:41','',NULL),(9,'iot_dtu_protocol_type','DTU协议类型','enabled',NULL,'','2022-06-21 13:37:02','',NULL),(10,'iot_field_type','点位字段类型','enabled','点位字段类型','','2022-08-12 12:55:43','',NULL),(11,'sys_boolean_status','布尔状态值','enabled','布尔类型的状态值','','2022-08-27 08:04:30','',NULL),(12,'iot_collect_status','数据采集状态','enabled','数据采集任务的运行状态','','2022-08-28 12:16:15','',NULL);
/*!40000 ALTER TABLE `sys_dict_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_menu`
--

DROP TABLE IF EXISTS `sys_menu`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_menu` (
  `id` bigint NOT NULL AUTO_INCREMENT COMMENT '菜单ID',
  `name` varchar(50) NOT NULL COMMENT '菜单名称',
  `pid` bigint DEFAULT '0' COMMENT '父菜单ID',
  `sort` int DEFAULT '0' COMMENT '显示顺序',
  `url` varchar(200) DEFAULT '#' COMMENT '请求地址',
  `msn` char(16) DEFAULT NULL COMMENT '所属模块',
  `type` enum('A','M','V') NOT NULL COMMENT '菜单类型: A.权限、M.菜单、V.视图',
  `status` enum('enabled','disabled') DEFAULT 'enabled' COMMENT '菜单状态',
  `perms` varchar(100) DEFAULT NULL COMMENT '权限标识',
  `icon` varchar(100) DEFAULT '#' COMMENT '菜单图标',
  `remark` varchar(512) DEFAULT '' COMMENT '备注',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` datetime DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`),
  KEY `sys_menu_msn_index` (`msn`)
) ENGINE=InnoDB AUTO_INCREMENT=1334 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='菜单权限表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_menu`
--

LOCK TABLES `sys_menu` WRITE;
/*!40000 ALTER TABLE `sys_menu` DISABLE KEYS */;
INSERT INTO `sys_menu` VALUES (1058,'系统管理',0,50,'#','sys','M','enabled',NULL,'iz-icon-sys','','2021-09-25 00:00:00',NULL),(1060,'用户管理',1058,0,'/core/admin','sys','V','enabled','core:admin:view','iz-icon-sys-user','','2021-09-25 11:18:39',NULL),(1065,'角色管理',1058,1,'/core/role','sys','V','enabled','core:role:view','iz-icon-sys-role','','2021-09-25 11:18:39',NULL),(1066,'菜单管理',1058,2,'/core/menu','sys','V','enabled','core:menu:view','iz-icon-menu','','2021-09-25 11:18:39',NULL),(1069,'新增',1066,1,'/core/menu/add','sys','A','enabled','core:menu:add','#','','2021-09-25 11:18:39',NULL),(1070,'编辑',1066,2,'/core/menu/edit','sys','A','enabled','core:menu:edit','#','','2021-09-25 11:18:39',NULL),(1071,'删除',1066,3,'/core/menu/del','sys','A','enabled','core:menu:del','#','','2021-09-25 11:18:39',NULL),(1072,'查询',1066,0,'/core/menu/view','sys','A','enabled','core:menu:view','#','','2021-09-25 11:18:39',NULL),(1090,'字典管理',1058,8,'/core/dict','sys','V','enabled','core:dictType:view','iz-icon-zidianguanli','','2021-09-25 11:18:39',NULL),(1092,'新增',1090,0,'/core/dictType/add','sys','A','enabled','core:dictType:add','#','','2021-09-25 11:18:39',NULL),(1093,'修改',1090,0,'/core/dictType/edit','sys','A','enabled','core:dictType:edit','#','','2021-09-25 11:18:39',NULL),(1094,'查询',1090,0,'/core/dictType/view','sys','A','enabled','core:dictType:view','#','','2021-09-25 11:18:39',NULL),(1108,'组织机构',1058,50,'/core/org','sys','V','enabled','core:org:view','iz-icon-jigouguanli','','2021-09-25 00:00:00','2023-09-04 16:25:18'),(1113,'新增',1108,0,'/core/org/add','sys','A','enabled','core:org:add','#','','2021-09-25 11:18:39',NULL),(1114,'删除',1108,0,'/core/org/del','sys','A','enabled','core:org:del','#','','2021-09-25 11:18:39',NULL),(1115,'修改',1108,0,'/core/org/edit','sys','A','enabled','core:org:edit','#','','2021-09-25 11:18:39',NULL),(1116,'查询',1108,0,'/core/org/view','sys','A','enabled','core:org:view','#','','2021-09-25 11:18:39',NULL),(1117,'新增',1060,0,'/core/admin/add','sys','A','enabled','core:admin:add','#','','2021-09-25 11:18:39',NULL),(1118,'删除',1060,0,'/core/admin/del','sys','A','enabled','core:admin:del','#','','2021-09-25 11:18:39',NULL),(1119,'修改',1060,0,'/core/admin/edit','sys','A','enabled','core:admin:edit','#','','2021-09-25 11:18:39',NULL),(1120,'查询',1060,0,'/core/admin/view','sys','A','enabled','core:admin:view','#','','2021-09-25 11:18:39',NULL),(1121,'新增',1065,0,'/core/role/add','sys','A','enabled','core:role:add','#','','2021-09-25 11:18:39',NULL),(1122,'删除',1065,0,'/core/role/del','sys','A','enabled','core:role:del','#','','2021-09-25 11:18:39',NULL),(1123,'修改',1065,0,'/core/role/edit','sys','A','enabled','core:role:edit','#','','2021-09-25 11:18:39',NULL),(1124,'查询',1065,0,'/core/role/view','sys','A','enabled','core:role:view','#','','2021-09-25 11:18:39',NULL),(1125,'设置密码',1060,0,'/core/admin/pwd','sys','A','enabled','core:admin:pwd','#','修改用户密码','2021-09-25 11:18:39',NULL),(1127,'系统配置',1058,5,'/core/config','sys','V','enabled','core:config:view','iz-icon-sysconfig','','2021-09-25 11:18:39',NULL),(1128,'新增',1127,0,'/core/config/add','sys','A','enabled','core:config:add','#','','2021-09-25 11:18:39',NULL),(1129,'删除',1127,0,'/core/config/del','sys','A','enabled','core:config:del','#','','2021-09-25 11:18:39',NULL),(1130,'修改',1127,0,'/core/config/edit','sys','A','enabled','core:config:edit','#','','2021-09-25 11:18:39',NULL),(1131,'查询',1127,0,'/core/config/view','sys','A','enabled','core:config:view','#','','2021-09-25 11:18:39',NULL),(1132,'操作日志',1156,18,'/core/log','sys','V','enabled','core:log:view','iz-icon-log','','2021-09-25 11:18:39',NULL),(1134,'删除',1132,0,'/core/log/del','sys','A','enabled','core:log:del','#','','2021-09-25 11:18:39',NULL),(1136,'查询',1132,0,'/core/log/view','sys','A','enabled','core:log:view','#','','2021-09-25 11:18:39',NULL),(1137,'详情',1066,0,'','sys','A','enabled','core:menu:detail','#','','2021-09-25 11:18:39',NULL),(1156,'系统运维',0,100,'#','sys','M','enabled',NULL,'iz-icon-sys-monitor','','2021-09-25 00:00:00','2023-09-05 18:00:03'),(1157,'会话管理',1156,12,'/core/online','sys','V','enabled','core:online:user','iz-icon-online-user','','2021-09-25 00:00:00','2023-09-04 17:51:20'),(1162,'定时任务',1156,50,'/quartz/task','iot','V','enabled','quartz:task:view','iz-icon-quartz','','2021-09-25 00:00:00',NULL),(1163,'新增',1162,0,'/quartz/triggers/add','iot','A','enabled','quartz:trigger:add','#','','2021-09-25 11:18:39',NULL),(1164,'删除',1162,0,'/quartz/triggers/del','iot','A','enabled','quartz:trigger:del','#','','2021-09-25 11:18:39',NULL),(1165,'修改',1162,0,'/quartz/triggers/edit','iot','A','enabled','quartz:trigger:edit','#','','2021-09-25 11:18:39',NULL),(1166,'查询',1162,0,'/quartz/triggers/view','iot','A','enabled','quartz:trigger:view','#','','2021-09-25 11:18:39',NULL),(1167,'暂停',1162,5,'/quartz/triggers/paused','iot','A','enabled','quartz:triggers:paused','#','','2021-09-25 11:18:39',NULL),(1168,'运行一次',1162,0,'/quartz/triggers/run','iot','A','enabled','quartz:triggers:run','#','','2021-09-25 11:18:39',NULL),(1217,'分配权限',1065,68,'/core/role/perm','sys','A','enabled','core:role:perm','#','','2023-05-23 15:28:31',NULL),(1218,'删除',1157,68,'/core/online/del','iot','A','enabled','core:online:del','#','','2023-05-23 15:28:31',NULL),(1219,'下线',1157,68,'/core/online/offline','iot','A','enabled','core:online:offline','#','','2023-05-23 15:28:31',NULL),(1220,'查询',1157,68,'/core/online/view','iot','A','enabled','core:online:view','#','','2023-05-23 15:28:31',NULL),(1221,'删除',1090,68,'/core/dictType/del','iot','A','enabled','core:dictType:del','#','','2023-05-23 15:28:31',NULL),(1222,'开发工具',0,150,'#','dev','M','enabled',NULL,'iz-icon-kaifa','','2023-05-23 15:28:31',NULL),(1223,'代码生成',1222,10,'/gen/code','dev','V','enabled','gen:code:view','iz-icon-code','','2023-05-23 15:28:31',NULL),(1224,'工业物联网',0,30,'#','iot','M','enabled',NULL,'iz-icon-iiot','','2023-05-23 15:28:31',NULL),(1225,'设备类型',1304,158,'/iot/deviceType','iot','V','enabled','iot:deviceType:view','iz-icon-type','','2023-05-23 15:28:31',NULL),(1226,'查询',1225,5,'/iot/deviceType/view','iot','A','enabled','iot:deviceType:view','#','','2023-05-23 15:28:31',NULL),(1227,'新增',1225,10,'/iot/deviceType/add','iot','A','enabled','iot:deviceType:add','#','','2023-05-23 15:28:31',NULL),(1228,'修改',1225,15,'/iot/deviceType/edit','iot','A','enabled','iot:deviceType:edit','#','','2023-05-23 15:28:31',NULL),(1229,'删除',1225,20,'/iot/deviceType/del','iot','A','enabled','iot:deviceType:del','#','','2023-05-23 15:28:31',NULL),(1230,'设备信息',1304,128,'/iot/device','iot','V','enabled','iot:device:view','iz-icon-device','','2023-05-23 15:28:31',NULL),(1231,'查询',1230,5,'/iot/device/view','iot','A','enabled','iot:device:view','#','','2023-05-23 15:28:31',NULL),(1232,'新增',1230,10,'/iot/device/add','iot','A','enabled','iot:device:add','#','','2023-05-23 15:28:31',NULL),(1233,'修改',1230,15,'/iot/device/edit','iot','A','enabled','iot:device:edit','#','','2023-05-23 15:28:31',NULL),(1234,'删除',1230,20,'/iot/device/del','iot','A','enabled','iot:device:del','#','','2023-05-23 15:28:31',NULL),(1235,'PLC管理',1224,200,'/iot/plc','iot','V','enabled','iot:plc:view','iz-icon-plc','','2023-05-23 15:28:31',NULL),(1236,'新增',1235,28,'/iot/plc/add','iot','A','enabled','iot:plc:add','#','','2023-05-23 15:28:31',NULL),(1237,'DTU管理',1224,250,'/iot/dtu','iot','V','enabled','iot:dtu:view','iz-icon-dtube','','2023-05-23 15:28:31',NULL),(1238,'新增',1237,60,'/iot/dtu/add','iot','A','enabled','iot:dtu:add','#','','2023-05-23 15:28:31',NULL),(1239,'查询',1237,30,'/iot/dtu/view','iot','A','enabled','iot:dtu:view','#','','2023-05-23 15:28:31',NULL),(1240,'修改',1237,0,'/iot/dtu/edit','iot','A','enabled','iot:dtu:edit','#','','2023-05-23 15:28:31',NULL),(1241,'调试',1237,90,'/iot/dtu/debug','iot','A','enabled','iot:dtu:debug','#','','2023-05-23 15:28:31',NULL),(1242,'删除',1237,120,'/iot/dtu/del','iot','A','enabled','iot:dtu:del','#','','2023-05-23 15:28:31',NULL),(1243,'修改',1235,58,'/iot/plc/edit','iot','A','enabled','iot:plc:edit','#','','2023-05-23 15:28:31',NULL),(1244,'删除',1235,78,'/iot/plc/del','iot','A','enabled','iot:plc:del','#','','2023-05-23 15:28:31',NULL),(1245,'调试',1235,98,'/iot/plc/debug','iot','A','enabled','iot:plc:debug','#','','2023-05-23 15:28:31',NULL),(1246,'查询',1235,18,'/iot/plc/view','iot','A','enabled','iot:plc:view','#','','2023-05-23 15:28:31',NULL),(1247,'子设备',1237,160,'/iot/dtu/child','iot','A','enabled','iot:dtu:child','#','','2023-05-23 15:28:31',NULL),(1248,'子设备',1224,158,'/iot/deviceChild','iot','V','disabled','iot:deviceChild:view','#','','2023-05-23 15:28:31',NULL),(1249,'查询',1248,5,'/iot/deviceChild/view','iot','A','enabled','iot:deviceChild:view','#','','2023-05-23 15:28:31',NULL),(1250,'新增',1248,10,'/iot/deviceChild/add','iot','A','enabled','iot:deviceChild:add','#','','2023-05-23 15:28:31',NULL),(1251,'修改',1248,15,'/iot/deviceChild/edit','iot','A','enabled','iot:deviceChild:edit','#','','2023-05-23 15:28:31',NULL),(1252,'删除',1248,20,'/iot/deviceChild/del','iot','A','enabled','iot:deviceChild:del','#','','2023-05-23 15:28:31',NULL),(1255,'网络调试',1273,300,'/iot/debug','iot','V','enabled','','iz-icon-debug-tools','','2023-05-23 15:28:31',NULL),(1256,'点位组管理',1272,58,'/iot/pointGroup','iot','V','enabled','iot:pointGroup:view','iz-icon-set','','2023-05-23 15:28:31',NULL),(1257,'查询',1256,5,'/iot/pointGroup/view','iot','A','enabled','iot:pointGroup:view','#','','2023-05-23 15:28:31',NULL),(1258,'新增',1256,10,'/iot/pointGroup/add','iot','A','enabled','iot:pointGroup:add','#','','2023-05-23 15:28:31',NULL),(1259,'修改',1256,16,'/iot/pointGroup/edit','iot','A','enabled','iot:pointGroup:edit','#','','2023-05-23 15:28:31',NULL),(1260,'删除',1256,20,'/iot/pointGroup/del','iot','A','enabled','iot:pointGroup:del','#','','2023-05-23 15:28:31',NULL),(1261,'点位管理',1272,18,'/iot/signal','iot','V','enabled','iot:signal:view','iz-icon-signal','','2023-05-23 15:28:31',NULL),(1262,'查询',1261,5,'/iot/signal/view','iot','A','enabled','iot:signal:view','#','','2023-05-23 15:28:31',NULL),(1263,'新增',1261,10,'/iot/signal/add','iot','A','enabled','iot:signal:add','#','','2023-05-23 15:28:31',NULL),(1264,'修改',1261,15,'/iot/signal/edit','iot','A','enabled','iot:signal:edit','#','','2023-05-23 15:28:31',NULL),(1265,'删除',1261,20,'/iot/signal/del','iot','A','enabled','iot:signal:del','#','','2023-05-23 15:28:31',NULL),(1266,'设备型号',1304,158,'/iot/deviceModel','iot','V','enabled','iot:deviceModel:view','iz-icon-model','','2023-05-23 15:28:31',NULL),(1267,'查询',1266,5,'/iot/deviceModel/view','iot','A','enabled','iot:deviceModel:view','#','','2023-05-23 15:28:31',NULL),(1268,'新增',1266,10,'/iot/deviceModel/add','iot','A','enabled','iot:deviceModel:add','#','','2023-05-23 15:28:31',NULL),(1269,'修改',1266,15,'/iot/deviceModel/edit','iot','A','enabled','iot:deviceModel:edit','#','','2023-05-23 15:28:31',NULL),(1270,'删除',1266,20,'/iot/deviceModel/del','iot','A','enabled','iot:deviceModel:del','#','','2023-05-23 15:28:31',NULL),(1271,'连接',1235,108,'/iot/plc/connect','iot','A','enabled','iot:plc:connect','#','','2023-05-23 15:28:31',NULL),(1272,'数据采集',1224,300,'#','iot','M','enabled',NULL,'iz-icon-collect','','2023-05-23 15:28:31',NULL),(1273,'调试工具',1224,320,'#','iot','M','enabled',NULL,'iz-icon-debug','','2023-05-23 15:28:31',NULL),(1274,'DTU模拟',1273,20,'/iot/simulator/dtu','iot','V','enabled',NULL,'#','','2023-05-23 15:28:31',NULL),(1275,'采集任务管理',1272,158,'/iot/collectTask','iot','V','enabled','iot:collectTask:view','iz-icon-collect-task','','2023-05-23 15:28:31',NULL),(1276,'查询',1275,5,'/iot/collectTask/view','iot','A','enabled','iot:collectTask:view','#','','2023-05-23 15:28:31',NULL),(1277,'新增',1275,10,'/iot/collectTask/add','iot','A','enabled','iot:collectTask:add','#','','2023-05-23 15:28:31',NULL),(1278,'修改',1275,15,'/iot/collectTask/edit','iot','A','enabled','iot:collectTask:edit','#','','2023-05-23 15:28:31',NULL),(1279,'删除',1275,20,'/iot/collectTask/del','iot','A','enabled','iot:collectTask:del','#','','2023-05-23 15:28:31',NULL),(1281,'配置',1275,25,'','iot','A','enabled','iot:collectTask:config','#','','2023-05-23 15:28:31',NULL),(1282,'Modbus管理',1224,280,'/iot/modbus','iot','V','enabled',NULL,'iz-icon-modbus','','2023-05-23 15:28:31',NULL),(1283,'新增',1282,10,'/iot/modbus/add','iot','A','enabled','iot:modbus:add','#','','2023-05-23 15:28:31',NULL),(1284,'编辑',1282,50,'/iot/modbus/edit','iot','A','enabled','iot:modbus:edit','#','','2023-05-23 15:28:31',NULL),(1285,'删除',1282,80,'/iot/modbus/del','iot','A','enabled','iot:modbus:del','#','','2023-05-23 15:28:31',NULL),(1286,'浏览',1282,5,'/iot/modbus/view','iot','A','enabled','iot:modbus:view','#','','2023-05-23 15:28:31',NULL),(1287,'数据',1275,30,'#','iot','A','enabled','iot:collectTask:data','#','','2023-05-23 15:28:31',NULL),(1288,'采集数据列表',1272,188,'/iot/collectData','iot','V','enabled','iot:collectData:view','#','','2023-05-23 15:28:31',NULL),(1289,'导出',1060,80,'/core/admin/export','sys','A','enabled','core:admin:export','#','','2023-05-23 15:28:31',NULL),(1290,'调试',1282,100,'/iot/modbus/debug','iot','A','enabled','iot:modbus:debug','#','','2023-05-23 15:28:31',NULL),(1291,'连接',1282,90,'/iot/modbus/connect','iot','A','enabled','iot:modbus:connect','#','','2023-05-23 15:28:31',NULL),(1292,'导入',1060,70,'/core/admin/import','sys','A','enabled','core:admin:import','#','','2023-05-23 15:28:31',NULL),(1293,'串口设备',1224,158,'/iot/serial','iot','V','enabled','iot:serial:view','iz-icon-serial','','2023-05-23 15:28:31',NULL),(1294,'查询',1293,5,'/iot/serial/view','iot','A','enabled','iot:serial:view','#','','2023-05-23 15:28:31',NULL),(1295,'新增',1293,10,'/iot/serial/add','iot','A','enabled','iot:serial:add','#','','2023-05-23 15:28:31',NULL),(1296,'修改',1293,15,'/iot/serial/edit','iot','A','enabled','iot:serial:edit','#','','2023-05-23 15:28:31',NULL),(1297,'删除',1293,20,'/iot/serial/del','iot','A','enabled','iot:serial:del','#','','2023-05-23 15:28:31',NULL),(1303,'连接',1293,25,'/iot/serial/connect','iot','A','enabled','iot:serial:connect','#','','2023-05-23 15:28:31',NULL),(1304,'基础信息',0,20,'#','iot','M','enabled','#','iz-icon-basic-config','','2023-05-23 15:28:31',NULL),(1306,'消息配置',1156,8,'/core/messageSource','sys','V','enabled','core:messageSource:view','iz-icon-message','','2023-05-23 00:00:00','2023-09-04 17:57:40'),(1307,'查询',1306,5,'/core/messageSource/view','sys','A','enabled','core:messageSource:view','#','','2023-05-23 15:28:31',NULL),(1308,'新增',1306,10,'/core/messageSource/add','sys','A','enabled','core:messageSource:add','#','','2023-05-23 15:28:31',NULL),(1309,'修改',1306,15,'/core/messageSource/edit','sys','A','enabled','core:messageSource:edit','#','','2023-05-23 15:28:31',NULL),(1310,'删除',1306,20,'/core/messageSource/del','sys','A','enabled','core:messageSource:del','#','','2023-05-23 15:28:31',NULL),(1311,'调试',1306,25,'/core/messageSource/debug/#','sys','A','enabled','core:messageSource:debug','#','','2023-05-23 15:28:31',NULL),(1329,'岗位管理',1058,158,'/core/post','sys','V','enabled','core:post:view','iz-icon-post','','2023-05-23 00:00:00','2023-09-04 17:49:47'),(1330,'查询',1329,5,'/core/post/view','sys','A','enabled','core:post:view','#','','2023-05-23 15:28:31',NULL),(1331,'新增',1329,10,'/core/post/add','sys','A','enabled','core:post:add','#','','2023-05-23 15:28:31',NULL),(1332,'修改',1329,15,'/core/post/edit','sys','A','enabled','core:post:edit','#','','2023-05-23 15:28:31',NULL),(1333,'删除',1329,20,'/core/post/del','sys','A','enabled','core:post:del','#','','2023-05-23 15:28:31',NULL);
/*!40000 ALTER TABLE `sys_menu` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_message_source`
--

DROP TABLE IF EXISTS `sys_message_source`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_message_source` (
  `id` int NOT NULL AUTO_INCREMENT,
  `type` char(32) NOT NULL COMMENT '消息类型(email,sms,...)',
  `name` char(64) NOT NULL COMMENT '消息源名称',
  `channel` char(16) DEFAULT NULL COMMENT '通道类型',
  `config` json DEFAULT NULL COMMENT '其它配置',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='消息源';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_message_source`
--

LOCK TABLES `sys_message_source` WRITE;
/*!40000 ALTER TABLE `sys_message_source` DISABLE KEYS */;
INSERT INTO `sys_message_source` VALUES (1,'Sms','阿里云短信测试','ALIBABA','{\"signature\": \"sdf\", \"accessKeyId\": \"sdf\", \"accessKeySecret\": \"sdf\"}','2023-08-27 21:48:41'),(3,'Email','QQ邮件测试','DEFAULT','{\"port\": \"465\", \"password\": \"knlijuorwpetbhij\", \"username\": \"97235681@qq.com\", \"smtpServer\": \"smtp.qq.com\", \"fromAddress\": \"97235681@qq.com\"}','2023-08-31 18:52:16');
/*!40000 ALTER TABLE `sys_message_source` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_notify`
--

DROP TABLE IF EXISTS `sys_notify`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_notify` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `title` varchar(128) DEFAULT NULL COMMENT '消息主题',
  `content` varchar(256) DEFAULT NULL COMMENT '消息内容',
  `type` varchar(16) DEFAULT NULL COMMENT '消息类型',
  `create_user` bigint DEFAULT NULL COMMENT '发送人',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  PRIMARY KEY (`id`),
  KEY `table_name_create_time_index` (`create_time` DESC),
  KEY `table_name_org_id_index` (`create_user`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='系统通知';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_notify`
--

LOCK TABLES `sys_notify` WRITE;
/*!40000 ALTER TABLE `sys_notify` DISABLE KEYS */;
/*!40000 ALTER TABLE `sys_notify` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_notify_user`
--

DROP TABLE IF EXISTS `sys_notify_user`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_notify_user` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `notify_id` bigint NOT NULL COMMENT '所属通知',
  `status` tinyint(1) NOT NULL DEFAULT '0' COMMENT '已读状态(false未读 true已读)',
  `read_time` datetime DEFAULT NULL COMMENT '已读时间',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='消息通知用户';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_notify_user`
--

LOCK TABLES `sys_notify_user` WRITE;
/*!40000 ALTER TABLE `sys_notify_user` DISABLE KEYS */;
/*!40000 ALTER TABLE `sys_notify_user` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_online_user`
--

DROP TABLE IF EXISTS `sys_online_user`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_online_user` (
  `id` int NOT NULL AUTO_INCREMENT,
  `session_id` varchar(64) NOT NULL COMMENT '会话编号',
  `account` varchar(32) DEFAULT NULL COMMENT '当前在线的用户',
  `user_nick` varchar(64) NOT NULL DEFAULT '' COMMENT '用户昵称',
  `access_ip` char(16) NOT NULL DEFAULT '' COMMENT '登入ip',
  `browse` varchar(32) NOT NULL DEFAULT '' COMMENT '登录时使用的浏览器',
  `os` varchar(32) NOT NULL DEFAULT '' COMMENT '使用的操作系统',
  `status` enum('Online','Offline') NOT NULL DEFAULT 'Online' COMMENT '用户状态(Def. 默认 ,on. 在线, off. 离线)',
  `type` enum('COMPUTER','MOBILE','TABLET','UNKNOWN') NOT NULL DEFAULT 'UNKNOWN' COMMENT '应用类型',
  `location` varchar(64) NOT NULL DEFAULT '' COMMENT '访问的本地位置',
  `login_time` datetime DEFAULT NULL COMMENT '登录时间',
  `expire_time` int DEFAULT '0' COMMENT '超时时长, 从访问到离开的时间， 单位分钟',
  `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '系统访问时间',
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '系统最后访问时间',
  PRIMARY KEY (`id`),
  UNIQUE KEY `t_online_user_session_id_uindex` (`session_id`)
) ENGINE=InnoDB AUTO_INCREMENT=7387 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='在线用户';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_online_user`
--

LOCK TABLES `sys_online_user` WRITE;
/*!40000 ALTER TABLE `sys_online_user` DISABLE KEYS */;
INSERT INTO `sys_online_user` VALUES (7212,'442640c7-d7a8-41e2-a026-be60338bd9ab','admin','超级管理员','0:0:0:0:0:0:0:1','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-01 17:19:49',2592000,'2023-09-01 09:26:56','2023-09-01 17:46:34'),(7213,'e8bdb5a9-85bf-42af-b1c0-1a60aa9a5af0','admin','超级管理员','0:0:0:0:0:0:0:1','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-01 17:27:23',2592000,'2023-09-01 09:27:35','2023-09-01 17:36:33'),(7215,'2b0291a2-85b6-4e04-8a97-56cb4d07d1c8','admin','超级管理员','0:0:0:0:0:0:0:1','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-01 17:36:38',2592000,'2023-09-01 09:36:39','2023-09-01 17:46:34'),(7216,'94f2b334-d0f2-462d-98a3-d2765b66deda','admin','超级管理员','0:0:0:0:0:0:0:1','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-01 17:46:45',2592000,'2023-09-01 09:46:47','2023-09-01 18:09:05'),(7217,'2fcee020-2e5f-425f-8104-a605dfb5966b','admin','超级管理员','0:0:0:0:0:0:0:1','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-01 18:09:15',2592000,'2023-09-01 10:09:16','2023-09-01 18:18:24'),(7218,'651a1109-e714-402c-a31a-95c7fbd1e2fa','admin','超级管理员','124.222.187.121','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-01 18:18:32',2592000,'2023-09-01 10:18:31','2023-09-01 18:19:26'),(7219,'fd13662b-4f13-4470-8753-b6f92d40cb04','admin','超级管理员','124.222.187.121','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-01 20:47:48',2592000,'2023-09-01 12:47:47','2023-09-02 11:57:48'),(7220,'3c0b8ea9-8334-45db-b7f3-10886c1a848c','admin','超级管理员','124.222.187.121','Chrome Mobile','Android 1.x','Offline','MOBILE','','2023-09-01 22:03:10',2592000,'2023-09-01 14:03:10','2023-09-02 13:57:15'),(7229,'6426a470-0b83-4d09-b27b-54e99de64b21','admin','超级管理员','0:0:0:0:0:0:0:1','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-02 13:58:13',2592000,'2023-09-02 05:58:13','2023-09-02 14:01:19'),(7230,'603a07d1-cb76-45b2-b8cb-fa7996ba2bdf','admin','超级管理员','0:0:0:0:0:0:0:1','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-02 14:01:48',2592000,'2023-09-02 06:01:48','2023-09-02 14:30:20'),(7231,'ae102272-e611-4fa6-8bcd-d045911dccb6','admin','超级管理员','0:0:0:0:0:0:0:1','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-02 14:34:05',2592000,'2023-09-02 06:34:04','2023-09-02 14:56:44'),(7232,'0959f3af-fff8-4799-85ee-49a4c9e25341','admin','超级管理员','0:0:0:0:0:0:0:1','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-02 14:57:03',2592000,'2023-09-02 06:57:03','2023-09-04 11:17:25'),(7239,'9df04566-8b54-430e-82d6-15b9675344e6','admin','超级管理员','124.222.187.121','Chrome 9','Windows 10','Offline','COMPUTER','','2023-09-02 15:55:09',2592000,'2023-09-02 07:55:09','2023-09-04 09:26:14'),(7256,'af0564ae-5bbf-45a9-bb65-aa1aef417341','admin','超级管理员','124.222.187.121','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-04 09:31:37',2592000,'2023-09-04 01:31:36','2023-09-05 08:20:55'),(7260,'54319ea3-422b-4d75-950d-e024f2db5d9b','admin','超级管理员','0:0:0:0:0:0:0:1','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-04 11:18:39',7200,'2023-09-04 03:18:39','2023-09-04 11:48:13'),(7262,'a5fa9007-a126-4252-aa97-a43092133417','admin','超级管理员','0:0:0:0:0:0:0:1','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-04 11:48:47',7200,'2023-09-04 03:48:47','2023-09-04 17:10:30'),(7266,'004643bd-68b7-496c-b668-a85c2ce201cb','admin','超级管理员','0:0:0:0:0:0:0:1','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-04 14:03:56',7200,'2023-09-04 06:03:56','2023-09-04 17:10:30'),(7278,'50fc306f-15e0-4fb0-add9-4a6b2bbc305a','admin','超级管理员','0:0:0:0:0:0:0:1','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-04 16:04:11',7200,'2023-09-04 08:04:11','2023-09-04 17:10:30'),(7281,'ad6b0867-2132-4d3f-8f9f-d17298318bb1','admin','超级管理员','0:0:0:0:0:0:0:1','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-04 17:15:34',7200,'2023-09-04 09:15:34','2023-09-04 17:19:20'),(7283,'25cf1536-89ce-4801-b417-e524a89651cd','admin','超级管理员','0:0:0:0:0:0:0:1','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-04 17:31:39',7200,'2023-09-04 09:31:39','2023-09-04 17:34:57'),(7285,'3b06600c-05f4-4a1d-8a37-6fbc0bc7af68','admin','超级管理员','0:0:0:0:0:0:0:1','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-04 17:35:15',7200,'2023-09-04 09:35:15','2023-09-05 13:47:58'),(7297,'ce51fc02-ecdf-4634-a2e7-6a2c02588e99','admin','超级管理员','124.222.187.121','Chrome 8','Windows 10','Offline','COMPUTER','','2023-09-05 08:24:46',2592000,'2023-09-05 00:24:46','2023-09-05 09:20:04'),(7299,'320a440f-c254-4612-bf67-0f4d43a510fe','admin','超级管理员','124.222.187.121','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-05 09:27:34',2592000,'2023-09-05 01:27:34','2023-09-05 11:00:30'),(7305,'0b3a4975-3080-4f71-ab16-7d3f91b2b5a3','admin','超级管理员','124.222.187.121','Chrome 11','Mac OS X','Offline','COMPUTER','','2023-09-05 11:07:51',2592000,'2023-09-05 03:07:51','2023-09-05 14:45:21'),(7308,'c19176f3-99f5-4026-800d-465d9c2c2e04','admin','超级管理员','0:0:0:0:0:0:0:1','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-05 13:48:19',7200,'2023-09-05 05:48:19','2023-09-05 13:49:59'),(7309,'bdde54fd-9294-47e4-b634-4f4a57e36dfe','admin','超级管理员','0:0:0:0:0:0:0:1','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-05 13:50:14',7200,'2023-09-05 05:50:14','2023-09-05 13:54:59'),(7311,'70d50551-7cc5-4cd1-a490-32e2723cbcb8','admin','超级管理员','0:0:0:0:0:0:0:1','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-05 13:55:39',7200,'2023-09-05 05:55:39','2023-09-05 13:58:45'),(7312,'f8190b47-21f6-4c45-ab20-b20425c18372','admin','超级管理员','0:0:0:0:0:0:0:1','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-05 13:59:03',7200,'2023-09-05 05:59:04','2023-09-05 14:01:10'),(7313,'c7b9f288-8820-4d19-857d-2a524308accc','admin','超级管理员','0:0:0:0:0:0:0:1','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-05 14:01:22',7200,'2023-09-05 06:01:23','2023-09-05 14:03:12'),(7314,'cedc0826-e7fa-40d6-8189-2d1e550d08c4','admin','超级管理员','0:0:0:0:0:0:0:1','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-05 14:03:21',7200,'2023-09-05 06:03:22','2023-09-05 14:03:59'),(7315,'ecb1a7f7-b267-4253-b4b6-9ee5f70b7436','admin','超级管理员','0:0:0:0:0:0:0:1','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-05 14:04:21',7200,'2023-09-05 06:04:22','2023-09-05 17:54:59'),(7321,'11c32c78-391b-49a6-9f6e-907e2c5ee608','admin','超级管理员','124.222.187.121','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-05 14:45:47',2592000,'2023-09-05 06:45:46','2023-09-05 17:54:59'),(7324,'d6bf9969-41a4-4bcf-b28e-3a2f259edb64','admin','超级管理员','0:0:0:0:0:0:0:1','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-05 16:05:00',7200,'2023-09-05 08:05:01','2023-09-05 17:54:59'),(7337,'7cfcad46-71d0-41bd-896f-589045cf7d7f','admin','超级管理员','0:0:0:0:0:0:0:1','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-05 17:58:42',7200,'2023-09-05 09:58:42','2023-09-06 17:38:44'),(7338,'d93dc15a-e6c1-492f-8239-4099186b57aa','admin','超级管理员','0:0:0:0:0:0:0:1','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-05 19:59:00',7200,'2023-09-05 11:59:01','2023-09-06 17:38:44'),(7355,'3aaf5c96-305a-45ff-87b5-1e7af2dc10b8','admin','超级管理员','0:0:0:0:0:0:0:1','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-06 13:38:32',7200,'2023-09-06 05:38:32','2023-09-06 17:38:44'),(7362,'3339d208-fd4f-424e-974a-e51feff8cdcf','admin','超级管理员','0:0:0:0:0:0:0:1','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-06 15:42:57',7200,'2023-09-06 07:42:57','2023-09-06 17:38:44'),(7366,'9c25845e-16ba-4044-b606-2049e6c58ccd','admin','超级管理员','0:0:0:0:0:0:0:1','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-06 17:42:19',7200,'2023-09-06 09:42:19','2023-09-06 19:51:40'),(7370,'d3549daf-fdbc-4882-a925-bc91f0818af5','admin','超级管理员','124.222.187.121','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-06 19:52:15',7200,'2023-09-06 11:52:15','2023-09-07 09:19:13'),(7371,'b782cf41-a8a7-48fe-a048-fe689b81c8e9','admin','超级管理员','124.222.187.121','Chrome Mobile','Android 1.x','Offline','MOBILE','','2023-09-06 19:54:21',7200,'2023-09-06 11:54:20','2023-09-07 09:19:13'),(7374,'bd98f6d9-2111-44ad-b7c1-533f1deb799f','admin','超级管理员','124.222.187.121','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-07 09:10:13',7200,'2023-09-07 01:10:12','2023-09-07 09:19:13'),(7375,'f9eebd74-b3f0-4ffe-a0ea-d5ac68b286c1','admin','超级管理员','0:0:0:0:0:0:0:1','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-07 09:11:59',7200,'2023-09-07 01:11:59','2023-09-07 09:19:13'),(7378,'413fa7f5-e445-4782-afa2-9dd45b78105e','admin','超级管理员','0:0:0:0:0:0:0:1','Chrome 11','Windows 10','Offline','COMPUTER','','2023-09-07 09:33:02',2592000,'2023-09-07 01:33:02','2023-09-07 09:42:17'),(7379,'77950801-d4f6-4b42-a5bc-a6222d622340','admin','超级管理员','0:0:0:0:0:0:0:1','Chrome 11','Windows 10','Online','COMPUTER','','2023-09-07 09:43:19',2592000,'2023-09-07 01:43:20','2023-09-07 09:43:20');
/*!40000 ALTER TABLE `sys_online_user` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_org`
--

DROP TABLE IF EXISTS `sys_org`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_org` (
  `id` bigint NOT NULL AUTO_INCREMENT COMMENT '部门id',
  `pid` bigint DEFAULT '0' COMMENT '父级id',
  `level` int DEFAULT '1' COMMENT '属于第几级',
  `name` varchar(64) NOT NULL COMMENT '机构名称',
  `sort` int DEFAULT '0' COMMENT '显示顺序',
  `leader` varchar(20) DEFAULT NULL COMMENT '负责人',
  `phone` varchar(11) DEFAULT NULL COMMENT '联系电话',
  `path` varchar(128) DEFAULT NULL COMMENT '机构路径',
  `create_by` varchar(64) DEFAULT '' COMMENT '创建者',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_by` varchar(64) DEFAULT '' COMMENT '更新者',
  `update_time` datetime DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='组织机构表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_org`
--

LOCK TABLES `sys_org` WRITE;
/*!40000 ALTER TABLE `sys_org` DISABLE KEYS */;
INSERT INTO `sys_org` VALUES (1,0,1,'厦门由源创科技',0,'iteaj',NULL,'1','','2019-11-26 09:20:59','',NULL),(2,1,1,'运维部',0,'iteaj',NULL,'1,2','','2019-11-26 01:21:01','',NULL),(3,1,2,'技术部',0,'iteaj','13123456028','1,3','','2019-11-26 18:19:23','',NULL),(5,2,2,'测试部',0,'test','13123456029','1,2,5','','2021-06-06 15:51:12','',NULL);
/*!40000 ALTER TABLE `sys_org` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_post`
--

DROP TABLE IF EXISTS `sys_post`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_post` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `sort` mediumint DEFAULT '0' COMMENT '排序',
  `name` varchar(64) NOT NULL COMMENT '岗位名称',
  `org_id` bigint NOT NULL COMMENT '所属机构',
  `remark` varchar(256) DEFAULT NULL COMMENT '岗位介绍',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='岗位管理';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_post`
--

LOCK TABLES `sys_post` WRITE;
/*!40000 ALTER TABLE `sys_post` DISABLE KEYS */;
INSERT INTO `sys_post` VALUES (1,10,'技术总监',3,NULL,'2023-09-04 17:32:20'),(2,10,'CEO',1,'公司总负责人','2023-09-05 13:53:26'),(3,10,'高级测试',5,NULL,'2023-09-05 14:54:02');
/*!40000 ALTER TABLE `sys_post` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_region`
--

DROP TABLE IF EXISTS `sys_region`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_region` (
  `id` int unsigned NOT NULL AUTO_INCREMENT,
  `code` varchar(50) DEFAULT NULL COMMENT '行政代码',
  `name` varchar(255) DEFAULT NULL COMMENT '名称',
  `pid` int NOT NULL COMMENT '父id',
  `first_letter` varchar(10) DEFAULT NULL COMMENT '首字母',
  `level` int NOT NULL COMMENT '城市等级',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2463 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='行政区域';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_region`
--

LOCK TABLES `sys_region` WRITE;
/*!40000 ALTER TABLE `sys_region` DISABLE KEYS */;
INSERT INTO `sys_region` VALUES (1,'110000','北京市',0,'B',0),(2,'120000','天津市',0,'T',0),(3,'130000','河北省',0,'H',0),(4,'140000','山西省',0,'S',0),(5,'150000','内蒙古自治区',0,'N',0),(6,'210000','辽宁省',0,'L',0),(7,'220000','吉林省',0,'J',0),(8,'230000','黑龙江省',0,'H',0),(9,'310000','上海市',0,'S',0),(10,'320000','江苏省',0,'J',0),(11,'330000','浙江省',0,'Z',0),(12,'340000','安徽省',0,'A',0),(13,'350000','福建省',0,'F',0),(14,'360000','江西省',0,'J',0),(15,'370000','山东省',0,'S',0),(16,'410000','河南省',0,'H',0),(17,'420000','湖北省',0,'H',0),(18,'430000','湖南省',0,'H',0),(19,'440000','广东省',0,'G',0),(20,'450000','广西壮族自治区',0,'G',0),(21,'460000','海南省',0,'H',0),(22,'500000','重庆市',0,'Z',0),(23,'510000','四川省',0,'S',0),(24,'520000','贵州省',0,'G',0),(25,'530000','云南省',0,'Y',0),(26,'540000','西藏自治区',0,'X',0),(27,'610000','陕西省',0,'S',0),(28,'620000','甘肃省',0,'G',0),(29,'630000','青海省',0,'Q',0),(30,'640000','宁夏回族自治区',0,'N',0),(31,'650000','新疆维吾尔自治区',0,'X',0),(32,'710000','台湾省',0,'T',0),(33,'810000','香港特别行政区',0,'X',0),(34,'820000','澳门特别行政区',0,'A',0),(35,'110100','北京市',1,'B',1),(36,'110200','北京县',1,'B',1),(37,'120100','天津市',2,'T',1),(38,'120200','天津县',2,'T',1),(39,'130100','石家庄市',3,'S',1),(40,'130200','唐山市',3,'T',1),(41,'130300','秦皇岛市',3,'Q',1),(42,'130400','邯郸市',3,'H',1),(43,'130500','邢台市',3,'X',1),(44,'130600','保定市',3,'B',1),(45,'130700','张家口市',3,'Z',1),(46,'130800','承德市',3,'C',1),(47,'130900','沧州市',3,'C',1),(48,'131000','廊坊市',3,'L',1),(49,'131100','衡水市',3,'H',1),(50,'140100','太原市',4,'T',1),(51,'140200','大同市',4,'D',1),(52,'140300','阳泉市',4,'Y',1),(53,'140400','长治市',4,'C',1),(54,'140500','晋城市',4,'J',1),(55,'140600','朔州市',4,'S',1),(56,'140700','晋中市',4,'J',1),(57,'140800','运城市',4,'Y',1),(58,'140900','忻州市',4,'X',1),(59,'141000','临汾市',4,'L',1),(60,'141100','吕梁市',4,'L',1),(61,'150100','呼和浩特市',5,'H',1),(62,'150200','包头市',5,'B',1),(63,'150300','乌海市',5,'W',1),(64,'150400','赤峰市',5,'C',1),(65,'150500','通辽市',5,'T',1),(66,'150600','鄂尔多斯市',5,'E',1),(67,'150700','呼伦贝尔市',5,'H',1),(68,'150800','巴彦淖尔市',5,'B',1),(69,'150900','乌兰察布市',5,'W',1),(70,'152200','兴安盟',5,'X',1),(71,'152500','锡林郭勒盟',5,'X',1),(72,'152900','阿拉善盟',5,'A',1),(73,'210100','沈阳市',6,'S',1),(74,'210200','大连市',6,'D',1),(75,'210300','鞍山市',6,'A',1),(76,'210400','抚顺市',6,'F',1),(77,'210500','本溪市',6,'B',1),(78,'210600','丹东市',6,'D',1),(79,'210700','锦州市',6,'J',1),(80,'210800','营口市',6,'Y',1),(81,'210900','阜新市',6,'F',1),(82,'211000','辽阳市',6,'L',1),(83,'211100','盘锦市',6,'P',1),(84,'211200','铁岭市',6,'T',1),(85,'211300','朝阳市',6,'C',1),(86,'211400','葫芦岛市',6,'H',1),(87,'220100','长春市',7,'C',1),(88,'220200','吉林市',7,'J',1),(89,'220300','四平市',7,'S',1),(90,'220400','辽源市',7,'L',1),(91,'220500','通化市',7,'T',1),(92,'220600','白山市',7,'B',1),(93,'220700','松原市',7,'S',1),(94,'220800','白城市',7,'B',1),(95,'222400','延边朝鲜族自治州',7,'Y',1),(96,'230100','哈尔滨市',8,'H',1),(97,'230200','齐齐哈尔市',8,'Q',1),(98,'230300','鸡西市',8,'J',1),(99,'230400','鹤岗市',8,'H',1),(100,'230500','双鸭山市',8,'S',1),(101,'230600','大庆市',8,'D',1),(102,'230700','伊春市',8,'Y',1),(103,'230800','佳木斯市',8,'J',1),(104,'230900','七台河市',8,'Q',1),(105,'231000','牡丹江市',8,'M',1),(106,'231100','黑河市',8,'H',1),(107,'231200','绥化市',8,'S',1),(108,'232700','大兴安岭地区',8,'D',1),(109,'310100','上海市',9,'S',1),(110,'310200','上海县',9,'S',1),(111,'320100','南京市',10,'N',1),(112,'320200','无锡市',10,'W',1),(113,'320300','徐州市',10,'X',1),(114,'320400','常州市',10,'C',1),(115,'320500','苏州市',10,'S',1),(116,'320600','南通市',10,'N',1),(117,'320700','连云港市',10,'L',1),(118,'320800','淮安市',10,'H',1),(119,'320900','盐城市',10,'Y',1),(120,'321000','扬州市',10,'Y',1),(121,'321100','镇江市',10,'Z',1),(122,'321200','泰州市',10,'T',1),(123,'321300','宿迁市',10,'S',1),(124,'330100','杭州市',11,'H',1),(125,'330200','宁波市',11,'N',1),(126,'330300','温州市',11,'W',1),(127,'330400','嘉兴市',11,'J',1),(128,'330500','湖州市',11,'H',1),(129,'330600','绍兴市',11,'S',1),(130,'330700','金华市',11,'J',1),(131,'330800','衢州市',11,'Q',1),(132,'330900','舟山市',11,'Z',1),(133,'331000','台州市',11,'T',1),(134,'331100','丽水市',11,'L',1),(135,'340100','合肥市',12,'H',1),(136,'340200','芜湖市',12,'W',1),(137,'340300','蚌埠市',12,'B',1),(138,'340400','淮南市',12,'H',1),(139,'340500','马鞍山市',12,'M',1),(140,'340600','淮北市',12,'H',1),(141,'340700','铜陵市',12,'T',1),(142,'340800','安庆市',12,'A',1),(143,'341000','黄山市',12,'H',1),(144,'341100','滁州市',12,'C',1),(145,'341200','阜阳市',12,'F',1),(146,'341300','宿州市',12,'S',1),(147,'341500','六安市',12,'L',1),(148,'341600','亳州市',12,'B',1),(149,'341700','池州市',12,'C',1),(150,'341800','宣城市',12,'X',1),(151,'350100','福州市',13,'F',1),(152,'350200','厦门市',13,'X',1),(153,'350300','莆田市',13,'P',1),(154,'350400','三明市',13,'S',1),(155,'350500','泉州市',13,'Q',1),(156,'350600','漳州市',13,'Z',1),(157,'350700','南平市',13,'N',1),(158,'350800','龙岩市',13,'L',1),(159,'350900','宁德市',13,'N',1),(160,'360100','南昌市',14,'N',1),(161,'360200','景德镇市',14,'J',1),(162,'360300','萍乡市',14,'P',1),(163,'360400','九江市',14,'J',1),(164,'360500','新余市',14,'X',1),(165,'360600','鹰潭市',14,'Y',1),(166,'360700','赣州市',14,'G',1),(167,'360800','吉安市',14,'J',1),(168,'360900','宜春市',14,'Y',1),(169,'361000','抚州市',14,'F',1),(170,'361100','上饶市',14,'S',1),(171,'370100','济南市',15,'J',1),(172,'370200','青岛市',15,'Q',1),(173,'370300','淄博市',15,'Z',1),(174,'370400','枣庄市',15,'Z',1),(175,'370500','东营市',15,'D',1),(176,'370600','烟台市',15,'Y',1),(177,'370700','潍坊市',15,'W',1),(178,'370800','济宁市',15,'J',1),(179,'370900','泰安市',15,'T',1),(180,'371000','威海市',15,'W',1),(181,'371100','日照市',15,'R',1),(182,'371200','莱芜市',15,'L',1),(183,'371300','临沂市',15,'L',1),(184,'371400','德州市',15,'D',1),(185,'371500','聊城市',15,'L',1),(186,'371600','滨州市',15,'B',1),(187,'371700','菏泽市',15,'H',1),(188,'410100','郑州市',16,'Z',1),(189,'410200','开封市',16,'K',1),(190,'410300','洛阳市',16,'L',1),(191,'410400','平顶山市',16,'P',1),(192,'410500','安阳市',16,'A',1),(193,'410600','鹤壁市',16,'H',1),(194,'410700','新乡市',16,'X',1),(195,'410800','焦作市',16,'J',1),(196,'410900','濮阳市',16,'P',1),(197,'411000','许昌市',16,'X',1),(198,'411100','漯河市',16,'L',1),(199,'411200','三门峡市',16,'S',1),(200,'411300','南阳市',16,'N',1),(201,'411400','商丘市',16,'S',1),(202,'411500','信阳市',16,'X',1),(203,'411600','周口市',16,'Z',1),(204,'411700','驻马店市',16,'Z',1),(205,'419000','省直辖县级行政区划',16,'S',1),(206,'420100','武汉市',17,'W',1),(207,'420200','黄石市',17,'H',1),(208,'420300','十堰市',17,'S',1),(209,'420500','宜昌市',17,'Y',1),(210,'420600','襄阳市',17,'X',1),(211,'420700','鄂州市',17,'E',1),(212,'420800','荆门市',17,'J',1),(213,'420900','孝感市',17,'X',1),(214,'421000','荆州市',17,'J',1),(215,'421100','黄冈市',17,'H',1),(216,'421200','咸宁市',17,'X',1),(217,'421300','随州市',17,'S',1),(218,'422800','恩施土家族苗族自治州',17,'E',1),(219,'429000','省直辖县级行政区划',17,'S',1),(220,'430100','长沙市',18,'C',1),(221,'430200','株洲市',18,'Z',1),(222,'430300','湘潭市',18,'X',1),(223,'430400','衡阳市',18,'H',1),(224,'430500','邵阳市',18,'S',1),(225,'430600','岳阳市',18,'Y',1),(226,'430700','常德市',18,'C',1),(227,'430800','张家界市',18,'Z',1),(228,'430900','益阳市',18,'Y',1),(229,'431000','郴州市',18,'C',1),(230,'431100','永州市',18,'Y',1),(231,'431200','怀化市',18,'H',1),(232,'431300','娄底市',18,'L',1),(233,'433100','湘西土家族苗族自治州',18,'X',1),(234,'440100','广州市',19,'G',1),(235,'440200','韶关市',19,'S',1),(236,'440300','深圳市',19,'S',1),(237,'440400','珠海市',19,'Z',1),(238,'440500','汕头市',19,'S',1),(239,'440600','佛山市',19,'F',1),(240,'440700','江门市',19,'J',1),(241,'440800','湛江市',19,'Z',1),(242,'440900','茂名市',19,'M',1),(243,'441200','肇庆市',19,'Z',1),(244,'441300','惠州市',19,'H',1),(245,'441400','梅州市',19,'M',1),(246,'441500','汕尾市',19,'S',1),(247,'441600','河源市',19,'H',1),(248,'441700','阳江市',19,'Y',1),(249,'441800','清远市',19,'Q',1),(250,'441900','东莞市',19,'D',1),(251,'442000','中山市',19,'Z',1),(252,'445100','潮州市',19,'C',1),(253,'445200','揭阳市',19,'J',1),(254,'445300','云浮市',19,'Y',1),(255,'450100','南宁市',20,'N',1),(256,'450200','柳州市',20,'L',1),(257,'450300','桂林市',20,'G',1),(258,'450400','梧州市',20,'W',1),(259,'450500','北海市',20,'B',1),(260,'450600','防城港市',20,'F',1),(261,'450700','钦州市',20,'Q',1),(262,'450800','贵港市',20,'G',1),(263,'450900','玉林市',20,'Y',1),(264,'451000','百色市',20,'B',1),(265,'451100','贺州市',20,'H',1),(266,'451200','河池市',20,'H',1),(267,'451300','来宾市',20,'L',1),(268,'451400','崇左市',20,'C',1),(269,'460100','海口市',21,'H',1),(270,'460200','三亚市',21,'S',1),(271,'460300','三沙市',21,'S',1),(272,'469000','省直辖县级行政区划',21,'S',1),(273,'500100','重庆市',22,'C',1),(274,'500200','重庆县',22,'C',1),(275,'510100','成都市',23,'C',1),(276,'510300','自贡市',23,'Z',1),(277,'510400','攀枝花市',23,'P',1),(278,'510500','泸州市',23,'L',1),(279,'510600','德阳市',23,'D',1),(280,'510700','绵阳市',23,'M',1),(281,'510800','广元市',23,'G',1),(282,'510900','遂宁市',23,'S',1),(283,'511000','内江市',23,'N',1),(284,'511100','乐山市',23,'L',1),(285,'511300','南充市',23,'N',1),(286,'511400','眉山市',23,'M',1),(287,'511500','宜宾市',23,'Y',1),(288,'511600','广安市',23,'G',1),(289,'511700','达州市',23,'D',1),(290,'511800','雅安市',23,'Y',1),(291,'511900','巴中市',23,'B',1),(292,'512000','资阳市',23,'Z',1),(293,'513200','阿坝藏族羌族自治州',23,'A',1),(294,'513300','甘孜藏族自治州',23,'G',1),(295,'513400','凉山彝族自治州',23,'L',1),(296,'520100','贵阳市',24,'G',1),(297,'520200','六盘水市',24,'L',1),(298,'520300','遵义市',24,'Z',1),(299,'520400','安顺市',24,'A',1),(300,'520500','毕节市',24,'B',1),(301,'520600','铜仁市',24,'T',1),(302,'522300','黔西南布依族苗族自治州',24,'Q',1),(303,'522600','黔东南苗族侗族自治州',24,'Q',1),(304,'522700','黔南布依族苗族自治州',24,'Q',1),(305,'530100','昆明市',25,'K',1),(306,'530300','曲靖市',25,'Q',1),(307,'530400','玉溪市',25,'Y',1),(308,'530500','保山市',25,'B',1),(309,'530600','昭通市',25,'Z',1),(310,'530700','丽江市',25,'L',1),(311,'530800','普洱市',25,'P',1),(312,'530900','临沧市',25,'L',1),(313,'532300','楚雄彝族自治州',25,'C',1),(314,'532500','红河哈尼族彝族自治州',25,'H',1),(315,'532600','文山壮族苗族自治州',25,'W',1),(316,'532800','西双版纳傣族自治州',25,'X',1),(317,'532900','大理白族自治州',25,'D',1),(318,'533100','德宏傣族景颇族自治州',25,'D',1),(319,'533300','怒江傈僳族自治州',25,'N',1),(320,'533400','迪庆藏族自治州',25,'D',1),(321,'540100','拉萨市',26,'L',1),(322,'540200','日喀则市',26,'R',1),(323,'542100','昌都地区',26,'C',1),(324,'542200','山南地区',26,'S',1),(325,'542400','那曲地区',26,'N',1),(326,'542500','阿里地区',26,'A',1),(327,'542600','林芝地区',26,'L',1),(328,'610100','西安市',27,'X',1),(329,'610200','铜川市',27,'T',1),(330,'610300','宝鸡市',27,'B',1),(331,'610400','咸阳市',27,'X',1),(332,'610500','渭南市',27,'W',1),(333,'610600','延安市',27,'Y',1),(334,'610700','汉中市',27,'H',1),(335,'610800','榆林市',27,'Y',1),(336,'610900','安康市',27,'A',1),(337,'611000','商洛市',27,'S',1),(338,'620100','兰州市',28,'L',1),(339,'620200','嘉峪关市',28,'J',1),(340,'620300','金昌市',28,'J',1),(341,'620400','白银市',28,'B',1),(342,'620500','天水市',28,'T',1),(343,'620600','武威市',28,'W',1),(344,'620700','张掖市',28,'Z',1),(345,'620800','平凉市',28,'P',1),(346,'620900','酒泉市',28,'J',1),(347,'621000','庆阳市',28,'Q',1),(348,'621100','定西市',28,'D',1),(349,'621200','陇南市',28,'L',1),(350,'622900','临夏回族自治州',28,'L',1),(351,'623000','甘南藏族自治州',28,'G',1),(352,'630100','西宁市',29,'X',1),(353,'630200','海东市',29,'H',1),(354,'632200','海北藏族自治州',29,'H',1),(355,'632300','黄南藏族自治州',29,'H',1),(356,'632500','海南藏族自治州',29,'H',1),(357,'632600','果洛藏族自治州',29,'G',1),(358,'632700','玉树藏族自治州',29,'Y',1),(359,'632800','海西蒙古族藏族自治州',29,'H',1),(360,'640100','银川市',30,'Y',1),(361,'640200','石嘴山市',30,'S',1),(362,'640300','吴忠市',30,'W',1),(363,'640400','固原市',30,'G',1),(364,'640500','中卫市',30,'Z',1),(365,'650100','乌鲁木齐市',31,'W',1),(366,'650200','克拉玛依市',31,'K',1),(367,'652100','吐鲁番地区',31,'T',1),(368,'652200','哈密地区',31,'H',1),(369,'652300','昌吉回族自治州',31,'C',1),(370,'652700','博尔塔拉蒙古自治州',31,'B',1),(371,'652800','巴音郭楞蒙古自治州',31,'B',1),(372,'652900','阿克苏地区',31,'A',1),(373,'653000','克孜勒苏柯尔克孜自治州',31,'K',1),(374,'653100','喀什地区',31,'K',1),(375,'653200','和田地区',31,'H',1),(376,'654000','伊犁哈萨克自治州',31,'Y',1),(377,'654200','塔城地区',31,'T',1),(378,'654300','阿勒泰地区',31,'A',1),(379,'659000','自治区直辖县级行政区划',31,'Z',1),(380,'110101','东城区',35,'D',2),(381,'110102','西城区',35,'X',2),(382,'110105','朝阳区',35,'C',2),(383,'110106','丰台区',35,'F',2),(384,'110107','石景山区',35,'S',2),(385,'110108','海淀区',35,'H',2),(386,'110109','门头沟区',35,'M',2),(387,'110111','房山区',35,'F',2),(388,'110112','通州区',35,'T',2),(389,'110113','顺义区',35,'S',2),(390,'110114','昌平区',35,'C',2),(391,'110115','大兴区',35,'D',2),(392,'110116','怀柔区',35,'H',2),(393,'110117','平谷区',35,'P',2),(394,'110228','密云县',36,'M',2),(395,'110229','延庆县',36,'Y',2),(396,'120101','和平区',37,'H',2),(397,'120102','河东区',37,'H',2),(398,'120103','河西区',37,'H',2),(399,'120104','南开区',37,'N',2),(400,'120105','河北区',37,'H',2),(401,'120106','红桥区',37,'H',2),(402,'120110','东丽区',37,'D',2),(403,'120111','西青区',37,'X',2),(404,'120112','津南区',37,'J',2),(405,'120113','北辰区',37,'B',2),(406,'120114','武清区',37,'W',2),(407,'120115','宝坻区',37,'B',2),(408,'120116','滨海新区',37,'B',2),(409,'120221','宁河县',38,'N',2),(410,'120223','静海县',38,'J',2),(411,'120225','蓟县',38,'J',2),(413,'130102','长安区',39,'C',2),(414,'130104','桥西区',39,'Q',2),(415,'130123','正定县',39,'Z',2),(416,'130125','行唐县',39,'X',2),(417,'130126','灵寿县',39,'L',2),(418,'130127','高邑县',39,'G',2),(419,'130181','辛集市',39,'X',2),(420,'130183','晋州市',39,'J',2),(421,'130184','新乐市',39,'X',2),(422,'130202','路南区',40,'L',2),(423,'130203','路北区',40,'L',2),(424,'130204','古冶区',40,'G',2),(425,'130205','开平区',40,'K',2),(426,'130207','丰南区',40,'F',2),(427,'130208','丰润区',40,'F',2),(428,'130209','曹妃甸区',40,'C',2),(429,'130223','滦县',40,'L',2),(430,'130224','滦南县',40,'L',2),(431,'130225','乐亭县',40,'L',2),(432,'130227','迁西县',40,'Q',2),(433,'130229','玉田县',40,'Y',2),(434,'130281','遵化市',40,'Z',2),(435,'130283','迁安市',40,'Q',2),(436,'130302','海港区',41,'H',2),(437,'130303','山海关区',41,'S',2),(438,'130304','北戴河区',41,'B',2),(439,'130321','青龙满族自治县',41,'Q',2),(440,'130322','昌黎县',41,'C',2),(441,'130323','抚宁县',41,'F',2),(442,'130324','卢龙县',41,'L',2),(443,'130402','邯山区',42,'H',2),(444,'130403','丛台区',42,'C',2),(445,'130404','复兴区',42,'F',2),(446,'130406','峰峰矿区',42,'F',2),(447,'130421','邯郸县',42,'H',2),(448,'130423','临漳县',42,'L',2),(449,'130424','成安县',42,'C',2),(450,'130425','大名县',42,'D',2),(451,'130426','涉县',42,'S',2),(452,'130427','磁县',42,'C',2),(453,'130428','肥乡县',42,'F',2),(454,'130429','永年县',42,'Y',2),(455,'130430','邱县',42,'Q',2),(456,'130431','鸡泽县',42,'J',2),(457,'130432','广平县',42,'G',2),(458,'130433','馆陶县',42,'G',2),(459,'130434','魏县',42,'W',2),(460,'130435','曲周县',42,'Q',2),(461,'130481','武安市',42,'W',2),(462,'130502','桥东区',43,'Q',2),(463,'130521','邢台县',43,'X',2),(464,'130522','临城县',43,'L',2),(465,'130523','内丘县',43,'N',2),(466,'130524','柏乡县',43,'B',2),(467,'130525','隆尧县',43,'L',2),(468,'130526','任县',43,'R',2),(469,'130527','南和县',43,'N',2),(470,'130528','宁晋县',43,'N',2),(471,'130529','巨鹿县',43,'J',2),(472,'130530','新河县',43,'X',2),(473,'130531','广宗县',43,'G',2),(474,'130532','平乡县',43,'P',2),(475,'130533','威县',43,'W',2),(476,'130534','清河县',43,'Q',2),(477,'130535','临西县',43,'L',2),(478,'130581','南宫市',43,'N',2),(479,'130582','沙河市',43,'S',2),(480,'130602','新市区',44,'X',2),(481,'130603','北市区',44,'B',2),(482,'130604','南市区',44,'N',2),(483,'130621','满城县',44,'M',2),(484,'130622','清苑县',44,'Q',2),(485,'130623','涞水县',44,'L',2),(486,'130624','阜平县',44,'F',2),(487,'130625','徐水县',44,'X',2),(488,'130626','定兴县',44,'D',2),(489,'130627','唐县',44,'T',2),(490,'130628','高阳县',44,'G',2),(491,'130629','容城县',44,'R',2),(492,'130630','涞源县',44,'L',2),(493,'130631','望都县',44,'W',2),(494,'130632','安新县',44,'A',2),(495,'130633','易县',44,'Y',2),(496,'130634','曲阳县',44,'Q',2),(497,'130635','蠡县',44,'L',2),(498,'130636','顺平县',44,'S',2),(499,'130637','博野县',44,'B',2),(500,'130638','雄县',44,'X',2),(501,'130681','涿州市',44,'Z',2),(502,'130682','定州市',44,'D',2),(503,'130683','安国市',44,'A',2),(504,'130684','高碑店市',44,'G',2),(505,'130705','宣化区',45,'X',2),(506,'130706','下花园区',45,'X',2),(507,'130721','宣化县',45,'X',2),(508,'130722','张北县',45,'Z',2),(509,'130723','康保县',45,'K',2),(510,'130724','沽源县',45,'G',2),(511,'130725','尚义县',45,'S',2),(512,'130726','蔚县',45,'W',2),(513,'130727','阳原县',45,'Y',2),(514,'130728','怀安县',45,'H',2),(515,'130729','万全县',45,'W',2),(516,'130730','怀来县',45,'H',2),(517,'130731','涿鹿县',45,'Z',2),(518,'130732','赤城县',45,'C',2),(519,'130733','崇礼县',45,'C',2),(520,'130802','双桥区',46,'S',2),(521,'130803','双滦区',46,'S',2),(522,'130804','鹰手营子矿区',46,'Y',2),(523,'130821','承德县',46,'C',2),(524,'130822','兴隆县',46,'X',2),(525,'130823','平泉县',46,'P',2),(526,'130824','滦平县',46,'L',2),(527,'130825','隆化县',46,'L',2),(528,'130826','丰宁满族自治县',46,'F',2),(529,'130827','宽城满族自治县',46,'K',2),(530,'130828','围场满族蒙古族自治县',46,'W',2),(531,'130903','运河区',47,'Y',2),(532,'130921','沧县',47,'C',2),(533,'130922','青县',47,'Q',2),(534,'130923','东光县',47,'D',2),(535,'130924','海兴县',47,'H',2),(536,'130925','盐山县',47,'Y',2),(537,'130926','肃宁县',47,'S',2),(538,'130927','南皮县',47,'N',2),(539,'130928','吴桥县',47,'W',2),(540,'130929','献县',47,'X',2),(541,'130930','孟村回族自治县',47,'M',2),(542,'130981','泊头市',47,'B',2),(543,'130982','任丘市',47,'R',2),(544,'130983','黄骅市',47,'H',2),(545,'130984','河间市',47,'H',2),(546,'131002','安次区',48,'A',2),(547,'131003','广阳区',48,'G',2),(548,'131022','固安县',48,'G',2),(549,'131023','永清县',48,'Y',2),(550,'131024','香河县',48,'X',2),(551,'131025','大城县',48,'D',2),(552,'131026','文安县',48,'W',2),(553,'131028','大厂回族自治县',48,'D',2),(554,'131081','霸州市',48,'B',2),(555,'131082','三河市',48,'S',2),(556,'131102','桃城区',49,'T',2),(557,'131121','枣强县',49,'Z',2),(558,'131122','武邑县',49,'W',2),(559,'131123','武强县',49,'W',2),(560,'131124','饶阳县',49,'R',2),(561,'131125','安平县',49,'A',2),(562,'131126','故城县',49,'G',2),(563,'131127','景县',49,'J',2),(564,'131128','阜城县',49,'F',2),(565,'131181','冀州市',49,'J',2),(566,'131182','深州市',49,'S',2),(567,'140105','小店区',50,'X',2),(568,'140106','迎泽区',50,'Y',2),(569,'140107','杏花岭区',50,'X',2),(570,'140108','尖草坪区',50,'J',2),(571,'140109','万柏林区',50,'W',2),(572,'140110','晋源区',50,'J',2),(573,'140121','清徐县',50,'Q',2),(574,'140122','阳曲县',50,'Y',2),(575,'140123','娄烦县',50,'L',2),(576,'140181','古交市',50,'G',2),(577,'140202','城区',51,'C',2),(578,'140203','矿区',51,'K',2),(579,'140211','南郊区',51,'N',2),(580,'140212','新荣区',51,'X',2),(581,'140221','阳高县',51,'Y',2),(582,'140222','天镇县',51,'T',2),(583,'140223','广灵县',51,'G',2),(584,'140224','灵丘县',51,'L',2),(585,'140225','浑源县',51,'H',2),(586,'140226','左云县',51,'Z',2),(587,'140227','大同县',51,'D',2),(588,'140311','郊区',52,'J',2),(589,'140321','平定县',52,'P',2),(590,'140322','盂县',52,'Y',2),(591,'140421','长治县',53,'C',2),(592,'140423','襄垣县',53,'X',2),(593,'140424','屯留县',53,'T',2),(594,'140425','平顺县',53,'P',2),(595,'140426','黎城县',53,'L',2),(596,'140427','壶关县',53,'H',2),(597,'140428','长子县',53,'C',2),(598,'140429','武乡县',53,'W',2),(599,'140430','沁县',53,'Q',2),(600,'140431','沁源县',53,'Q',2),(601,'140481','潞城市',53,'L',2),(602,'140521','沁水县',54,'Q',2),(603,'140522','阳城县',54,'Y',2),(604,'140524','陵川县',54,'L',2),(605,'140525','泽州县',54,'Z',2),(606,'140581','高平市',54,'G',2),(607,'140602','朔城区',55,'S',2),(608,'140603','平鲁区',55,'P',2),(609,'140621','山阴县',55,'S',2),(610,'140622','应县',55,'Y',2),(611,'140623','右玉县',55,'Y',2),(612,'140624','怀仁县',55,'H',2),(613,'140702','榆次区',56,'Y',2),(614,'140721','榆社县',56,'Y',2),(615,'140722','左权县',56,'Z',2),(616,'140723','和顺县',56,'H',2),(617,'140724','昔阳县',56,'X',2),(618,'140725','寿阳县',56,'S',2),(619,'140726','太谷县',56,'T',2),(620,'140727','祁县',56,'Q',2),(621,'140728','平遥县',56,'P',2),(622,'140729','灵石县',56,'L',2),(623,'140781','介休市',56,'J',2),(624,'140802','盐湖区',57,'Y',2),(625,'140821','临猗县',57,'L',2),(626,'140822','万荣县',57,'W',2),(627,'140823','闻喜县',57,'W',2),(628,'140824','稷山县',57,'J',2),(629,'140825','新绛县',57,'X',2),(630,'140826','绛县',57,'J',2),(631,'140827','垣曲县',57,'Y',2),(632,'140828','夏县',57,'X',2),(633,'140829','平陆县',57,'P',2),(634,'140830','芮城县',57,'R',2),(635,'140881','永济市',57,'Y',2),(636,'140882','河津市',57,'H',2),(637,'140902','忻府区',58,'X',2),(638,'140921','定襄县',58,'D',2),(639,'140922','五台县',58,'W',2),(640,'140923','代县',58,'D',2),(641,'140924','繁峙县',58,'F',2),(642,'140925','宁武县',58,'N',2),(643,'140926','静乐县',58,'J',2),(644,'140927','神池县',58,'S',2),(645,'140928','五寨县',58,'W',2),(646,'140929','岢岚县',58,'K',2),(647,'140930','河曲县',58,'H',2),(648,'140931','保德县',58,'B',2),(649,'140932','偏关县',58,'P',2),(650,'140981','原平市',58,'Y',2),(651,'141002','尧都区',59,'Y',2),(652,'141021','曲沃县',59,'Q',2),(653,'141022','翼城县',59,'Y',2),(654,'141023','襄汾县',59,'X',2),(655,'141024','洪洞县',59,'H',2),(656,'141025','古县',59,'G',2),(657,'141026','安泽县',59,'A',2),(658,'141027','浮山县',59,'F',2),(659,'141028','吉县',59,'J',2),(660,'141029','乡宁县',59,'X',2),(661,'141030','大宁县',59,'D',2),(662,'141031','隰县',59,'X',2),(663,'141032','永和县',59,'Y',2),(664,'141033','蒲县',59,'P',2),(665,'141034','汾西县',59,'F',2),(666,'141081','侯马市',59,'H',2),(667,'141082','霍州市',59,'H',2),(668,'141102','离石区',60,'L',2),(669,'141121','文水县',60,'W',2),(670,'141122','交城县',60,'J',2),(671,'141123','兴县',60,'X',2),(672,'141124','临县',60,'L',2),(673,'141125','柳林县',60,'L',2),(674,'141126','石楼县',60,'S',2),(675,'141127','岚县',60,'L',2),(676,'141128','方山县',60,'F',2),(677,'141129','中阳县',60,'Z',2),(678,'141130','交口县',60,'J',2),(679,'141181','孝义市',60,'X',2),(680,'141182','汾阳市',60,'F',2),(681,'150102','新城区',61,'X',2),(682,'150103','回民区',61,'H',2),(683,'150104','玉泉区',61,'Y',2),(684,'150105','赛罕区',61,'S',2),(685,'150121','土默特左旗',61,'T',2),(686,'150122','托克托县',61,'T',2),(687,'150123','和林格尔县',61,'H',2),(688,'150124','清水河县',61,'Q',2),(689,'150125','武川县',61,'W',2),(690,'150202','东河区',62,'D',2),(691,'150203','昆都仑区',62,'K',2),(692,'150204','青山区',62,'Q',2),(693,'150205','石拐区',62,'S',2),(694,'150206','白云鄂博矿区',62,'B',2),(695,'150207','九原区',62,'J',2),(696,'150221','土默特右旗',62,'T',2),(697,'150222','固阳县',62,'G',2),(698,'150223','达尔罕茂明安联合旗',62,'D',2),(699,'150302','海勃湾区',63,'H',2),(700,'150303','海南区',63,'H',2),(701,'150304','乌达区',63,'W',2),(702,'150402','红山区',64,'H',2),(703,'150403','元宝山区',64,'Y',2),(704,'150404','松山区',64,'S',2),(705,'150421','阿鲁科尔沁旗',64,'A',2),(706,'150422','巴林左旗',64,'B',2),(707,'150423','巴林右旗',64,'B',2),(708,'150424','林西县',64,'L',2),(709,'150425','克什克腾旗',64,'K',2),(710,'150426','翁牛特旗',64,'W',2),(711,'150428','喀喇沁旗',64,'K',2),(712,'150429','宁城县',64,'N',2),(713,'150430','敖汉旗',64,'A',2),(714,'150502','科尔沁区',65,'K',2),(715,'150521','科尔沁左翼中旗',65,'K',2),(716,'150522','科尔沁左翼后旗',65,'K',2),(717,'150523','开鲁县',65,'K',2),(718,'150524','库伦旗',65,'K',2),(719,'150525','奈曼旗',65,'N',2),(720,'150526','扎鲁特旗',65,'Z',2),(721,'150581','霍林郭勒市',65,'H',2),(722,'150602','东胜区',66,'D',2),(723,'150621','达拉特旗',66,'D',2),(724,'150622','准格尔旗',66,'Z',2),(725,'150623','鄂托克前旗',66,'E',2),(726,'150624','鄂托克旗',66,'E',2),(727,'150625','杭锦旗',66,'H',2),(728,'150626','乌审旗',66,'W',2),(729,'150627','伊金霍洛旗',66,'Y',2),(730,'150702','海拉尔区',67,'H',2),(731,'150703','扎赉诺尔区',67,'Z',2),(732,'150721','阿荣旗',67,'A',2),(733,'150722','莫力达瓦达斡尔族自治旗',67,'M',2),(734,'150723','鄂伦春自治旗',67,'E',2),(735,'150724','鄂温克族自治旗',67,'E',2),(736,'150725','陈巴尔虎旗',67,'C',2),(737,'150726','新巴尔虎左旗',67,'X',2),(738,'150727','新巴尔虎右旗',67,'X',2),(739,'150781','满洲里市',67,'M',2),(740,'150782','牙克石市',67,'Y',2),(741,'150783','扎兰屯市',67,'Z',2),(742,'150784','额尔古纳市',67,'E',2),(743,'150785','根河市',67,'G',2),(744,'150802','临河区',68,'L',2),(745,'150821','五原县',68,'W',2),(746,'150822','磴口县',68,'D',2),(747,'150823','乌拉特前旗',68,'W',2),(748,'150824','乌拉特中旗',68,'W',2),(749,'150825','乌拉特后旗',68,'W',2),(750,'150826','杭锦后旗',68,'H',2),(751,'150902','集宁区',69,'J',2),(752,'150921','卓资县',69,'Z',2),(753,'150922','化德县',69,'H',2),(754,'150923','商都县',69,'S',2),(755,'150924','兴和县',69,'X',2),(756,'150925','凉城县',69,'L',2),(757,'150926','察哈尔右翼前旗',69,'C',2),(758,'150927','察哈尔右翼中旗',69,'C',2),(759,'150928','察哈尔右翼后旗',69,'C',2),(760,'150929','四子王旗',69,'S',2),(761,'150981','丰镇市',69,'F',2),(762,'152201','乌兰浩特市',70,'W',2),(763,'152202','阿尔山市',70,'A',2),(764,'152221','科尔沁右翼前旗',70,'K',2),(765,'152222','科尔沁右翼中旗',70,'K',2),(766,'152223','扎赉特旗',70,'Z',2),(767,'152224','突泉县',70,'T',2),(768,'152501','二连浩特市',71,'E',2),(769,'152502','锡林浩特市',71,'X',2),(770,'152522','阿巴嘎旗',71,'A',2),(771,'152523','苏尼特左旗',71,'S',2),(772,'152524','苏尼特右旗',71,'S',2),(773,'152525','东乌珠穆沁旗',71,'D',2),(774,'152526','西乌珠穆沁旗',71,'X',2),(775,'152527','太仆寺旗',71,'T',2),(776,'152528','镶黄旗',71,'X',2),(777,'152529','正镶白旗',71,'Z',2),(778,'152530','正蓝旗',71,'Z',2),(779,'152531','多伦县',71,'D',2),(780,'152921','阿拉善左旗',72,'A',2),(781,'152922','阿拉善右旗',72,'A',2),(782,'152923','额济纳旗',72,'E',2),(783,'210103','沈河区',73,'S',2),(784,'210104','大东区',73,'D',2),(785,'210105','皇姑区',73,'H',2),(786,'210106','铁西区',73,'T',2),(787,'210111','苏家屯区',73,'S',2),(788,'210112','浑南区',73,'H',2),(789,'210113','沈北新区',73,'S',2),(790,'210114','于洪区',73,'Y',2),(791,'210122','辽中县',73,'L',2),(792,'210123','康平县',73,'K',2),(793,'210124','法库县',73,'F',2),(794,'210181','新民市',73,'X',2),(795,'210202','中山区',74,'Z',2),(796,'210203','西岗区',74,'X',2),(797,'210204','沙河口区',74,'S',2),(798,'210211','甘井子区',74,'G',2),(799,'210212','旅顺口区',74,'L',2),(800,'210213','金州区',74,'J',2),(801,'210224','长海县',74,'C',2),(802,'210281','瓦房店市',74,'W',2),(803,'210282','普兰店市',74,'P',2),(804,'210283','庄河市',74,'Z',2),(805,'210302','铁东区',75,'T',2),(806,'210304','立山区',75,'L',2),(807,'210311','千山区',75,'Q',2),(808,'210321','台安县',75,'T',2),(809,'210323','岫岩满族自治县',75,'X',2),(810,'210381','海城市',75,'H',2),(811,'210402','新抚区',76,'X',2),(812,'210403','东洲区',76,'D',2),(813,'210404','望花区',76,'W',2),(814,'210411','顺城区',76,'S',2),(815,'210421','抚顺县',76,'F',2),(816,'210422','新宾满族自治县',76,'X',2),(817,'210423','清原满族自治县',76,'Q',2),(818,'210502','平山区',77,'P',2),(819,'210503','溪湖区',77,'X',2),(820,'210504','明山区',77,'M',2),(821,'210505','南芬区',77,'N',2),(822,'210521','本溪满族自治县',77,'B',2),(823,'210522','桓仁满族自治县',77,'H',2),(824,'210602','元宝区',78,'Y',2),(825,'210603','振兴区',78,'Z',2),(826,'210604','振安区',78,'Z',2),(827,'210624','宽甸满族自治县',78,'K',2),(828,'210681','东港市',78,'D',2),(829,'210682','凤城市',78,'F',2),(830,'210702','古塔区',79,'G',2),(831,'210703','凌河区',79,'L',2),(832,'210711','太和区',79,'T',2),(833,'210726','黑山县',79,'H',2),(834,'210727','义县',79,'Y',2),(835,'210781','凌海市',79,'L',2),(836,'210782','北镇市',79,'B',2),(837,'210802','站前区',80,'Z',2),(838,'210803','西市区',80,'X',2),(839,'210804','鲅鱼圈区',80,'B',2),(840,'210811','老边区',80,'L',2),(841,'210881','盖州市',80,'G',2),(842,'210882','大石桥市',80,'D',2),(843,'210902','海州区',81,'H',2),(844,'210903','新邱区',81,'X',2),(845,'210904','太平区',81,'T',2),(846,'210905','清河门区',81,'Q',2),(847,'210911','细河区',81,'X',2),(848,'210921','阜新蒙古族自治县',81,'F',2),(849,'210922','彰武县',81,'Z',2),(850,'211002','白塔区',82,'B',2),(851,'211003','文圣区',82,'W',2),(852,'211004','宏伟区',82,'H',2),(853,'211005','弓长岭区',82,'G',2),(854,'211011','太子河区',82,'T',2),(855,'211021','辽阳县',82,'L',2),(856,'211081','灯塔市',82,'D',2),(858,'211102','双台子区',83,'S',2),(859,'211103','兴隆台区',83,'X',2),(860,'211121','大洼县',83,'D',2),(861,'211122','盘山县',83,'P',2),(862,'211202','银州区',84,'Y',2),(863,'211204','清河区',84,'Q',2),(864,'211221','铁岭县',84,'T',2),(865,'211223','西丰县',84,'X',2),(866,'211224','昌图县',84,'C',2),(867,'211281','调兵山市',84,'D',2),(868,'211282','开原市',84,'K',2),(869,'211302','双塔区',85,'S',2),(870,'211303','龙城区',85,'L',2),(871,'211321','朝阳县',85,'C',2),(872,'211322','建平县',85,'J',2),(873,'211324','喀喇沁左翼蒙古族自治县',85,'K',2),(874,'211381','北票市',85,'B',2),(875,'211382','凌源市',85,'L',2),(876,'211402','连山区',86,'L',2),(877,'211403','龙港区',86,'L',2),(878,'211404','南票区',86,'N',2),(879,'211421','绥中县',86,'S',2),(880,'211422','建昌县',86,'J',2),(881,'211481','兴城市',86,'X',2),(882,'220102','南关区',87,'N',2),(883,'220103','宽城区',87,'K',2),(884,'220105','二道区',87,'E',2),(885,'220106','绿园区',87,'L',2),(886,'220112','双阳区',87,'S',2),(887,'220113','九台区',87,'J',2),(888,'220122','农安县',87,'N',2),(889,'220182','榆树市',87,'Y',2),(890,'220183','德惠市',87,'D',2),(891,'220202','昌邑区',88,'C',2),(892,'220203','龙潭区',88,'L',2),(893,'220204','船营区',88,'C',2),(894,'220211','丰满区',88,'F',2),(895,'220221','永吉县',88,'Y',2),(896,'220281','蛟河市',88,'J',2),(897,'220282','桦甸市',88,'H',2),(898,'220283','舒兰市',88,'S',2),(899,'220284','磐石市',88,'P',2),(900,'220322','梨树县',89,'L',2),(901,'220323','伊通满族自治县',89,'Y',2),(902,'220381','公主岭市',89,'G',2),(903,'220382','双辽市',89,'S',2),(904,'220402','龙山区',90,'L',2),(905,'220403','西安区',90,'X',2),(906,'220421','东丰县',90,'D',2),(907,'220422','东辽县',90,'D',2),(908,'220502','东昌区',91,'D',2),(909,'220503','二道江区',91,'E',2),(910,'220521','通化县',91,'T',2),(911,'220523','辉南县',91,'H',2),(912,'220524','柳河县',91,'L',2),(913,'220581','梅河口市',91,'M',2),(914,'220582','集安市',91,'J',2),(915,'220602','浑江区',92,'H',2),(916,'220605','江源区',92,'J',2),(917,'220621','抚松县',92,'F',2),(918,'220622','靖宇县',92,'J',2),(919,'220623','长白朝鲜族自治县',92,'C',2),(920,'220681','临江市',92,'L',2),(921,'220702','宁江区',93,'N',2),(922,'220721','前郭尔罗斯蒙古族自治县',93,'Q',2),(923,'220722','长岭县',93,'C',2),(924,'220723','乾安县',93,'Q',2),(925,'220781','扶余市',93,'F',2),(926,'220802','洮北区',94,'T',2),(927,'220821','镇赉县',94,'Z',2),(928,'220822','通榆县',94,'T',2),(929,'220881','洮南市',94,'T',2),(930,'220882','大安市',94,'D',2),(931,'222401','延吉市',95,'Y',2),(932,'222402','图们市',95,'T',2),(933,'222403','敦化市',95,'D',2),(934,'222404','珲春市',95,'H',2),(935,'222405','龙井市',95,'L',2),(936,'222406','和龙市',95,'H',2),(937,'222424','汪清县',95,'W',2),(938,'222426','安图县',95,'A',2),(939,'230102','道里区',96,'D',2),(940,'230103','南岗区',96,'N',2),(941,'230104','道外区',96,'D',2),(942,'230108','平房区',96,'P',2),(943,'230109','松北区',96,'S',2),(944,'230110','香坊区',96,'X',2),(945,'230111','呼兰区',96,'H',2),(946,'230112','阿城区',96,'A',2),(947,'230123','依兰县',96,'Y',2),(948,'230124','方正县',96,'F',2),(949,'230125','宾县',96,'B',2),(950,'230126','巴彦县',96,'B',2),(951,'230127','木兰县',96,'M',2),(952,'230128','通河县',96,'T',2),(953,'230129','延寿县',96,'Y',2),(954,'230182','双城市',96,'S',2),(955,'230183','尚志市',96,'S',2),(956,'230184','五常市',96,'W',2),(957,'230202','龙沙区',97,'L',2),(958,'230203','建华区',97,'J',2),(959,'230204','铁锋区',97,'T',2),(960,'230205','昂昂溪区',97,'A',2),(961,'230206','富拉尔基区',97,'F',2),(962,'230207','碾子山区',97,'N',2),(963,'230208','梅里斯达斡尔族区',97,'M',2),(964,'230221','龙江县',97,'L',2),(965,'230223','依安县',97,'Y',2),(966,'230224','泰来县',97,'T',2),(967,'230225','甘南县',97,'G',2),(968,'230227','富裕县',97,'F',2),(969,'230229','克山县',97,'K',2),(970,'230230','克东县',97,'K',2),(971,'230231','拜泉县',97,'B',2),(972,'230281','讷河市',97,'N',2),(973,'230302','鸡冠区',98,'J',2),(974,'230303','恒山区',98,'H',2),(975,'230304','滴道区',98,'D',2),(976,'230305','梨树区',98,'L',2),(977,'230306','城子河区',98,'C',2),(978,'230307','麻山区',98,'M',2),(979,'230321','鸡东县',98,'J',2),(980,'230381','虎林市',98,'H',2),(981,'230382','密山市',98,'M',2),(982,'230402','向阳区',99,'X',2),(983,'230403','工农区',99,'G',2),(984,'230404','南山区',99,'N',2),(985,'230405','兴安区',99,'X',2),(986,'230406','东山区',99,'D',2),(987,'230407','兴山区',99,'X',2),(988,'230421','萝北县',99,'L',2),(989,'230422','绥滨县',99,'S',2),(990,'230502','尖山区',100,'J',2),(991,'230503','岭东区',100,'L',2),(992,'230505','四方台区',100,'S',2),(993,'230506','宝山区',100,'B',2),(994,'230521','集贤县',100,'J',2),(995,'230522','友谊县',100,'Y',2),(996,'230523','宝清县',100,'B',2),(997,'230524','饶河县',100,'R',2),(998,'230602','萨尔图区',101,'S',2),(999,'230603','龙凤区',101,'L',2),(1000,'230604','让胡路区',101,'R',2),(1001,'230605','红岗区',101,'H',2),(1002,'230606','大同区',101,'D',2),(1003,'230621','肇州县',101,'Z',2),(1004,'230622','肇源县',101,'Z',2),(1005,'230623','林甸县',101,'L',2),(1006,'230624','杜尔伯特蒙古族自治县',101,'D',2),(1007,'230702','伊春区',102,'Y',2),(1008,'230703','南岔区',102,'N',2),(1009,'230704','友好区',102,'Y',2),(1010,'230705','西林区',102,'X',2),(1011,'230706','翠峦区',102,'C',2),(1012,'230707','新青区',102,'X',2),(1013,'230708','美溪区',102,'M',2),(1014,'230709','金山屯区',102,'J',2),(1015,'230710','五营区',102,'W',2),(1016,'230711','乌马河区',102,'W',2),(1017,'230712','汤旺河区',102,'T',2),(1018,'230713','带岭区',102,'D',2),(1019,'230714','乌伊岭区',102,'W',2),(1020,'230715','红星区',102,'H',2),(1021,'230716','上甘岭区',102,'S',2),(1022,'230722','嘉荫县',102,'J',2),(1023,'230781','铁力市',102,'T',2),(1024,'230804','前进区',103,'Q',2),(1025,'230805','东风区',103,'D',2),(1026,'230822','桦南县',103,'H',2),(1027,'230826','桦川县',103,'H',2),(1028,'230828','汤原县',103,'T',2),(1029,'230833','抚远县',103,'F',2),(1030,'230881','同江市',103,'T',2),(1031,'230882','富锦市',103,'F',2),(1032,'230902','新兴区',104,'X',2),(1033,'230903','桃山区',104,'T',2),(1034,'230904','茄子河区',104,'Q',2),(1035,'230921','勃利县',104,'B',2),(1036,'231002','东安区',105,'D',2),(1037,'231003','阳明区',105,'Y',2),(1038,'231004','爱民区',105,'A',2),(1039,'231024','东宁县',105,'D',2),(1040,'231025','林口县',105,'L',2),(1041,'231081','绥芬河市',105,'S',2),(1042,'231083','海林市',105,'H',2),(1043,'231084','宁安市',105,'N',2),(1044,'231085','穆棱市',105,'M',2),(1045,'231102','爱辉区',106,'A',2),(1046,'231121','嫩江县',106,'N',2),(1047,'231123','逊克县',106,'X',2),(1048,'231124','孙吴县',106,'S',2),(1049,'231181','北安市',106,'B',2),(1050,'231182','五大连池市',106,'W',2),(1051,'231202','北林区',107,'B',2),(1052,'231221','望奎县',107,'W',2),(1053,'231222','兰西县',107,'L',2),(1054,'231223','青冈县',107,'Q',2),(1055,'231224','庆安县',107,'Q',2),(1056,'231225','明水县',107,'M',2),(1057,'231226','绥棱县',107,'S',2),(1058,'231281','安达市',107,'A',2),(1059,'231282','肇东市',107,'Z',2),(1060,'231283','海伦市',107,'H',2),(1061,'232721','呼玛县',108,'H',2),(1062,'232722','塔河县',108,'T',2),(1063,'232723','漠河县',108,'M',2),(1064,'310101','黄浦区',109,'H',2),(1065,'310104','徐汇区',109,'X',2),(1066,'310105','长宁区',109,'C',2),(1067,'310106','静安区',109,'J',2),(1068,'310107','普陀区',109,'P',2),(1069,'310108','闸北区',109,'Z',2),(1070,'310109','虹口区',109,'H',2),(1071,'310110','杨浦区',109,'Y',2),(1072,'310112','闵行区',109,'M',2),(1073,'310114','嘉定区',109,'J',2),(1074,'310115','浦东新区',109,'P',2),(1075,'310116','金山区',109,'J',2),(1076,'310117','松江区',109,'S',2),(1077,'310118','青浦区',109,'Q',2),(1078,'310120','奉贤区',109,'F',2),(1079,'310230','崇明县',110,'C',2),(1080,'320102','玄武区',111,'X',2),(1081,'320104','秦淮区',111,'Q',2),(1082,'320105','建邺区',111,'J',2),(1083,'320106','鼓楼区',111,'G',2),(1084,'320111','浦口区',111,'P',2),(1085,'320113','栖霞区',111,'Q',2),(1086,'320114','雨花台区',111,'Y',2),(1087,'320115','江宁区',111,'J',2),(1088,'320116','六合区',111,'L',2),(1089,'320117','溧水区',111,'L',2),(1090,'320118','高淳区',111,'G',2),(1091,'320202','崇安区',112,'C',2),(1092,'320203','南长区',112,'N',2),(1093,'320204','北塘区',112,'B',2),(1094,'320205','锡山区',112,'X',2),(1095,'320206','惠山区',112,'H',2),(1096,'320211','滨湖区',112,'B',2),(1097,'320281','江阴市',112,'J',2),(1098,'320282','宜兴市',112,'Y',2),(1099,'320303','云龙区',113,'Y',2),(1100,'320305','贾汪区',113,'J',2),(1101,'320311','泉山区',113,'Q',2),(1102,'320312','铜山区',113,'T',2),(1103,'320321','丰县',113,'F',2),(1104,'320322','沛县',113,'P',2),(1105,'320324','睢宁县',113,'S',2),(1106,'320381','新沂市',113,'X',2),(1107,'320382','邳州市',113,'P',2),(1108,'320402','天宁区',114,'T',2),(1109,'320404','钟楼区',114,'Z',2),(1110,'320405','戚墅堰区',114,'Q',2),(1111,'320411','新北区',114,'X',2),(1112,'320412','武进区',114,'W',2),(1113,'320481','溧阳市',114,'L',2),(1114,'320482','金坛市',114,'J',2),(1115,'320505','虎丘区',115,'H',2),(1116,'320506','吴中区',115,'W',2),(1117,'320507','相城区',115,'X',2),(1118,'320508','姑苏区',115,'G',2),(1119,'320509','吴江区',115,'W',2),(1120,'320581','常熟市',115,'C',2),(1121,'320582','张家港市',115,'Z',2),(1122,'320583','昆山市',115,'K',2),(1123,'320585','太仓市',115,'T',2),(1124,'320602','崇川区',116,'C',2),(1125,'320611','港闸区',116,'G',2),(1126,'320612','通州区',116,'T',2),(1127,'320621','海安县',116,'H',2),(1128,'320623','如东县',116,'R',2),(1129,'320681','启东市',116,'Q',2),(1130,'320682','如皋市',116,'R',2),(1131,'320684','海门市',116,'H',2),(1132,'320703','连云区',117,'L',2),(1133,'320707','赣榆区',117,'G',2),(1134,'320722','东海县',117,'D',2),(1135,'320723','灌云县',117,'G',2),(1136,'320724','灌南县',117,'G',2),(1137,'320803','淮安区',118,'H',2),(1138,'320804','淮阴区',118,'H',2),(1139,'320811','清浦区',118,'Q',2),(1140,'320826','涟水县',118,'L',2),(1141,'320829','洪泽县',118,'H',2),(1142,'320830','盱眙县',118,'X',2),(1143,'320831','金湖县',118,'J',2),(1144,'320902','亭湖区',119,'T',2),(1145,'320903','盐都区',119,'Y',2),(1146,'320921','响水县',119,'X',2),(1147,'320922','滨海县',119,'B',2),(1148,'320923','阜宁县',119,'F',2),(1149,'320924','射阳县',119,'S',2),(1150,'320925','建湖县',119,'J',2),(1151,'320981','东台市',119,'D',2),(1152,'320982','大丰市',119,'D',2),(1153,'321002','广陵区',120,'G',2),(1154,'321003','邗江区',120,'H',2),(1155,'321012','江都区',120,'J',2),(1156,'321023','宝应县',120,'B',2),(1157,'321081','仪征市',120,'Y',2),(1158,'321084','高邮市',120,'G',2),(1159,'321102','京口区',121,'J',2),(1160,'321111','润州区',121,'R',2),(1161,'321112','丹徒区',121,'D',2),(1162,'321181','丹阳市',121,'D',2),(1163,'321182','扬中市',121,'Y',2),(1164,'321183','句容市',121,'J',2),(1165,'321202','海陵区',122,'H',2),(1166,'321203','高港区',122,'G',2),(1167,'321204','姜堰区',122,'J',2),(1168,'321281','兴化市',122,'X',2),(1169,'321282','靖江市',122,'J',2),(1170,'321283','泰兴市',122,'T',2),(1171,'321302','宿城区',123,'S',2),(1172,'321311','宿豫区',123,'S',2),(1173,'321322','沭阳县',123,'S',2),(1174,'321323','泗阳县',123,'S',2),(1175,'321324','泗洪县',123,'S',2),(1176,'330102','上城区',124,'S',2),(1177,'330103','下城区',124,'X',2),(1178,'330104','江干区',124,'J',2),(1179,'330105','拱墅区',124,'G',2),(1180,'330106','西湖区',124,'X',2),(1181,'330108','滨江区',124,'B',2),(1182,'330109','萧山区',124,'X',2),(1183,'330110','余杭区',124,'Y',2),(1184,'330122','桐庐县',124,'T',2),(1185,'330127','淳安县',124,'C',2),(1186,'330182','建德市',124,'J',2),(1187,'330183','富阳市',124,'F',2),(1188,'330185','临安市',124,'L',2),(1189,'330203','海曙区',125,'H',2),(1190,'330204','江东区',125,'J',2),(1191,'330205','江北区',125,'J',2),(1192,'330206','北仑区',125,'B',2),(1193,'330211','镇海区',125,'Z',2),(1194,'330212','鄞州区',125,'Y',2),(1195,'330225','象山县',125,'X',2),(1196,'330226','宁海县',125,'N',2),(1197,'330281','余姚市',125,'Y',2),(1198,'330282','慈溪市',125,'C',2),(1199,'330283','奉化市',125,'F',2),(1200,'330302','鹿城区',126,'L',2),(1201,'330303','龙湾区',126,'L',2),(1202,'330304','瓯海区',126,'O',2),(1203,'330322','洞头县',126,'D',2),(1204,'330324','永嘉县',126,'Y',2),(1205,'330326','平阳县',126,'P',2),(1206,'330327','苍南县',126,'C',2),(1207,'330328','文成县',126,'W',2),(1208,'330329','泰顺县',126,'T',2),(1209,'330381','瑞安市',126,'R',2),(1210,'330382','乐清市',126,'L',2),(1211,'330402','南湖区',127,'N',2),(1212,'330411','秀洲区',127,'X',2),(1213,'330421','嘉善县',127,'J',2),(1214,'330424','海盐县',127,'H',2),(1215,'330481','海宁市',127,'H',2),(1216,'330482','平湖市',127,'P',2),(1217,'330483','桐乡市',127,'T',2),(1218,'330502','吴兴区',128,'W',2),(1219,'330503','南浔区',128,'N',2),(1220,'330521','德清县',128,'D',2),(1221,'330522','长兴县',128,'C',2),(1222,'330523','安吉县',128,'A',2),(1223,'330602','越城区',129,'Y',2),(1224,'330603','柯桥区',129,'K',2),(1225,'330604','上虞区',129,'S',2),(1226,'330624','新昌县',129,'X',2),(1227,'330681','诸暨市',129,'Z',2),(1228,'330683','嵊州市',129,'S',2),(1229,'330702','婺城区',130,'W',2),(1230,'330703','金东区',130,'J',2),(1231,'330723','武义县',130,'W',2),(1232,'330726','浦江县',130,'P',2),(1233,'330727','磐安县',130,'P',2),(1234,'330781','兰溪市',130,'L',2),(1235,'330782','义乌市',130,'Y',2),(1236,'330783','东阳市',130,'D',2),(1237,'330784','永康市',130,'Y',2),(1238,'330802','柯城区',131,'K',2),(1239,'330803','衢江区',131,'Q',2),(1240,'330822','常山县',131,'C',2),(1241,'330824','开化县',131,'K',2),(1242,'330825','龙游县',131,'L',2),(1243,'330881','江山市',131,'J',2),(1244,'330902','定海区',132,'D',2),(1245,'330921','岱山县',132,'D',2),(1246,'330922','嵊泗县',132,'S',2),(1247,'331002','椒江区',133,'J',2),(1248,'331003','黄岩区',133,'H',2),(1249,'331004','路桥区',133,'L',2),(1250,'331021','玉环县',133,'Y',2),(1251,'331022','三门县',133,'S',2),(1252,'331023','天台县',133,'T',2),(1253,'331024','仙居县',133,'X',2),(1254,'331081','温岭市',133,'W',2),(1255,'331082','临海市',133,'L',2),(1256,'331102','莲都区',134,'L',2),(1257,'331121','青田县',134,'Q',2),(1258,'331122','缙云县',134,'J',2),(1259,'331123','遂昌县',134,'S',2),(1260,'331124','松阳县',134,'S',2),(1261,'331125','云和县',134,'Y',2),(1262,'331126','庆元县',134,'Q',2),(1263,'331127','景宁畲族自治县',134,'J',2),(1264,'331181','龙泉市',134,'L',2),(1265,'340102','瑶海区',135,'Y',2),(1266,'340103','庐阳区',135,'L',2),(1267,'340104','蜀山区',135,'S',2),(1268,'340111','包河区',135,'B',2),(1269,'340121','长丰县',135,'C',2),(1270,'340122','肥东县',135,'F',2),(1271,'340123','肥西县',135,'F',2),(1272,'340124','庐江县',135,'L',2),(1273,'340181','巢湖市',135,'C',2),(1274,'340202','镜湖区',136,'J',2),(1275,'340203','弋江区',136,'Y',2),(1276,'340207','鸠江区',136,'J',2),(1277,'340208','三山区',136,'S',2),(1278,'340221','芜湖县',136,'W',2),(1279,'340222','繁昌县',136,'F',2),(1280,'340223','南陵县',136,'N',2),(1281,'340225','无为县',136,'W',2),(1282,'340302','龙子湖区',137,'L',2),(1283,'340303','蚌山区',137,'B',2),(1284,'340304','禹会区',137,'Y',2),(1285,'340311','淮上区',137,'H',2),(1286,'340321','怀远县',137,'H',2),(1287,'340322','五河县',137,'W',2),(1288,'340323','固镇县',137,'G',2),(1289,'340402','大通区',138,'D',2),(1290,'340403','田家庵区',138,'T',2),(1291,'340404','谢家集区',138,'X',2),(1292,'340405','八公山区',138,'B',2),(1293,'340406','潘集区',138,'P',2),(1294,'340421','凤台县',138,'F',2),(1295,'340503','花山区',139,'H',2),(1296,'340504','雨山区',139,'Y',2),(1297,'340506','博望区',139,'B',2),(1298,'340521','当涂县',139,'D',2),(1299,'340522','含山县',139,'H',2),(1300,'340523','和县',139,'H',2),(1301,'340602','杜集区',140,'D',2),(1302,'340603','相山区',140,'X',2),(1303,'340604','烈山区',140,'L',2),(1304,'340621','濉溪县',140,'S',2),(1305,'340702','铜官山区',141,'T',2),(1306,'340703','狮子山区',141,'S',2),(1307,'340721','铜陵县',141,'T',2),(1308,'340802','迎江区',142,'Y',2),(1309,'340803','大观区',142,'D',2),(1310,'340811','宜秀区',142,'Y',2),(1311,'340822','怀宁县',142,'H',2),(1312,'340823','枞阳县',142,'C',2),(1313,'340824','潜山县',142,'Q',2),(1314,'340825','太湖县',142,'T',2),(1315,'340826','宿松县',142,'S',2),(1316,'340827','望江县',142,'W',2),(1317,'340828','岳西县',142,'Y',2),(1318,'340881','桐城市',142,'T',2),(1319,'341002','屯溪区',143,'T',2),(1320,'341003','黄山区',143,'H',2),(1321,'341004','徽州区',143,'H',2),(1322,'341021','歙县',143,'X',2),(1323,'341022','休宁县',143,'X',2),(1324,'341023','黟县',143,'Y',2),(1325,'341024','祁门县',143,'Q',2),(1326,'341102','琅琊区',144,'L',2),(1327,'341103','南谯区',144,'N',2),(1328,'341122','来安县',144,'L',2),(1329,'341124','全椒县',144,'Q',2),(1330,'341125','定远县',144,'D',2),(1331,'341126','凤阳县',144,'F',2),(1332,'341181','天长市',144,'T',2),(1333,'341182','明光市',144,'M',2),(1334,'341202','颍州区',145,'Y',2),(1335,'341203','颍东区',145,'Y',2),(1336,'341204','颍泉区',145,'Y',2),(1337,'341221','临泉县',145,'L',2),(1338,'341222','太和县',145,'T',2),(1339,'341225','阜南县',145,'F',2),(1340,'341226','颍上县',145,'Y',2),(1341,'341282','界首市',145,'J',2),(1342,'341302','埇桥区',146,'Y',2),(1343,'341321','砀山县',146,'D',2),(1344,'341322','萧县',146,'X',2),(1345,'341323','灵璧县',146,'L',2),(1346,'341324','泗县',146,'S',2),(1347,'341502','金安区',147,'J',2),(1348,'341503','裕安区',147,'Y',2),(1349,'341521','寿县',147,'S',2),(1350,'341522','霍邱县',147,'H',2),(1351,'341523','舒城县',147,'S',2),(1352,'341524','金寨县',147,'J',2),(1353,'341525','霍山县',147,'H',2),(1354,'341602','谯城区',148,'Q',2),(1355,'341621','涡阳县',148,'W',2),(1356,'341622','蒙城县',148,'M',2),(1357,'341623','利辛县',148,'L',2),(1358,'341702','贵池区',149,'G',2),(1359,'341721','东至县',149,'D',2),(1360,'341722','石台县',149,'S',2),(1361,'341723','青阳县',149,'Q',2),(1362,'341802','宣州区',150,'X',2),(1363,'341821','郎溪县',150,'L',2),(1364,'341822','广德县',150,'G',2),(1365,'341823','泾县',150,'J',2),(1366,'341824','绩溪县',150,'J',2),(1367,'341825','旌德县',150,'J',2),(1368,'341881','宁国市',150,'N',2),(1369,'350103','台江区',151,'T',2),(1370,'350104','仓山区',151,'C',2),(1371,'350105','马尾区',151,'M',2),(1372,'350111','晋安区',151,'J',2),(1373,'350121','闽侯县',151,'M',2),(1374,'350122','连江县',151,'L',2),(1375,'350123','罗源县',151,'L',2),(1376,'350124','闽清县',151,'M',2),(1377,'350125','永泰县',151,'Y',2),(1378,'350128','平潭县',151,'P',2),(1379,'350181','福清市',151,'F',2),(1380,'350182','长乐市',151,'C',2),(1381,'350203','思明区',152,'S',2),(1382,'350205','海沧区',152,'H',2),(1383,'350206','湖里区',152,'H',2),(1384,'350211','集美区',152,'J',2),(1385,'350212','同安区',152,'T',2),(1386,'350213','翔安区',152,'X',2),(1387,'350302','城厢区',153,'C',2),(1388,'350303','涵江区',153,'H',2),(1389,'350304','荔城区',153,'L',2),(1390,'350305','秀屿区',153,'X',2),(1391,'350322','仙游县',153,'X',2),(1392,'350402','梅列区',154,'M',2),(1393,'350403','三元区',154,'S',2),(1394,'350421','明溪县',154,'M',2),(1395,'350423','清流县',154,'Q',2),(1396,'350424','宁化县',154,'N',2),(1397,'350425','大田县',154,'D',2),(1398,'350426','尤溪县',154,'Y',2),(1399,'350427','沙县',154,'S',2),(1400,'350428','将乐县',154,'J',2),(1401,'350429','泰宁县',154,'T',2),(1402,'350430','建宁县',154,'J',2),(1403,'350481','永安市',154,'Y',2),(1404,'350502','鲤城区',155,'L',2),(1405,'350503','丰泽区',155,'F',2),(1406,'350504','洛江区',155,'L',2),(1407,'350505','泉港区',155,'Q',2),(1408,'350521','惠安县',155,'H',2),(1409,'350524','安溪县',155,'A',2),(1410,'350525','永春县',155,'Y',2),(1411,'350526','德化县',155,'D',2),(1412,'350527','金门县',155,'J',2),(1413,'350581','石狮市',155,'S',2),(1414,'350582','晋江市',155,'J',2),(1415,'350583','南安市',155,'N',2),(1416,'350602','芗城区',156,'X',2),(1417,'350603','龙文区',156,'L',2),(1418,'350622','云霄县',156,'Y',2),(1419,'350623','漳浦县',156,'Z',2),(1420,'350624','诏安县',156,'Z',2),(1421,'350625','长泰县',156,'C',2),(1422,'350626','东山县',156,'D',2),(1423,'350627','南靖县',156,'N',2),(1424,'350628','平和县',156,'P',2),(1425,'350629','华安县',156,'H',2),(1426,'350681','龙海市',156,'L',2),(1427,'350702','延平区',157,'Y',2),(1428,'350721','顺昌县',157,'S',2),(1429,'350722','浦城县',157,'P',2),(1430,'350723','光泽县',157,'G',2),(1431,'350724','松溪县',157,'S',2),(1432,'350725','政和县',157,'Z',2),(1433,'350781','邵武市',157,'S',2),(1434,'350782','武夷山市',157,'W',2),(1435,'350783','建瓯市',157,'J',2),(1436,'350784','建阳市',157,'J',2),(1437,'350802','新罗区',158,'X',2),(1438,'350821','长汀县',158,'C',2),(1439,'350822','永定县',158,'Y',2),(1440,'350823','上杭县',158,'S',2),(1441,'350824','武平县',158,'W',2),(1442,'350825','连城县',158,'L',2),(1443,'350881','漳平市',158,'Z',2),(1444,'350902','蕉城区',159,'J',2),(1445,'350921','霞浦县',159,'X',2),(1446,'350922','古田县',159,'G',2),(1447,'350923','屏南县',159,'P',2),(1448,'350924','寿宁县',159,'S',2),(1449,'350925','周宁县',159,'Z',2),(1450,'350926','柘荣县',159,'Z',2),(1451,'350981','福安市',159,'F',2),(1452,'350982','福鼎市',159,'F',2),(1453,'360102','东湖区',160,'D',2),(1454,'360104','青云谱区',160,'Q',2),(1455,'360105','湾里区',160,'W',2),(1456,'360111','青山湖区',160,'Q',2),(1457,'360121','南昌县',160,'N',2),(1458,'360122','新建县',160,'X',2),(1459,'360123','安义县',160,'A',2),(1460,'360124','进贤县',160,'J',2),(1461,'360202','昌江区',161,'C',2),(1462,'360203','珠山区',161,'Z',2),(1463,'360222','浮梁县',161,'F',2),(1464,'360281','乐平市',161,'L',2),(1465,'360302','安源区',162,'A',2),(1466,'360313','湘东区',162,'X',2),(1467,'360321','莲花县',162,'L',2),(1468,'360322','上栗县',162,'S',2),(1469,'360323','芦溪县',162,'L',2),(1470,'360402','庐山区',163,'L',2),(1471,'360403','浔阳区',163,'X',2),(1472,'360421','九江县',163,'J',2),(1473,'360423','武宁县',163,'W',2),(1474,'360424','修水县',163,'X',2),(1475,'360425','永修县',163,'Y',2),(1476,'360426','德安县',163,'D',2),(1477,'360427','星子县',163,'X',2),(1478,'360428','都昌县',163,'D',2),(1479,'360429','湖口县',163,'H',2),(1480,'360430','彭泽县',163,'P',2),(1481,'360481','瑞昌市',163,'R',2),(1482,'360482','共青城市',163,'G',2),(1483,'360502','渝水区',164,'Y',2),(1484,'360521','分宜县',164,'F',2),(1485,'360602','月湖区',165,'Y',2),(1486,'360622','余江县',165,'Y',2),(1487,'360681','贵溪市',165,'G',2),(1488,'360702','章贡区',166,'Z',2),(1489,'360703','南康区',166,'N',2),(1490,'360721','赣县',166,'G',2),(1491,'360722','信丰县',166,'X',2),(1492,'360723','大余县',166,'D',2),(1493,'360724','上犹县',166,'S',2),(1494,'360725','崇义县',166,'C',2),(1495,'360726','安远县',166,'A',2),(1496,'360727','龙南县',166,'L',2),(1497,'360728','定南县',166,'D',2),(1498,'360729','全南县',166,'Q',2),(1499,'360730','宁都县',166,'N',2),(1500,'360731','于都县',166,'Y',2),(1501,'360732','兴国县',166,'X',2),(1502,'360733','会昌县',166,'H',2),(1503,'360734','寻乌县',166,'X',2),(1504,'360735','石城县',166,'S',2),(1505,'360781','瑞金市',166,'R',2),(1506,'360802','吉州区',167,'J',2),(1507,'360803','青原区',167,'Q',2),(1508,'360821','吉安县',167,'J',2),(1509,'360822','吉水县',167,'J',2),(1510,'360823','峡江县',167,'X',2),(1511,'360824','新干县',167,'X',2),(1512,'360825','永丰县',167,'Y',2),(1513,'360826','泰和县',167,'T',2),(1514,'360827','遂川县',167,'S',2),(1515,'360828','万安县',167,'W',2),(1516,'360829','安福县',167,'A',2),(1517,'360830','永新县',167,'Y',2),(1518,'360881','井冈山市',167,'J',2),(1519,'360902','袁州区',168,'Y',2),(1520,'360921','奉新县',168,'F',2),(1521,'360922','万载县',168,'W',2),(1522,'360923','上高县',168,'S',2),(1523,'360924','宜丰县',168,'Y',2),(1524,'360925','靖安县',168,'J',2),(1525,'360926','铜鼓县',168,'T',2),(1526,'360981','丰城市',168,'F',2),(1527,'360982','樟树市',168,'Z',2),(1528,'360983','高安市',168,'G',2),(1529,'361002','临川区',169,'L',2),(1530,'361021','南城县',169,'N',2),(1531,'361022','黎川县',169,'L',2),(1532,'361023','南丰县',169,'N',2),(1533,'361024','崇仁县',169,'C',2),(1534,'361025','乐安县',169,'L',2),(1535,'361026','宜黄县',169,'Y',2),(1536,'361027','金溪县',169,'J',2),(1537,'361028','资溪县',169,'Z',2),(1538,'361029','东乡县',169,'D',2),(1539,'361030','广昌县',169,'G',2),(1540,'361102','信州区',170,'X',2),(1541,'361121','上饶县',170,'S',2),(1542,'361122','广丰县',170,'G',2),(1543,'361123','玉山县',170,'Y',2),(1544,'361124','铅山县',170,'Q',2),(1545,'361125','横峰县',170,'H',2),(1546,'361126','弋阳县',170,'Y',2),(1547,'361127','余干县',170,'Y',2),(1548,'361128','鄱阳县',170,'P',2),(1549,'361129','万年县',170,'W',2),(1550,'361130','婺源县',170,'W',2),(1551,'361181','德兴市',170,'D',2),(1552,'370102','历下区',171,'L',2),(1553,'370103','市中区',171,'S',2),(1554,'370104','槐荫区',171,'H',2),(1555,'370105','天桥区',171,'T',2),(1556,'370112','历城区',171,'L',2),(1557,'370113','长清区',171,'C',2),(1558,'370124','平阴县',171,'P',2),(1559,'370125','济阳县',171,'J',2),(1560,'370126','商河县',171,'S',2),(1561,'370181','章丘市',171,'Z',2),(1562,'370202','市南区',172,'S',2),(1563,'370203','市北区',172,'S',2),(1564,'370211','黄岛区',172,'H',2),(1565,'370212','崂山区',172,'L',2),(1566,'370213','李沧区',172,'L',2),(1567,'370214','城阳区',172,'C',2),(1568,'370281','胶州市',172,'J',2),(1569,'370282','即墨市',172,'J',2),(1570,'370283','平度市',172,'P',2),(1571,'370285','莱西市',172,'L',2),(1572,'370302','淄川区',173,'Z',2),(1573,'370303','张店区',173,'Z',2),(1574,'370304','博山区',173,'B',2),(1575,'370305','临淄区',173,'L',2),(1576,'370306','周村区',173,'Z',2),(1577,'370321','桓台县',173,'H',2),(1578,'370322','高青县',173,'G',2),(1579,'370323','沂源县',173,'Y',2),(1580,'370403','薛城区',174,'X',2),(1581,'370404','峄城区',174,'Y',2),(1582,'370405','台儿庄区',174,'T',2),(1583,'370406','山亭区',174,'S',2),(1584,'370481','滕州市',174,'T',2),(1585,'370502','东营区',175,'D',2),(1586,'370503','河口区',175,'H',2),(1587,'370521','垦利县',175,'K',2),(1588,'370522','利津县',175,'L',2),(1589,'370523','广饶县',175,'G',2),(1590,'370602','芝罘区',176,'Z',2),(1591,'370611','福山区',176,'F',2),(1592,'370612','牟平区',176,'M',2),(1593,'370613','莱山区',176,'L',2),(1594,'370634','长岛县',176,'C',2),(1595,'370681','龙口市',176,'L',2),(1596,'370682','莱阳市',176,'L',2),(1597,'370683','莱州市',176,'L',2),(1598,'370684','蓬莱市',176,'P',2),(1599,'370685','招远市',176,'Z',2),(1600,'370686','栖霞市',176,'Q',2),(1601,'370687','海阳市',176,'H',2),(1602,'370702','潍城区',177,'W',2),(1603,'370703','寒亭区',177,'H',2),(1604,'370704','坊子区',177,'F',2),(1605,'370705','奎文区',177,'K',2),(1606,'370724','临朐县',177,'L',2),(1607,'370725','昌乐县',177,'C',2),(1608,'370781','青州市',177,'Q',2),(1609,'370782','诸城市',177,'Z',2),(1610,'370783','寿光市',177,'S',2),(1611,'370784','安丘市',177,'A',2),(1612,'370785','高密市',177,'G',2),(1613,'370786','昌邑市',177,'C',2),(1614,'370811','任城区',178,'R',2),(1615,'370812','兖州区',178,'Y',2),(1616,'370826','微山县',178,'W',2),(1617,'370827','鱼台县',178,'Y',2),(1618,'370828','金乡县',178,'J',2),(1619,'370829','嘉祥县',178,'J',2),(1620,'370830','汶上县',178,'W',2),(1621,'370831','泗水县',178,'S',2),(1622,'370832','梁山县',178,'L',2),(1623,'370881','曲阜市',178,'Q',2),(1624,'370883','邹城市',178,'Z',2),(1625,'370902','泰山区',179,'T',2),(1626,'370911','岱岳区',179,'D',2),(1627,'370921','宁阳县',179,'N',2),(1628,'370923','东平县',179,'D',2),(1629,'370982','新泰市',179,'X',2),(1630,'370983','肥城市',179,'F',2),(1631,'371002','环翠区',180,'H',2),(1632,'371003','文登区',180,'W',2),(1633,'371082','荣成市',180,'R',2),(1634,'371083','乳山市',180,'R',2),(1635,'371102','东港区',181,'D',2),(1636,'371103','岚山区',181,'L',2),(1637,'371121','五莲县',181,'W',2),(1638,'371122','莒县',181,'J',2),(1639,'371202','莱城区',182,'L',2),(1640,'371203','钢城区',182,'G',2),(1641,'371302','兰山区',183,'L',2),(1642,'371311','罗庄区',183,'L',2),(1643,'371321','沂南县',183,'Y',2),(1644,'371322','郯城县',183,'T',2),(1645,'371323','沂水县',183,'Y',2),(1646,'371324','兰陵县',183,'L',2),(1647,'371325','费县',183,'F',2),(1648,'371326','平邑县',183,'P',2),(1649,'371327','莒南县',183,'J',2),(1650,'371328','蒙阴县',183,'M',2),(1651,'371329','临沭县',183,'L',2),(1652,'371402','德城区',184,'D',2),(1653,'371403','陵城区',184,'L',2),(1654,'371422','宁津县',184,'N',2),(1655,'371423','庆云县',184,'Q',2),(1656,'371424','临邑县',184,'L',2),(1657,'371425','齐河县',184,'Q',2),(1658,'371426','平原县',184,'P',2),(1659,'371427','夏津县',184,'X',2),(1660,'371428','武城县',184,'W',2),(1661,'371481','乐陵市',184,'L',2),(1662,'371482','禹城市',184,'Y',2),(1663,'371502','东昌府区',185,'D',2),(1664,'371521','阳谷县',185,'Y',2),(1665,'371522','莘县',185,'X',2),(1666,'371523','茌平县',185,'C',2),(1667,'371524','东阿县',185,'D',2),(1668,'371525','冠县',185,'G',2),(1669,'371526','高唐县',185,'G',2),(1670,'371581','临清市',185,'L',2),(1671,'371602','滨城区',186,'B',2),(1672,'371603','沾化区',186,'Z',2),(1673,'371621','惠民县',186,'H',2),(1674,'371622','阳信县',186,'Y',2),(1675,'371623','无棣县',186,'W',2),(1676,'371625','博兴县',186,'B',2),(1677,'371626','邹平县',186,'Z',2),(1678,'371702','牡丹区',187,'M',2),(1679,'371721','曹县',187,'C',2),(1680,'371722','单县',187,'D',2),(1681,'371723','成武县',187,'C',2),(1682,'371724','巨野县',187,'J',2),(1683,'371725','郓城县',187,'Y',2),(1684,'371726','鄄城县',187,'J',2),(1685,'371727','定陶县',187,'D',2),(1686,'371728','东明县',187,'D',2),(1687,'410102','中原区',188,'Z',2),(1688,'410103','二七区',188,'E',2),(1689,'410104','管城回族区',188,'G',2),(1690,'410105','金水区',188,'J',2),(1691,'410106','上街区',188,'S',2),(1692,'410108','惠济区',188,'H',2),(1693,'410122','中牟县',188,'Z',2),(1694,'410181','巩义市',188,'G',2),(1695,'410182','荥阳市',188,'Y',2),(1696,'410183','新密市',188,'X',2),(1697,'410184','新郑市',188,'X',2),(1698,'410185','登封市',188,'D',2),(1699,'410202','龙亭区',189,'L',2),(1700,'410203','顺河回族区',189,'S',2),(1701,'410205','禹王台区',189,'Y',2),(1702,'410211','金明区',189,'J',2),(1703,'410221','杞县',189,'Q',2),(1704,'410222','通许县',189,'T',2),(1705,'410223','尉氏县',189,'W',2),(1706,'410224','开封县',189,'K',2),(1707,'410225','兰考县',189,'L',2),(1708,'410302','老城区',190,'L',2),(1709,'410303','西工区',190,'X',2),(1710,'410304','瀍河回族区',190,'C',2),(1711,'410305','涧西区',190,'J',2),(1712,'410306','吉利区',190,'J',2),(1713,'410311','洛龙区',190,'L',2),(1714,'410322','孟津县',190,'M',2),(1715,'410323','新安县',190,'X',2),(1716,'410324','栾川县',190,'L',2),(1717,'410325','嵩县',190,'S',2),(1718,'410326','汝阳县',190,'R',2),(1719,'410327','宜阳县',190,'Y',2),(1720,'410328','洛宁县',190,'L',2),(1721,'410329','伊川县',190,'Y',2),(1722,'410381','偃师市',190,'Y',2),(1723,'410403','卫东区',191,'W',2),(1724,'410404','石龙区',191,'S',2),(1725,'410411','湛河区',191,'Z',2),(1726,'410421','宝丰县',191,'B',2),(1727,'410422','叶县',191,'Y',2),(1728,'410423','鲁山县',191,'L',2),(1729,'410425','郏县',191,'J',2),(1730,'410481','舞钢市',191,'W',2),(1731,'410482','汝州市',191,'R',2),(1732,'410502','文峰区',192,'W',2),(1733,'410503','北关区',192,'B',2),(1734,'410505','殷都区',192,'Y',2),(1735,'410506','龙安区',192,'L',2),(1736,'410522','安阳县',192,'A',2),(1737,'410523','汤阴县',192,'T',2),(1738,'410526','滑县',192,'H',2),(1739,'410527','内黄县',192,'N',2),(1740,'410581','林州市',192,'L',2),(1741,'410602','鹤山区',193,'H',2),(1742,'410603','山城区',193,'S',2),(1743,'410611','淇滨区',193,'Q',2),(1744,'410621','浚县',193,'J',2),(1745,'410622','淇县',193,'Q',2),(1746,'410702','红旗区',194,'H',2),(1747,'410703','卫滨区',194,'W',2),(1748,'410704','凤泉区',194,'F',2),(1749,'410711','牧野区',194,'M',2),(1750,'410721','新乡县',194,'X',2),(1751,'410724','获嘉县',194,'H',2),(1752,'410725','原阳县',194,'Y',2),(1753,'410726','延津县',194,'Y',2),(1754,'410727','封丘县',194,'F',2),(1755,'410728','长垣县',194,'C',2),(1756,'410781','卫辉市',194,'W',2),(1757,'410782','辉县市',194,'H',2),(1758,'410802','解放区',195,'J',2),(1759,'410803','中站区',195,'Z',2),(1760,'410804','马村区',195,'M',2),(1761,'410811','山阳区',195,'S',2),(1762,'410821','修武县',195,'X',2),(1763,'410822','博爱县',195,'B',2),(1764,'410823','武陟县',195,'W',2),(1765,'410825','温县',195,'W',2),(1766,'410882','沁阳市',195,'Q',2),(1767,'410883','孟州市',195,'M',2),(1768,'410902','华龙区',196,'H',2),(1769,'410922','清丰县',196,'Q',2),(1770,'410923','南乐县',196,'N',2),(1771,'410926','范县',196,'F',2),(1772,'410927','台前县',196,'T',2),(1773,'410928','濮阳县',196,'P',2),(1774,'411002','魏都区',197,'W',2),(1775,'411023','许昌县',197,'X',2),(1776,'411024','鄢陵县',197,'Y',2),(1777,'411025','襄城县',197,'X',2),(1778,'411081','禹州市',197,'Y',2),(1779,'411082','长葛市',197,'C',2),(1781,'411102','源汇区',198,'Y',2),(1782,'411103','郾城区',198,'Y',2),(1783,'411104','召陵区',198,'Z',2),(1784,'411121','舞阳县',198,'W',2),(1785,'411122','临颍县',198,'L',2),(1786,'411202','湖滨区',199,'H',2),(1787,'411221','渑池县',199,'S',2),(1788,'411222','陕县',199,'S',2),(1789,'411224','卢氏县',199,'L',2),(1790,'411281','义马市',199,'Y',2),(1791,'411282','灵宝市',199,'L',2),(1792,'411302','宛城区',200,'W',2),(1793,'411303','卧龙区',200,'W',2),(1794,'411321','南召县',200,'N',2),(1795,'411322','方城县',200,'F',2),(1796,'411323','西峡县',200,'X',2),(1797,'411324','镇平县',200,'Z',2),(1798,'411325','内乡县',200,'N',2),(1799,'411326','淅川县',200,'X',2),(1800,'411327','社旗县',200,'S',2),(1801,'411328','唐河县',200,'T',2),(1802,'411329','新野县',200,'X',2),(1803,'411330','桐柏县',200,'T',2),(1804,'411381','邓州市',200,'D',2),(1805,'411402','梁园区',201,'L',2),(1806,'411403','睢阳区',201,'S',2),(1807,'411421','民权县',201,'M',2),(1808,'411422','睢县',201,'S',2),(1809,'411423','宁陵县',201,'N',2),(1810,'411424','柘城县',201,'Z',2),(1811,'411425','虞城县',201,'Y',2),(1812,'411426','夏邑县',201,'X',2),(1813,'411481','永城市',201,'Y',2),(1814,'411502','浉河区',202,'S',2),(1815,'411503','平桥区',202,'P',2),(1816,'411521','罗山县',202,'L',2),(1817,'411522','光山县',202,'G',2),(1818,'411523','新县',202,'X',2),(1819,'411524','商城县',202,'S',2),(1820,'411525','固始县',202,'G',2),(1821,'411526','潢川县',202,'H',2),(1822,'411527','淮滨县',202,'H',2),(1823,'411528','息县',202,'X',2),(1824,'411602','川汇区',203,'C',2),(1825,'411621','扶沟县',203,'F',2),(1826,'411622','西华县',203,'X',2),(1827,'411623','商水县',203,'S',2),(1828,'411624','沈丘县',203,'S',2),(1829,'411625','郸城县',203,'D',2),(1830,'411626','淮阳县',203,'H',2),(1831,'411627','太康县',203,'T',2),(1832,'411628','鹿邑县',203,'L',2),(1833,'411681','项城市',203,'X',2),(1834,'411702','驿城区',204,'Y',2),(1835,'411721','西平县',204,'X',2),(1836,'411722','上蔡县',204,'S',2),(1837,'411723','平舆县',204,'P',2),(1838,'411724','正阳县',204,'Z',2),(1839,'411725','确山县',204,'Q',2),(1840,'411726','泌阳县',204,'M',2),(1841,'411727','汝南县',204,'R',2),(1842,'411728','遂平县',204,'S',2),(1843,'411729','新蔡县',204,'X',2),(1844,'419001','济源市',205,'J',2),(1845,'420102','江岸区',206,'J',2),(1846,'420103','江汉区',206,'J',2),(1847,'420104','硚口区',206,'Q',2),(1848,'420105','汉阳区',206,'H',2),(1849,'420106','武昌区',206,'W',2),(1850,'420111','洪山区',206,'H',2),(1851,'420112','东西湖区',206,'D',2),(1852,'420113','汉南区',206,'H',2),(1853,'420114','蔡甸区',206,'C',2),(1854,'420115','江夏区',206,'J',2),(1855,'420116','黄陂区',206,'H',2),(1856,'420117','新洲区',206,'X',2),(1857,'420202','黄石港区',207,'H',2),(1858,'420203','西塞山区',207,'X',2),(1859,'420204','下陆区',207,'X',2),(1860,'420205','铁山区',207,'T',2),(1861,'420222','阳新县',207,'Y',2),(1862,'420281','大冶市',207,'D',2),(1863,'420302','茅箭区',208,'M',2),(1864,'420303','张湾区',208,'Z',2),(1865,'420304','郧阳区',208,'Y',2),(1866,'420322','郧西县',208,'Y',2),(1867,'420323','竹山县',208,'Z',2),(1868,'420324','竹溪县',208,'Z',2),(1869,'420325','房县',208,'F',2),(1870,'420381','丹江口市',208,'D',2),(1871,'420502','西陵区',209,'X',2),(1872,'420503','伍家岗区',209,'W',2),(1873,'420504','点军区',209,'D',2),(1874,'420505','猇亭区',209,'X',2),(1875,'420506','夷陵区',209,'Y',2),(1876,'420525','远安县',209,'Y',2),(1877,'420526','兴山县',209,'X',2),(1878,'420527','秭归县',209,'Z',2),(1879,'420528','长阳土家族自治县',209,'C',2),(1880,'420529','五峰土家族自治县',209,'W',2),(1881,'420581','宜都市',209,'Y',2),(1882,'420582','当阳市',209,'D',2),(1883,'420583','枝江市',209,'Z',2),(1884,'420602','襄城区',210,'X',2),(1885,'420606','樊城区',210,'F',2),(1886,'420607','襄州区',210,'X',2),(1887,'420624','南漳县',210,'N',2),(1888,'420625','谷城县',210,'G',2),(1889,'420626','保康县',210,'B',2),(1890,'420682','老河口市',210,'L',2),(1891,'420683','枣阳市',210,'Z',2),(1892,'420684','宜城市',210,'Y',2),(1893,'420702','梁子湖区',211,'L',2),(1894,'420703','华容区',211,'H',2),(1895,'420704','鄂城区',211,'E',2),(1896,'420802','东宝区',212,'D',2),(1897,'420804','掇刀区',212,'D',2),(1898,'420821','京山县',212,'J',2),(1899,'420822','沙洋县',212,'S',2),(1900,'420881','钟祥市',212,'Z',2),(1901,'420902','孝南区',213,'X',2),(1902,'420921','孝昌县',213,'X',2),(1903,'420922','大悟县',213,'D',2),(1904,'420923','云梦县',213,'Y',2),(1905,'420981','应城市',213,'Y',2),(1906,'420982','安陆市',213,'A',2),(1907,'420984','汉川市',213,'H',2),(1908,'421002','沙市区',214,'S',2),(1909,'421003','荆州区',214,'J',2),(1910,'421022','公安县',214,'G',2),(1911,'421023','监利县',214,'J',2),(1912,'421024','江陵县',214,'J',2),(1913,'421081','石首市',214,'S',2),(1914,'421083','洪湖市',214,'H',2),(1915,'421087','松滋市',214,'S',2),(1916,'421102','黄州区',215,'H',2),(1917,'421121','团风县',215,'T',2),(1918,'421122','红安县',215,'H',2),(1919,'421123','罗田县',215,'L',2),(1920,'421124','英山县',215,'Y',2),(1921,'421125','浠水县',215,'X',2),(1922,'421126','蕲春县',215,'Q',2),(1923,'421127','黄梅县',215,'H',2),(1924,'421181','麻城市',215,'M',2),(1925,'421182','武穴市',215,'W',2),(1926,'421202','咸安区',216,'X',2),(1927,'421221','嘉鱼县',216,'J',2),(1928,'421222','通城县',216,'T',2),(1929,'421223','崇阳县',216,'C',2),(1930,'421224','通山县',216,'T',2),(1931,'421281','赤壁市',216,'C',2),(1932,'421303','曾都区',217,'Z',2),(1933,'421321','随县',217,'S',2),(1934,'421381','广水市',217,'G',2),(1935,'422801','恩施市',218,'E',2),(1936,'422802','利川市',218,'L',2),(1937,'422822','建始县',218,'J',2),(1938,'422823','巴东县',218,'B',2),(1939,'422825','宣恩县',218,'X',2),(1940,'422826','咸丰县',218,'X',2),(1941,'422827','来凤县',218,'L',2),(1942,'422828','鹤峰县',218,'H',2),(1943,'429004','仙桃市',219,'X',2),(1944,'429005','潜江市',219,'Q',2),(1945,'429006','天门市',219,'T',2),(1946,'429021','神农架林区',219,'S',2),(1947,'430102','芙蓉区',220,'F',2),(1948,'430103','天心区',220,'T',2),(1949,'430104','岳麓区',220,'Y',2),(1950,'430105','开福区',220,'K',2),(1951,'430111','雨花区',220,'Y',2),(1952,'430112','望城区',220,'W',2),(1953,'430121','长沙县',220,'C',2),(1954,'430124','宁乡县',220,'N',2),(1955,'430181','浏阳市',220,'L',2),(1956,'430202','荷塘区',221,'H',2),(1957,'430203','芦淞区',221,'L',2),(1958,'430204','石峰区',221,'S',2),(1959,'430211','天元区',221,'T',2),(1960,'430221','株洲县',221,'Z',2),(1961,'430223','攸县',221,'Y',2),(1962,'430224','茶陵县',221,'C',2),(1963,'430225','炎陵县',221,'Y',2),(1964,'430281','醴陵市',221,'L',2),(1965,'430302','雨湖区',222,'Y',2),(1966,'430304','岳塘区',222,'Y',2),(1967,'430321','湘潭县',222,'X',2),(1968,'430381','湘乡市',222,'X',2),(1969,'430382','韶山市',222,'S',2),(1970,'430405','珠晖区',223,'Z',2),(1971,'430406','雁峰区',223,'Y',2),(1972,'430407','石鼓区',223,'S',2),(1973,'430408','蒸湘区',223,'Z',2),(1974,'430412','南岳区',223,'N',2),(1975,'430421','衡阳县',223,'H',2),(1976,'430422','衡南县',223,'H',2),(1977,'430423','衡山县',223,'H',2),(1978,'430424','衡东县',223,'H',2),(1979,'430426','祁东县',223,'Q',2),(1980,'430481','耒阳市',223,'L',2),(1981,'430482','常宁市',223,'C',2),(1982,'430502','双清区',224,'S',2),(1983,'430503','大祥区',224,'D',2),(1984,'430511','北塔区',224,'B',2),(1985,'430521','邵东县',224,'S',2),(1986,'430522','新邵县',224,'X',2),(1987,'430523','邵阳县',224,'S',2),(1988,'430524','隆回县',224,'L',2),(1989,'430525','洞口县',224,'D',2),(1990,'430527','绥宁县',224,'S',2),(1991,'430528','新宁县',224,'X',2),(1992,'430529','城步苗族自治县',224,'C',2),(1993,'430581','武冈市',224,'W',2),(1994,'430602','岳阳楼区',225,'Y',2),(1995,'430603','云溪区',225,'Y',2),(1996,'430611','君山区',225,'J',2),(1997,'430621','岳阳县',225,'Y',2),(1998,'430623','华容县',225,'H',2),(1999,'430624','湘阴县',225,'X',2),(2000,'430626','平江县',225,'P',2),(2001,'430681','汨罗市',225,'M',2),(2002,'430682','临湘市',225,'L',2),(2003,'430702','武陵区',226,'W',2),(2004,'430703','鼎城区',226,'D',2),(2005,'430721','安乡县',226,'A',2),(2006,'430722','汉寿县',226,'H',2),(2007,'430723','澧县',226,'L',2),(2008,'430724','临澧县',226,'L',2),(2009,'430725','桃源县',226,'T',2),(2010,'430726','石门县',226,'S',2),(2011,'430781','津市市',226,'J',2),(2012,'430802','永定区',227,'Y',2),(2013,'430811','武陵源区',227,'W',2),(2014,'430821','慈利县',227,'C',2),(2015,'430822','桑植县',227,'S',2),(2016,'430902','资阳区',228,'Z',2),(2017,'430903','赫山区',228,'H',2),(2018,'430921','南县',228,'N',2),(2019,'430922','桃江县',228,'T',2),(2020,'430923','安化县',228,'A',2),(2021,'430981','沅江市',228,'Y',2),(2022,'431002','北湖区',229,'B',2),(2023,'431003','苏仙区',229,'S',2),(2024,'431021','桂阳县',229,'G',2),(2025,'431022','宜章县',229,'Y',2),(2026,'431023','永兴县',229,'Y',2),(2027,'431024','嘉禾县',229,'J',2),(2028,'431025','临武县',229,'L',2),(2029,'431026','汝城县',229,'R',2),(2030,'431027','桂东县',229,'G',2),(2031,'431028','安仁县',229,'A',2),(2032,'431081','资兴市',229,'Z',2),(2033,'431102','零陵区',230,'L',2),(2034,'431103','冷水滩区',230,'L',2),(2035,'431121','祁阳县',230,'Q',2),(2036,'431122','东安县',230,'D',2),(2037,'431123','双牌县',230,'S',2),(2038,'431124','道县',230,'D',2),(2039,'431125','江永县',230,'J',2),(2040,'431126','宁远县',230,'N',2),(2041,'431127','蓝山县',230,'L',2),(2042,'431128','新田县',230,'X',2),(2043,'431129','江华瑶族自治县',230,'J',2),(2044,'431202','鹤城区',231,'H',2),(2045,'431221','中方县',231,'Z',2),(2046,'431222','沅陵县',231,'Y',2),(2047,'431223','辰溪县',231,'C',2),(2048,'431224','溆浦县',231,'X',2),(2049,'431225','会同县',231,'H',2),(2050,'431226','麻阳苗族自治县',231,'M',2),(2051,'431227','新晃侗族自治县',231,'X',2),(2052,'431228','芷江侗族自治县',231,'Z',2),(2053,'431229','靖州苗族侗族自治县',231,'J',2),(2054,'431230','通道侗族自治县',231,'T',2),(2055,'431281','洪江市',231,'H',2),(2056,'431302','娄星区',232,'L',2),(2057,'431321','双峰县',232,'S',2),(2058,'431322','新化县',232,'X',2),(2059,'431381','冷水江市',232,'L',2),(2060,'431382','涟源市',232,'L',2),(2061,'433101','吉首市',233,'J',2),(2062,'433122','泸溪县',233,'L',2),(2063,'433123','凤凰县',233,'F',2),(2064,'433124','花垣县',233,'H',2),(2065,'433125','保靖县',233,'B',2),(2066,'433126','古丈县',233,'G',2),(2067,'433127','永顺县',233,'Y',2),(2068,'433130','龙山县',233,'L',2),(2069,'440103','荔湾区',234,'L',2),(2070,'440104','越秀区',234,'Y',2),(2071,'440105','海珠区',234,'H',2),(2072,'440106','天河区',234,'T',2),(2073,'440111','白云区',234,'B',2),(2074,'440112','黄埔区',234,'H',2),(2075,'440113','番禺区',234,'F',2),(2076,'440114','花都区',234,'H',2),(2077,'440115','南沙区',234,'N',2),(2078,'440116','萝岗区',234,'L',2),(2079,'440117','从化区',234,'C',2),(2080,'440118','增城区',234,'Z',2),(2081,'440203','武江区',235,'W',2),(2082,'440204','浈江区',235,'Z',2),(2083,'440205','曲江区',235,'Q',2),(2084,'440222','始兴县',235,'S',2),(2085,'440224','仁化县',235,'R',2),(2086,'440229','翁源县',235,'W',2),(2087,'440232','乳源瑶族自治县',235,'R',2),(2088,'440233','新丰县',235,'X',2),(2089,'440281','乐昌市',235,'L',2),(2090,'440282','南雄市',235,'N',2),(2091,'440303','罗湖区',236,'L',2),(2092,'440304','福田区',236,'F',2),(2093,'440306','宝安区',236,'B',2),(2094,'440307','龙岗区',236,'L',2),(2095,'440308','盐田区',236,'Y',2),(2096,'440402','香洲区',237,'X',2),(2097,'440403','斗门区',237,'D',2),(2098,'440404','金湾区',237,'J',2),(2099,'440507','龙湖区',238,'L',2),(2100,'440511','金平区',238,'J',2),(2101,'440512','濠江区',238,'H',2),(2102,'440513','潮阳区',238,'C',2),(2103,'440514','潮南区',238,'C',2),(2104,'440515','澄海区',238,'C',2),(2105,'440523','南澳县',238,'N',2),(2106,'440604','禅城区',239,'C',2),(2107,'440605','南海区',239,'N',2),(2108,'440606','顺德区',239,'S',2),(2109,'440607','三水区',239,'S',2),(2110,'440608','高明区',239,'G',2),(2111,'440703','蓬江区',240,'P',2),(2112,'440704','江海区',240,'J',2),(2113,'440705','新会区',240,'X',2),(2114,'440781','台山市',240,'T',2),(2115,'440783','开平市',240,'K',2),(2116,'440784','鹤山市',240,'H',2),(2117,'440785','恩平市',240,'E',2),(2118,'440802','赤坎区',241,'C',2),(2119,'440803','霞山区',241,'X',2),(2120,'440804','坡头区',241,'P',2),(2121,'440811','麻章区',241,'M',2),(2122,'440823','遂溪县',241,'S',2),(2123,'440825','徐闻县',241,'X',2),(2124,'440881','廉江市',241,'L',2),(2125,'440882','雷州市',241,'L',2),(2126,'440883','吴川市',241,'W',2),(2127,'440902','茂南区',242,'M',2),(2128,'440904','电白区',242,'D',2),(2129,'440981','高州市',242,'G',2),(2130,'440982','化州市',242,'H',2),(2131,'440983','信宜市',242,'X',2),(2132,'441202','端州区',243,'D',2),(2133,'441203','鼎湖区',243,'D',2),(2134,'441223','广宁县',243,'G',2),(2135,'441224','怀集县',243,'H',2),(2136,'441225','封开县',243,'F',2),(2137,'441226','德庆县',243,'D',2),(2138,'441283','高要市',243,'G',2),(2139,'441284','四会市',243,'S',2),(2140,'441302','惠城区',244,'H',2),(2141,'441303','惠阳区',244,'H',2),(2142,'441322','博罗县',244,'B',2),(2143,'441323','惠东县',244,'H',2),(2144,'441324','龙门县',244,'L',2),(2145,'441402','梅江区',245,'M',2),(2146,'441403','梅县区',245,'M',2),(2147,'441422','大埔县',245,'D',2),(2148,'441423','丰顺县',245,'F',2),(2149,'441424','五华县',245,'W',2),(2150,'441426','平远县',245,'P',2),(2151,'441427','蕉岭县',245,'J',2),(2152,'441481','兴宁市',245,'X',2),(2153,'441521','海丰县',246,'H',2),(2154,'441523','陆河县',246,'L',2),(2155,'441581','陆丰市',246,'L',2),(2156,'441602','源城区',247,'Y',2),(2157,'441621','紫金县',247,'Z',2),(2158,'441622','龙川县',247,'L',2),(2159,'441623','连平县',247,'L',2),(2160,'441624','和平县',247,'H',2),(2161,'441625','东源县',247,'D',2),(2162,'441702','江城区',248,'J',2),(2163,'441721','阳西县',248,'Y',2),(2164,'441723','阳东县',248,'Y',2),(2165,'441781','阳春市',248,'Y',2),(2166,'441802','清城区',249,'Q',2),(2167,'441803','清新区',249,'Q',2),(2168,'441821','佛冈县',249,'F',2),(2169,'441823','阳山县',249,'Y',2),(2170,'441825','连山壮族瑶族自治县',249,'L',2),(2171,'441826','连南瑶族自治县',249,'L',2),(2172,'441881','英德市',249,'Y',2),(2173,'441882','连州市',249,'L',2),(2174,'445102','湘桥区',252,'X',2),(2175,'445103','潮安区',252,'C',2),(2176,'445122','饶平县',252,'R',2),(2177,'445202','榕城区',253,'R',2),(2178,'445203','揭东区',253,'J',2),(2179,'445222','揭西县',253,'J',2),(2180,'445224','惠来县',253,'H',2),(2181,'445281','普宁市',253,'P',2),(2182,'445302','云城区',254,'Y',2),(2183,'445303','云安区',254,'Y',2),(2184,'445321','新兴县',254,'X',2),(2185,'445322','郁南县',254,'Y',2),(2186,'445381','罗定市',254,'L',2),(2187,'450102','兴宁区',255,'X',2),(2188,'450103','青秀区',255,'Q',2),(2189,'450105','江南区',255,'J',2),(2190,'450107','西乡塘区',255,'X',2),(2191,'450108','良庆区',255,'L',2),(2192,'450109','邕宁区',255,'Y',2),(2193,'450122','武鸣县',255,'W',2),(2194,'450123','隆安县',255,'L',2),(2195,'450124','马山县',255,'M',2),(2196,'450125','上林县',255,'S',2),(2197,'450126','宾阳县',255,'B',2),(2198,'450127','横县',255,'H',2),(2199,'450202','城中区',256,'C',2),(2200,'450203','鱼峰区',256,'Y',2),(2201,'450204','柳南区',256,'L',2),(2202,'450205','柳北区',256,'L',2),(2203,'450221','柳江县',256,'L',2),(2204,'450222','柳城县',256,'L',2),(2205,'450223','鹿寨县',256,'L',2),(2206,'450224','融安县',256,'R',2),(2207,'450225','融水苗族自治县',256,'R',2),(2208,'450226','三江侗族自治县',256,'S',2),(2209,'450302','秀峰区',257,'X',2),(2210,'450303','叠彩区',257,'D',2),(2211,'450304','象山区',257,'X',2),(2212,'450305','七星区',257,'Q',2),(2213,'450311','雁山区',257,'Y',2),(2214,'450312','临桂区',257,'L',2),(2215,'450321','阳朔县',257,'Y',2),(2216,'450323','灵川县',257,'L',2),(2217,'450324','全州县',257,'Q',2),(2218,'450325','兴安县',257,'X',2),(2219,'450326','永福县',257,'Y',2),(2220,'450327','灌阳县',257,'G',2),(2221,'450328','龙胜各族自治县',257,'L',2),(2222,'450329','资源县',257,'Z',2),(2223,'450330','平乐县',257,'P',2),(2224,'450331','荔浦县',257,'L',2),(2225,'450332','恭城瑶族自治县',257,'G',2),(2226,'450403','万秀区',258,'W',2),(2227,'450405','长洲区',258,'C',2),(2228,'450406','龙圩区',258,'L',2),(2229,'450421','苍梧县',258,'C',2),(2230,'450422','藤县',258,'T',2),(2231,'450423','蒙山县',258,'M',2),(2232,'450481','岑溪市',258,'C',2),(2233,'450502','海城区',259,'H',2),(2234,'450503','银海区',259,'Y',2),(2235,'450512','铁山港区',259,'T',2),(2236,'450521','合浦县',259,'H',2),(2237,'450602','港口区',260,'G',2),(2238,'450603','防城区',260,'F',2),(2239,'450621','上思县',260,'S',2),(2240,'450681','东兴市',260,'D',2),(2241,'450702','钦南区',261,'Q',2),(2242,'450703','钦北区',261,'Q',2),(2243,'450721','灵山县',261,'L',2),(2244,'450722','浦北县',261,'P',2),(2245,'450802','港北区',262,'G',2),(2246,'450803','港南区',262,'G',2),(2247,'450804','覃塘区',262,'T',2),(2248,'450821','平南县',262,'P',2),(2249,'450881','桂平市',262,'G',2),(2250,'450902','玉州区',263,'Y',2),(2251,'450903','福绵区',263,'F',2),(2252,'450921','容县',263,'R',2),(2253,'450922','陆川县',263,'L',2),(2254,'450923','博白县',263,'B',2),(2255,'450924','兴业县',263,'X',2),(2256,'450981','北流市',263,'B',2),(2257,'451002','右江区',264,'Y',2),(2258,'451021','田阳县',264,'T',2),(2259,'451022','田东县',264,'T',2),(2260,'451023','平果县',264,'P',2),(2261,'451024','德保县',264,'D',2),(2262,'451025','靖西县',264,'J',2),(2263,'451026','那坡县',264,'N',2),(2264,'451027','凌云县',264,'L',2),(2265,'451028','乐业县',264,'L',2),(2266,'451029','田林县',264,'T',2),(2267,'451030','西林县',264,'X',2),(2268,'451031','隆林各族自治县',264,'L',2),(2269,'451102','八步区',265,'B',2),(2270,'451121','昭平县',265,'Z',2),(2271,'451122','钟山县',265,'Z',2),(2272,'451123','富川瑶族自治县',265,'F',2),(2273,'451202','金城江区',266,'J',2),(2274,'451221','南丹县',266,'N',2),(2275,'451222','天峨县',266,'T',2),(2276,'451223','凤山县',266,'F',2),(2277,'451224','东兰县',266,'D',2),(2278,'451225','罗城仫佬族自治县',266,'L',2),(2279,'451226','环江毛南族自治县',266,'H',2),(2280,'451227','巴马瑶族自治县',266,'B',2),(2281,'451228','都安瑶族自治县',266,'D',2),(2282,'451229','大化瑶族自治县',266,'D',2),(2283,'451281','宜州市',266,'Y',2),(2284,'451302','兴宾区',267,'X',2),(2285,'451321','忻城县',267,'X',2),(2286,'451322','象州县',267,'X',2),(2287,'451323','武宣县',267,'W',2),(2288,'451324','金秀瑶族自治县',267,'J',2),(2289,'451381','合山市',267,'H',2),(2290,'451402','江州区',268,'J',2),(2291,'451421','扶绥县',268,'F',2),(2292,'451422','宁明县',268,'N',2),(2293,'451423','龙州县',268,'L',2),(2294,'451424','大新县',268,'D',2),(2295,'451425','天等县',268,'T',2),(2296,'451481','凭祥市',268,'P',2),(2297,'460105','秀英区',269,'X',2),(2298,'460106','龙华区',269,'L',2),(2299,'460107','琼山区',269,'Q',2),(2300,'460108','美兰区',269,'M',2),(2301,'460202','海棠区',270,'H',2),(2302,'460203','吉阳区',270,'J',2),(2303,'460204','天涯区',270,'T',2),(2304,'460205','崖州区',270,'Y',2),(2305,'469001','五指山市',272,'W',2),(2306,'469002','琼海市',272,'Q',2),(2307,'469003','儋州市',272,'D',2),(2308,'469005','文昌市',272,'W',2),(2309,'469006','万宁市',272,'W',2),(2310,'469007','东方市',272,'D',2),(2311,'469021','定安县',272,'D',2),(2312,'469022','屯昌县',272,'T',2),(2313,'469023','澄迈县',272,'C',2),(2314,'469024','临高县',272,'L',2),(2315,'469025','白沙黎族自治县',272,'B',2),(2316,'469026','昌江黎族自治县',272,'C',2),(2317,'469027','乐东黎族自治县',272,'L',2),(2318,'469028','陵水黎族自治县',272,'L',2),(2319,'469029','保亭黎族苗族自治县',272,'B',2),(2320,'469030','琼中黎族苗族自治县',272,'Q',2),(2321,'500101','万州区',273,'W',2),(2322,'500102','涪陵区',273,'F',2),(2323,'500103','渝中区',273,'Y',2),(2324,'500104','大渡口区',273,'D',2),(2325,'500106','沙坪坝区',273,'S',2),(2326,'500107','九龙坡区',273,'J',2),(2327,'500108','南岸区',273,'N',2),(2328,'500109','北碚区',273,'B',2),(2329,'500110','綦江区',273,'Q',2),(2330,'500111','大足区',273,'D',2),(2331,'500112','渝北区',273,'Y',2),(2332,'500113','巴南区',273,'B',2),(2333,'500114','黔江区',273,'Q',2),(2334,'500115','长寿区',273,'C',2),(2335,'500116','江津区',273,'J',2),(2336,'500117','合川区',273,'H',2),(2337,'500118','永川区',273,'Y',2),(2338,'500119','南川区',273,'N',2),(2339,'500120','璧山区',273,'B',2),(2340,'500151','铜梁区',273,'T',2),(2341,'500223','潼南县',274,'T',2),(2342,'500226','荣昌县',274,'R',2),(2343,'500228','梁平县',274,'L',2),(2344,'500229','城口县',274,'C',2),(2345,'500230','丰都县',274,'F',2),(2346,'500231','垫江县',274,'D',2),(2347,'500232','武隆县',274,'W',2),(2348,'500233','忠县',274,'Z',2),(2349,'500234','开县',274,'K',2),(2350,'500235','云阳县',274,'Y',2),(2351,'500236','奉节县',274,'F',2),(2352,'500237','巫山县',274,'W',2),(2353,'500238','巫溪县',274,'W',2),(2354,'500240','石柱土家族自治县',274,'S',2),(2355,'500241','秀山土家族苗族自治县',274,'X',2),(2356,'500242','酉阳土家族苗族自治县',274,'Y',2),(2357,'500243','彭水苗族土家族自治县',274,'P',2),(2358,'510104','锦江区',275,'J',2),(2359,'510105','青羊区',275,'Q',2),(2360,'510106','金牛区',275,'J',2),(2361,'510107','武侯区',275,'W',2),(2362,'510108','成华区',275,'C',2),(2363,'510112','龙泉驿区',275,'L',2),(2364,'510113','青白江区',275,'Q',2),(2365,'510114','新都区',275,'X',2),(2366,'510115','温江区',275,'W',2),(2367,'510121','金堂县',275,'J',2),(2368,'510122','双流县',275,'S',2),(2369,'510124','郫县',275,'P',2),(2370,'510129','大邑县',275,'D',2),(2371,'510131','蒲江县',275,'P',2),(2372,'510132','新津县',275,'X',2),(2373,'510181','都江堰市',275,'D',2),(2374,'510182','彭州市',275,'P',2),(2375,'510183','邛崃市',275,'Q',2),(2376,'510184','崇州市',275,'C',2),(2377,'510302','自流井区',276,'Z',2),(2378,'510303','贡井区',276,'G',2),(2379,'510304','大安区',276,'D',2),(2380,'510311','沿滩区',276,'Y',2),(2381,'510321','荣县',276,'R',2),(2382,'510322','富顺县',276,'F',2),(2383,'510402','东区',277,'D',2),(2384,'510403','西区',277,'X',2),(2385,'510411','仁和区',277,'R',2),(2386,'510421','米易县',277,'M',2),(2387,'510422','盐边县',277,'Y',2),(2388,'510502','江阳区',278,'J',2),(2389,'510503','纳溪区',278,'N',2),(2390,'510504','龙马潭区',278,'L',2),(2391,'510521','泸县',278,'L',2),(2392,'510522','合江县',278,'H',2),(2393,'510524','叙永县',278,'X',2),(2394,'510525','古蔺县',278,'G',2),(2395,'510603','旌阳区',279,'J',2),(2396,'510623','中江县',279,'Z',2),(2397,'510626','罗江县',279,'L',2),(2398,'510681','广汉市',279,'G',2),(2399,'510682','什邡市',279,'S',2),(2400,'510683','绵竹市',279,'M',2),(2401,'510703','涪城区',280,'F',2),(2402,'510704','游仙区',280,'Y',2),(2403,'510722','三台县',280,'S',2),(2404,'510723','盐亭县',280,'Y',2),(2405,'510724','安县',280,'A',2),(2406,'510725','梓潼县',280,'Z',2),(2407,'510726','北川羌族自治县',280,'B',2),(2408,'510727','平武县',280,'P',2),(2409,'510781','江油市',280,'J',2),(2410,'510802','利州区',281,'L',2),(2411,'510811','昭化区',281,'Z',2),(2412,'510812','朝天区',281,'C',2),(2413,'510821','旺苍县',281,'W',2),(2414,'510822','青川县',281,'Q',2),(2415,'510823','剑阁县',281,'J',2),(2416,'510824','苍溪县',281,'C',2),(2417,'510903','船山区',282,'C',2),(2418,'510904','安居区',282,'A',2),(2419,'510921','蓬溪县',282,'P',2),(2420,'510922','射洪县',282,'S',2),(2421,'510923','大英县',282,'D',2),(2422,'511011','东兴区',283,'D',2),(2423,'511024','威远县',283,'W',2),(2424,'511025','资中县',283,'Z',2),(2425,'511028','隆昌县',283,'L',2),(2427,'511102','市中区',284,'S',2),(2428,'511111','沙湾区',284,'S',2),(2429,'511112','五通桥区',284,'W',2),(2430,'511113','金口河区',284,'J',2),(2431,'511123','犍为县',284,'J',2),(2432,'511124','井研县',284,'J',2),(2433,'511126','夹江县',284,'J',2),(2434,'511129','沐川县',284,'M',2),(2435,'511132','峨边彝族自治县',284,'E',2),(2436,'511133','马边彝族自治县',284,'M',2),(2437,'511181','峨眉山市',284,'E',2),(2438,'511302','顺庆区',285,'S',2),(2439,'511303','高坪区',285,'G',2),(2440,'511304','嘉陵区',285,'J',2),(2441,'511321','南部县',285,'N',2),(2442,'511322','营山县',285,'Y',2),(2443,'511323','蓬安县',285,'P',2),(2444,'511324','仪陇县',285,'Y',2),(2445,'511325','西充县',285,'X',2),(2446,'511381','阆中市',285,'L',2),(2447,'511402','东坡区',286,'D',2),(2448,'511421','仁寿县',286,'R',2),(2449,'511422','彭山县',286,'P',2),(2450,'511423','洪雅县',286,'H',2),(2451,'511424','丹棱县',286,'D',2),(2452,'511425','青神县',286,'Q',2),(2453,'511502','翠屏区',287,'C',2),(2454,'511503','南溪区',287,'N',2),(2455,'511521','宜宾县',287,'Y',2),(2456,'511523','江安县',287,'J',2),(2457,'511524','长宁县',287,'C',2),(2458,'511525','高县',287,'G',2),(2459,'511526','珙县',287,'G',2),(2460,'511527','筠连县',287,'J',2),(2461,'511528','兴文县',287,'X',2),(2462,'511529','屏山县',287,'P',2);
/*!40000 ALTER TABLE `sys_region` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_role`
--

DROP TABLE IF EXISTS `sys_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_role` (
  `id` bigint NOT NULL AUTO_INCREMENT COMMENT '角色ID',
  `name` varchar(30) NOT NULL COMMENT '角色名称',
  `sort` int NOT NULL DEFAULT '0' COMMENT '显示顺序',
  `scope` char(1) DEFAULT '1' COMMENT '数据范围（1：全部数据权限 2：自定数据权限）',
  `status` enum('enabled','disabled') DEFAULT 'enabled' COMMENT '角色状态（enabled 启用 disabled 禁用）',
  `remark` varchar(500) DEFAULT NULL COMMENT '备注',
  `create_by` varchar(64) DEFAULT '' COMMENT '创建者',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_by` varchar(64) DEFAULT '' COMMENT '更新者',
  `update_time` datetime DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='角色信息表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_role`
--

LOCK TABLES `sys_role` WRITE;
/*!40000 ALTER TABLE `sys_role` DISABLE KEYS */;
INSERT INTO `sys_role` VALUES (2,'管理员',2,'1','enabled','123','','2019-11-27 08:00:00','',NULL),(3,'技术总监',10,'1','enabled','CTO','','2019-11-27 08:00:00','',NULL),(4,'演示角色',8,'1','enabled','用于演示','','2020-04-24 08:00:00','',NULL);
/*!40000 ALTER TABLE `sys_role` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_role_menu`
--

DROP TABLE IF EXISTS `sys_role_menu`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_role_menu` (
  `rid` bigint NOT NULL COMMENT '角色ID',
  `mid` bigint NOT NULL COMMENT '菜单ID',
  PRIMARY KEY (`rid`,`mid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='角色和菜单关联表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_role_menu`
--

LOCK TABLES `sys_role_menu` WRITE;
/*!40000 ALTER TABLE `sys_role_menu` DISABLE KEYS */;
INSERT INTO `sys_role_menu` VALUES (2,1058),(2,1060),(2,1065),(2,1066),(2,1069),(2,1070),(2,1071),(2,1072),(2,1090),(2,1092),(2,1093),(2,1094),(2,1108),(2,1113),(2,1114),(2,1115),(2,1116),(2,1117),(2,1118),(2,1119),(2,1120),(2,1121),(2,1122),(2,1123),(2,1124),(2,1125),(2,1127),(2,1128),(2,1129),(2,1130),(2,1131),(2,1132),(2,1134),(2,1136),(2,1137),(2,1156),(2,1157),(2,1162),(2,1163),(2,1164),(2,1165),(2,1166),(2,1167),(2,1168),(2,1217),(2,1218),(2,1219),(2,1220),(2,1221),(2,1224),(2,1235),(2,1236),(2,1237),(2,1238),(2,1239),(2,1240),(2,1241),(2,1242),(2,1243),(2,1244),(2,1245),(2,1246),(2,1247),(2,1248),(2,1249),(2,1250),(2,1251),(2,1252),(2,1255),(2,1256),(2,1257),(2,1258),(2,1259),(2,1260),(2,1261),(2,1262),(2,1263),(2,1264),(2,1265),(2,1271),(2,1272),(2,1273),(2,1274),(2,1275),(2,1276),(2,1277),(2,1278),(2,1279),(2,1281),(2,1282),(2,1283),(2,1284),(2,1285),(2,1286),(2,1287),(2,1288),(2,1289),(2,1290),(2,1291),(2,1292),(2,1293),(2,1294),(2,1295),(2,1296),(2,1297),(2,1303),(2,1306),(2,1307),(2,1308),(2,1309),(2,1310),(3,1058),(3,1060),(3,1065),(3,1066),(3,1069),(3,1070),(3,1071),(3,1072),(3,1090),(3,1092),(3,1093),(3,1094),(3,1108),(3,1113),(3,1114),(3,1115),(3,1116),(3,1117),(3,1118),(3,1119),(3,1120),(3,1121),(3,1122),(3,1123),(3,1124),(3,1125),(3,1127),(3,1128),(3,1129),(3,1130),(3,1131),(3,1132),(3,1134),(3,1136),(3,1137),(3,1156),(3,1157),(3,1162),(3,1163),(3,1164),(3,1165),(3,1166),(3,1167),(3,1168),(3,1217),(3,1218),(3,1219),(3,1220),(3,1221),(3,1224),(3,1231),(3,1234),(3,1235),(3,1236),(3,1237),(3,1238),(3,1239),(3,1240),(3,1241),(3,1242),(3,1243),(3,1244),(3,1245),(3,1246),(3,1247),(3,1248),(3,1249),(3,1250),(3,1251),(3,1252),(3,1255),(3,1256),(3,1257),(3,1258),(3,1259),(3,1260),(3,1261),(3,1262),(3,1263),(3,1264),(3,1265),(3,1271),(3,1272),(3,1273),(3,1274),(3,1275),(3,1276),(3,1277),(3,1278),(3,1279),(3,1281),(3,1282),(3,1283),(3,1284),(3,1285),(3,1286),(3,1287),(3,1288),(3,1289),(3,1290),(3,1291),(3,1292),(3,1293),(3,1294),(3,1295),(3,1296),(3,1297),(3,1303),(3,1306),(3,1307),(3,1308),(3,1309),(3,1310),(4,1222),(4,1223);
/*!40000 ALTER TABLE `sys_role_menu` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vip_user`
--

DROP TABLE IF EXISTS `vip_user`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `vip_user` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `sex` enum('man','woman') DEFAULT NULL COMMENT '性别',
  `email` varchar(64) DEFAULT NULL COMMENT '邮箱',
  `phone` char(11) DEFAULT NULL COMMENT '手机号',
  `identity` char(20) DEFAULT NULL COMMENT '身份证号码',
  `account` varchar(64) DEFAULT NULL COMMENT '会员账号',
  `password` varchar(64) DEFAULT NULL COMMENT '会员密码',
  `nick_name` varchar(64) NOT NULL COMMENT '会员昵称',
  `real_name` varchar(32) DEFAULT NULL COMMENT '姓名',
  `wechat_id` varchar(32) DEFAULT NULL COMMENT '微信openId',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime DEFAULT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci COMMENT='会员';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `vip_user`
--

LOCK TABLES `vip_user` WRITE;
/*!40000 ALTER TABLE `vip_user` DISABLE KEYS */;
/*!40000 ALTER TABLE `vip_user` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2023-09-07 11:22:34
